#define USE_DL_PREFIX
#include "dlmalloc.c"

#ifdef _DEBUG
	#include "Paper.h"

	AllocList	g_AllocList;
	DWORD		g_CurrentMemUsage = 0;
	DWORD		g_dwLastMemUsagePrintTime;

	void AddTrack(DWORD dwAddress, DWORD dwSize, const char *strFile, DWORD dwLine, bool bIsNewCall, bool bIsNewArrayCall)
	{
		AllocList *curalloc = &g_AllocList;

		while(curalloc->m_pNext)
			curalloc = curalloc->m_pNext;

		curalloc->m_pNext			= (AllocList*)malloc(sizeof(AllocList));
		memset(curalloc->m_pNext, 0, sizeof(AllocList));

		curalloc->m_pNext->m_pPrev  = curalloc;
		curalloc					= curalloc->m_pNext;
		curalloc->m_dwAddress		= dwAddress;
		
		strncpy(curalloc->m_strFile, strFile, 254);
		
		curalloc->m_dwLine			= dwLine;
		curalloc->m_dwSize			= dwSize;
		curalloc->m_iIsNewed		= (int)bIsNewCall;
		curalloc->m_iIsArray		= (int)bIsNewArrayCall;

		g_CurrentMemUsage += dwSize;

		char strBuffer[1024] = {0};
		sprintf(strBuffer, "%s:\t\tLINE %d,\t\tADDRESS %d\t\t%d alloced\t\t\t\t\t%d in use\n", strFile, dwLine, dwAddress, dwSize, g_CurrentMemUsage);
		//OutputDebugString(strBuffer);

		DWORD dwCurrentTime = g_xPaperAPI.m_xPlatform.GetTime();
		if(dwCurrentTime - g_dwLastMemUsagePrintTime > 1000)
		{
			//sprintf(strBuffer, "CurrentMemoryUsage: %d\n", g_CurrentMemUsage);
			//OutputDebugString(strBuffer);

			g_dwLastMemUsagePrintTime = dwCurrentTime;
		}
	}

	void RemoveTrack(DWORD dwAddress, bool bIsDeleteCall, bool bIsDeleteArrayCall)
	{
		AllocList *prevprevalloc = NULL;
		AllocList *prevalloc = NULL;
		AllocList *curalloc = &g_AllocList;

		while(curalloc->m_pNext)
		{
			prevprevalloc = prevalloc;
			prevalloc = curalloc;
			curalloc = curalloc->m_pNext;
			if(curalloc->m_dwAddress == dwAddress)
			{
				if(curalloc->m_iIsNewed != (int)bIsDeleteCall)
					assert(0);

				if(curalloc->m_iIsArray != (int)bIsDeleteArrayCall)
					assert(0);

				g_CurrentMemUsage -= curalloc->m_dwSize;

				memset((void*)dwAddress, 0xdeadb33f, curalloc->m_dwSize);

				char strBuffer[1024] = {0};
				sprintf(strBuffer, "%s:\t\tLINE %d,\t\tADDRESS %d\t\t%d freed\t\t\t\t\t%d in use\n", curalloc->m_strFile, curalloc->m_dwLine, curalloc->m_dwAddress, curalloc->m_dwSize, g_CurrentMemUsage);
				//OutputDebugString(strBuffer);

				if(curalloc->m_pPrev)
					curalloc->m_pPrev->m_pNext = curalloc->m_pNext;

				if(curalloc->m_pNext)
					curalloc->m_pNext->m_pPrev = curalloc->m_pPrev;

				free(curalloc);

				curalloc = NULL;

				return;
			}
		}

		//REMOVE TRACK FAILED
		//assert(0);

		return;
	}

	void DumpUnfreed()
	{
		DWORD dwTotalSize = 0;
		char strBuffer[1024];

		AllocList *curalloc = &g_AllocList;

		while(curalloc->m_pNext)
		{
			curalloc = curalloc->m_pNext;

			if(curalloc->m_dwSize > 1000)
			{
				sprintf(strBuffer, "%s:\t\tLINE %d,\t\tADDRESS %d\t\t%d unfreed\n",
						curalloc->m_strFile, curalloc->m_dwLine, curalloc->m_dwAddress, curalloc->m_dwSize);
				OutputDebugString(strBuffer);
			}

			dwTotalSize += curalloc->m_dwSize;
		}

		OutputDebugString("-----------------------------------------------------------\n");
		
		sprintf(strBuffer, "Total Unfreed: %d bytes\n", dwTotalSize);
		OutputDebugString(strBuffer);
	}
#else
	void* operator new [] (size_t size)
	{
		return dlmalloc(size);
	}

	void* operator new (size_t size)
	{
		return dlmalloc(size);
	}

	void operator delete (void* ptr)
	{
		dlfree(ptr);
	}

	void operator delete[] (void* ptr)
	{
		dlfree(ptr);
	}
#endif
