#include "Paper.h"
#include "Main.h"

xPaper	g_xPaperAPI;

extern void GameInit();
extern void GamePreUpdate(DWORD dwTime);
extern void GameUpdate(double dTime);
extern void GameShutdown();

int WINAPI WinMain(HINSTANCE hinst, HINSTANCE hprevinst, LPSTR lpcmdline, int nshowcmd)
{
	xFileIO fileio;
	HWND hwnd;
	MSG msg;

#ifdef _DEBUG
	char temp[256] = "FreePlay", output[256];
	uint32_t encrypted[100] = {0};
	int i;

	//xEncryptString(temp, encrypted, PRIVATE_KEY_KEY0, PRIVATE_KEY_KEY1, PRIVATE_KEY_KEY2, PRIVATE_KEY_KEY3);
	//xDecryptString(encrypted, 4, temp, PRIVATE_KEY_KEY0, PRIVATE_KEY_KEY1, PRIVATE_KEY_KEY2, PRIVATE_KEY_KEY3);

/*	strcpy(temp, "BreakBlocks.lic");
	memset(output, 0, 255);
	memset(encrypted, 0, 400);
	xEncryptString(temp, encrypted, PRIVATE_KEY_KEY0, PRIVATE_KEY_KEY1, PRIVATE_KEY_KEY2, PRIVATE_KEY_KEY3);
	for(i = 0; i < 4; i++)
		sprintf(output, "%s, %u", output, encrypted[i]);
*/
#endif

	if(!fileio.FileExists("Settings.txt"))
	{
		fileio.OpenFile("Settings.txt", false, false);
		fileio.WriteData("\n", 1);
		fileio.CloseFile();
		strcpy(g_xPaperAPI.m_strExitCommand, "InstallOpenAL.bat");
		g_xPaperAPI.m_bRunning = false;
	}
	else
		g_xPaperAPI.Init(&hwnd, &hinst, (void*)WinProc);

	if(g_xPaperAPI.m_bRunning)
	{
		//Create Game Objects
		//Load Maps/Menus/etc.
		GameInit();

		RECT tmp;
		GetWindowRect(g_xPaperAPI.m_hWnd, &tmp);
		g_xPaperAPI.m_xInput.m_lWindowOffsetX = tmp.left + g_xPaperAPI.m_xPlatform.m_iBorderSize;
		g_xPaperAPI.m_xInput.m_lWindowOffsetY = tmp.top  + g_xPaperAPI.m_xPlatform.m_iTitleBarHeight;

		g_xPaperAPI.m_dwLastTime = g_xPaperAPI.m_xPlatform.GetTime();

		while(g_xPaperAPI.m_bRunning)
		{
			if(PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))
			{
				TranslateMessage(&msg);
				DispatchMessage(&msg);
			}
			else
			{
				GameLoop();
		
				g_xPaperAPI.m_xInput.PostUpdate();
		
				if(!g_xPaperAPI.m_bHasFocus)
					Sleep(100);
			}
		}
		
		GameShutdown();
	}

	g_xPaperAPI.Shutdown();

	if(g_xPaperAPI.m_strExitCommand[0] != '\0')
		ShellExecute(0, "open", g_xPaperAPI.m_strExitCommand, 0, 0, SW_SHOW);

#ifdef _DEBUG
	DumpUnfreed();
#endif

	return 0;
}

LRESULT CALLBACK WinProc(HWND hwnd, UINT msg, WPARAM wparam, LPARAM lparam)
{
	switch(msg)
	{
		case WM_PE_WSASYNC:
		{
			HandleAsyncNetworkMessage(&g_xPaperAPI.m_xNetwork, lparam);
			break;
		}		

		case WM_PE_HTTPASYNC:
		{
			HandleAsyncNetworkMessage(&g_xPaperAPI.m_xHTTPNetwork, lparam);
			break;
		}		

		case WM_PE_PINGASYNC:
		{
			HandleAsyncNetworkMessage(&g_xPaperAPI.m_xPingNetwork, lparam);
			break;
		}		

		case WM_PE_FTPASYNC:
		{
			HandleAsyncNetworkMessage(&g_xPaperAPI.m_xFTPNetwork, lparam);
			break;
		}		

		case WM_PE_FTPTRANSFERASYNC:
		{
			HandleAsyncNetworkMessage(&g_xPaperAPI.m_xFTPFileTransfer, lparam);
			break;
		}		

		case WM_MOVE:
		{
			RECT tmp;
			GetWindowRect(g_xPaperAPI.m_hWnd, &tmp);
			g_xPaperAPI.m_xInput.m_lWindowOffsetX = tmp.left + g_xPaperAPI.m_xPlatform.m_iBorderSize;
			g_xPaperAPI.m_xInput.m_lWindowOffsetY = tmp.top  + g_xPaperAPI.m_xPlatform.m_iTitleBarHeight;
			g_xPaperAPI.m_bDragged = true;
			return DefWindowProc(hwnd, msg, wparam, lparam);
		}

		case WM_ACTIVATE:
		{
			g_xPaperAPI.m_bHasFocus = !g_xPaperAPI.m_bMinimized && wparam;

			if(g_xPaperAPI.m_xEngineSettings.m_bFullScreen)
			{
				if(!g_xPaperAPI.m_bHasFocus)
					ShowWindow(g_xPaperAPI.m_hWnd, SW_MINIMIZE);
				else
					ShowWindow(g_xPaperAPI.m_hWnd, SW_RESTORE);
			}

			return DefWindowProc(hwnd, msg, wparam, lparam);
		}

		case WM_DESTROY:
		{
			if(!g_xPaperAPI.m_bChangingScreenResolution)
				g_xPaperAPI.m_bRunning = false;

			break;
		}

		case WM_SYSKEYDOWN:
		case WM_KEYDOWN:
		{
			if(!(HIWORD(lparam) & KF_REPEAT))
			{
				if (wparam == VK_SHIFT && (int(lparam & (0xff << 16)) >> 16) == 0x36) // Differentiate Right Shift
					g_xPaperAPI.m_xInput.HandleKeyboardKeyPressed(0xA1, true);
				else if(wparam == VK_CONTROL && (HIWORD(lparam) & KF_EXTENDED)) // Differentiate Right Control
					g_xPaperAPI.m_xInput.HandleKeyboardKeyPressed(0xA3, true);
				else if(wparam == VK_MENU && (HIWORD(lparam) & KF_EXTENDED)) // Differentiate Right Alt
					g_xPaperAPI.m_xInput.HandleKeyboardKeyPressed(0xA5, true);
				else
					g_xPaperAPI.m_xInput.HandleKeyboardKeyPressed(wparam, true);
			}

			break;
		}

		case WM_SYSKEYUP:
		case WM_KEYUP:
		{
			if (wparam == VK_SHIFT && (int(lparam & (0xff << 16)) >> 16) == 0x36) // Differentiate Right Shift
				g_xPaperAPI.m_xInput.HandleKeyboardKeyPressed(0xA1, false);
			else if(wparam == VK_CONTROL && (HIWORD(lparam) & KF_EXTENDED)) // Differentiate Right Control
				g_xPaperAPI.m_xInput.HandleKeyboardKeyPressed(0xA3, true);
			else if(wparam == VK_MENU && (HIWORD(lparam) & KF_EXTENDED)) // Differentiate Right Alt
				g_xPaperAPI.m_xInput.HandleKeyboardKeyPressed(0xA5, true);
			else
				g_xPaperAPI.m_xInput.HandleKeyboardKeyPressed(wparam, false);

			break;
		}

		case WM_LBUTTONDOWN:
		{
			g_xPaperAPI.m_xInput.HandleMouseButtonPressed(0, true);
			break;
		}

		case WM_LBUTTONUP:
		{
			g_xPaperAPI.m_xInput.HandleMouseButtonPressed(0, false);
			break;
		}

		case WM_RBUTTONDOWN:
		{
			g_xPaperAPI.m_xInput.HandleMouseButtonPressed(1, true);
			break;
		}

		case WM_RBUTTONUP:
		{
			g_xPaperAPI.m_xInput.HandleMouseButtonPressed(1, false);
			break;
		}

		case WM_MBUTTONDOWN:
		{
			g_xPaperAPI.m_xInput.HandleMouseButtonPressed(2, true);
			break;
		}

		case WM_MBUTTONUP:
		{
			g_xPaperAPI.m_xInput.HandleMouseButtonPressed(2, false);
			break;
		}

		case WM_MOUSEMOVE: 
		{
			g_xPaperAPI.m_xInput.m_lMouseX = (float)(LOWORD(lparam) - g_xPaperAPI.m_iScreenOffsetX) / g_xPaperAPI.m_fScreenRatioX;
			g_xPaperAPI.m_xInput.m_lMouseY = (float)(HIWORD(lparam) - g_xPaperAPI.m_iScreenOffsetY) / g_xPaperAPI.m_fScreenRatioY;
			break;
		}

		case WM_SIZE:
		{
			g_xPaperAPI.m_bMinimized = wparam == SIZE_MINIMIZED;
			g_xPaperAPI.m_bHasFocus = !g_xPaperAPI.m_bMinimized;
			return DefWindowProc(hwnd, msg, wparam, lparam);
		}

		//Let Windows handle it, b/c we dont do anything with it
		default:
			return DefWindowProc(hwnd, msg, wparam, lparam);
	}
	return 0;
}

void GameLoop()
{
	if(g_xPaperAPI.m_bHasFocus || g_xPaperAPI.m_iNetMode != PE_NETMODE_SINGLEPLAYER)
	{
		g_xPaperAPI.PreUpdate();
		GamePreUpdate(g_xPaperAPI.m_dwCurrentTime);
	}

	GameUpdate((double)(g_xPaperAPI.m_dwCurrentTime - g_xPaperAPI.m_dwLastTime) * 0.001);

	g_xPaperAPI.Update(); //Updates GameTime and Renders/Flips Screen
}

void HandleAsyncNetworkMessage(xNetworkClient* pNetwork, DWORD lparam)
{
	switch(WSAGETSELECTEVENT(lparam))
	{
		case FD_CONNECT:
		{
			pNetwork->SetConnected(true);
			break;
		}

		case FD_READ:
		{
			if(int retvalu = WSAGETSELECTERROR(lparam))
			{
				if(retvalu != 0 && retvalu != 10035)
				{
					return;
				}
			}

			pNetwork->Read();
			break;
		}

		case FD_WRITE:
		{
			if(int retvalu = WSAGETSELECTERROR(lparam))
			{
				if(retvalu != 0 && retvalu != 10035)
				{
					return;
				}
			}

			pNetwork->SetWritable(true);
			break;
		}

		case FD_ACCEPT:
		{
			if(int retvalu = WSAGETSELECTERROR(lparam))
			{
				if(retvalu != 0 && retvalu != 10035)
				{
					return;
				}
			}

			if(!pNetwork->Accept())
				pNetwork->SetConnected(true);

			break;
		}

		case FD_CLOSE:
		{
			pNetwork->Close();
			break;
		}
	}
}
