/////////////////////////////////////////////////////////////////
// Name: xArrowManager.h
/////////////////////////////////////////////////////////////////
// Description:
// - Contains and controls all Arrows on the screen.
/////////////////////////////////////////////////////////////////
// - 7.15.2004, Update, Dayle Flowers(Xienen)
//   File Created
/////////////////////////////////////////////////////////////////
#ifndef XARROWMANAGER_H_
#define XARROWMANAGER_H_

#include "xArrow.h"

#define BB_MAXARROWSONSCREEN	30
#define BB_ARROWTARGETX			875
#define BB_ARROWTARGETY			676
#define BB_ARROWTARGETSPACING	112

class xArrowManager
{
public:
	xArrowManager()
	{
		m_iArrowsLoaded			= 0;
		m_bInitialized			= false;
		m_pCurArrow				= NULL;
		m_dCurHitTime			= 0.0;
		m_bAddedBlockAlready	= false;
		m_dwSongStartTime		= 0;
		m_pCurArrowObject		= NULL;
		m_iComboCount			= 0;
		m_iOldComboCount		= -1;
		m_bMissedArrow			= false;
	}

	bool Update(double dTime);
	void Shutdown();

	bool HitArrow(xDir iDir, DWORD dwTime);
	bool AddArrow(xDir iDir, DWORD dwArrowTime);

	DWORD	m_dwSongStartTime;
	int		m_iComboCount;
	int		m_iOldComboCount;
	bool	m_bMissedArrow;
private:
	int			 m_iArrowsLoaded;
	bool		 m_bInitialized;
	xArrow		 ;
	xArrow		 *m_pCurArrow;
	xArrow		 *m_pNewestArrow;
	xArrowObject m_xArrowObjects;
	xArrowObject *m_pCurArrowObject;
	double		 m_dCurHitTime;
};

#endif