/////////////////////////////////////////////////////////////////
// Name: xColor.h
/////////////////////////////////////////////////////////////////
// Description:
// - Structure to 
/////////////////////////////////////////////////////////////////
// - 12.08.2009, Dayle Flowers(Xienen)
//   File Created
/////////////////////////////////////////////////////////////////
#ifndef XCOLOR_H_
#define XCOLOR_H_

#include "xEngineDefines.h"

struct xColor
{
	float R, G, B, A;
};

FORCE_INLINE xColor* xColorInit(xColor *pThis)
{
	pThis->R = 1.0;
	pThis->G = 1.0;
	pThis->B = 1.0;
	pThis->A = 1.0;

	return pThis;
}

FORCE_INLINE xColor* xColorInit(xColor *pThis, float fR, float fG, float fB, float fA)
{
	pThis->R = fR;
	pThis->G = fG;
	pThis->B = fB;
	pThis->A = fA;

	return pThis;
}

FORCE_INLINE void xColorCopy(xColor *pDest, const xColor *pSource)
{
	pDest->R = pSource->R;
	pDest->G = pSource->G;
	pDest->B = pSource->B;
	pDest->A = pSource->A;
}

FORCE_INLINE xColor* xColorMultiply(xColor *pDest, const xColor *pLeft, const xColor *pRight)
{
	pDest->R = pLeft->R * pRight->R;
	pDest->G = pLeft->G * pRight->G;
	pDest->B = pLeft->B * pRight->B;
	pDest->A = pLeft->A * pRight->A;

	return pDest;
}

#endif