#ifndef XENGINEDEFINES_H_
#define XENGINEDEFINES_H_

//#define __FRAGSHADER_NOARB

#define FORCE_INLINE	__forceinline	//__attribute__((always_inline))

#define PI 3.1415926536

// Shader Parameter Index Defines
#define	PE_SHADERPARAM_ALPHA_GREYSCALE		0
#define	PE_SHADERPARAM_MASKED_TEXTUREOFFSET	0
#define	PE_SHADERPARAM_MASKED_TEXTURERATIO	1
#define	PE_SHADERPARAM_MASKED_GREYSCALE		2
#define	PE_SHADERPARAM_2COLOR_COLOR2		0
#define	PE_SHADERPARAM_2COLOR_COLORDIFF		1
#define	PE_SHADERPARAM_2COLOR_GREYSCALE		2

#ifdef _WIN32
typedef	__int16				int16;
typedef	unsigned __int8		uint8_t;
typedef	unsigned __int16	uint16_t;
typedef	unsigned __int32	uint32_t;
#endif

#define PE_UINT16_UPPER8BITS	0xff00
#define PE_UINT16_LOWER8BITS	0x00ff

enum xBlendModes
{
	PE_BLEND_MODE_ALPHA = 0,
	PE_BLEND_MODE_ALPHA_NOSHADER,
	PE_BLEND_MODE_INVERTED_COLOR,
	PE_BLEND_MODE_MASKED,
	PE_BLEND_MODE_2COLOR,
	PE_BLEND_MODE_NONE_OUTLINED,
	PE_BLEND_MODE_NONE
};

extern "C"
{
	// Make sure the dlmalloc/dlfree calls are available to all classes
	void* dlmalloc(size_t);
	void  dlfree(void*);
}

#ifdef _DEBUG
	#define dlmalloc(x)	mymalloc(x, __FILE__, __LINE__)
	#define dlfree		myfree
#endif

#ifndef FINAL_RELEASE
	extern class xFileIO g_xLog;
	#define DEBUGCHECK(x)	if(x) assert(0);
	#define CREATELOG()		if(!g_xLog.IsOpen()) { if(g_xPaperAPI.m_iNetMode == PE_NETMODE_LISTENSERVER) g_xLog.OpenFile("ServerLog.txt", false, false); else g_xLog.OpenFile("ClientLog.txt", false, false); }
	#define	LOG(x)			if(g_xLog.IsOpen()) g_xLog.WriteString(x);
	#define	LOG(...)		if(g_xLog.IsOpen()) { char temp[10240]; sprintf(temp, __VA_ARGS__); g_xLog.WriteString(temp); }
	#define	DEBUGLOG(x)		OutputDebugString(x);
	#define	DEBUGLOG(...)	{ char temp[10240]; sprintf(temp, __VA_ARGS__); OutputDebugString(temp); }
#else
	#define DEBUGCHECK(x)	NULL
	#define CREATELOG()		NULL
	#define LOG(x)			NULL
	#define	LOG(...)		NULL
	#define	DEBUGLOG(x)		NULL
	#define	DEBUGLOG(...)	NULL
#endif

#endif