#include "peGame.h"

FORCE_INLINE void UpdateDroppingPiece(xField *pField);

float g_fRingDistances[BB_FIELDHEIGHT] = {125, 147, 173, 204, 239, 282};

bool xField::Init()
{
	char tempstring[256], tempstring2[256];
	xTexture *temptexture, *glowtexture = 0, **textures;
	float centerx, centery, fx, fy, halfwidth, halfheight, rotation;
	float fullglowscalex, fullglowscaley, glowscalex, glowscaley;
	int x, y, i;

	m_iClearableBlockCount = 0;
	m_fRotationTime = BB_FIELD_ROTATETIME;
	m_iCurrentPlaceTail = 0;

	for(i = 0; i < 9; i++)
	{
		m_iShadowPieceX[i] = 0;
		m_iShadowPieceY[i] = 0;
	}

	if(!m_pBackgroundObject)
	{
		m_pBackgroundObject = xSceneGraphCreateQuad(BB_IMAGE_PLAYAREABACKGROUND, 0);
		xSceneGraphInsertQuad(&g_xGame.m_xSceneGraph, m_pBackgroundObject, 1, BB_DEPTH_FIELDBACKGROUND);
		xRenderable2DQuadSetPosition(m_pBackgroundObject, BB_FIELDX, BB_FIELDY);
		xRenderable2DQuadUpdate(m_pBackgroundObject);

		m_pBuildOverlay = xSceneGraphCreateQuad(BB_IMAGE_BUILDOVERLAY, 0);
		xSceneGraphInsertQuad(&g_xGame.m_xSceneGraph, m_pBuildOverlay, 1, BB_DEPTH_BUILDOVERLAY);
		xRenderable2DQuadSetPosition(m_pBuildOverlay, BB_FIELDX + BB_BUILDOVERLAYX, BB_FIELDY + BB_BUILDOVERLAYY);
		xRenderable2DQuadUpdate(m_pBuildOverlay);

		m_pPlacementFailureWarning = xSceneGraphCreateQuad(BB_IMAGE_BLOCKPLACEFAILWARNING, 0);
		xSceneGraphInsertQuad(&g_xGame.m_xSceneGraph, m_pPlacementFailureWarning, 1, BB_DEPTH_BLOCKPLACEFAILWARNING);
		xRenderable2DQuadSetPosition(m_pPlacementFailureWarning, BB_FIELDX + BB_PLACEFAILWARNINGX, BB_FIELDY + BB_PLACEFAILWARNINGY);
		xRenderable2DQuadUpdate(m_pPlacementFailureWarning);

		centerx = BB_FIELDX + m_pBackgroundObject->m_xRenderable2D.m_fWidth / 2.0;
		centery = BB_FIELDY + m_pBackgroundObject->m_xRenderable2D.m_fHeight / 2.0;

		for(y = BB_FIELDHEIGHT - 1; y >= 0; y--)
		{
			sprintf(tempstring, BB_IMAGE_BLOCKS, y + 1);
			sprintf(tempstring2, BB_IMAGE_BLOCKSOVERLAY, y + 1);

			temptexture = xGraphicsGetTexture(tempstring, 0);
			halfwidth = (float)temptexture->m_iWidth / 2.0;
			halfheight = (float)temptexture->m_iHeight / 2.0;

			if(!glowtexture)
			{
				glowtexture = xGraphicsGetTexture(BB_IMAGE_BLOCKSGLOW, 0);

				fullglowscalex = (float)glowtexture->m_iWidth / (float)temptexture->m_iWidth;
				fullglowscaley = (float)glowtexture->m_iHeight / (float)temptexture->m_iHeight;
			}
			
			glowscalex = (float)glowtexture->m_iWidth / ((float)temptexture->m_iWidth * fullglowscalex);
			glowscaley = (float)glowtexture->m_iHeight / ((float)temptexture->m_iHeight * fullglowscaley);

			xGraphicsGetTextures(tempstring, &textures);

			rotation = 0;

			m_pBlockAnimationObject[y] = xSceneGraphCreateQuad(BB_IMAGE_BLOCKSANIMATION, 0);
			xSceneGraphInsertQuad(&g_xGame.m_xSceneGraph, m_pBlockAnimationObject[y], 1, BB_DEPTH_FIELDBLOCKOVERLAY, 0, 0);
			xRenderable2DQuadSetSize(m_pBlockAnimationObject[y], m_pBlockAnimationObject[y]->m_xRenderable2D.m_fWidth / glowscalex, m_pBlockAnimationObject[y]->m_xRenderable2D.m_fHeight / glowscaley);
			xRenderable2DQuadUpdateVisibility(m_pBlockAnimationObject[y], false);
			xRenderable2DQuadUpdate(m_pBlockAnimationObject[y]);

			for(x = 0; x < BB_FIELDWIDTH; x++)
			{
				m_pFieldBlocks[x][y].m_bClearable = 0;
				m_pFieldBlocks[x][y].m_iNewColorIndex = -1;

				fx = centerx + cos(rotation) * g_fRingDistances[y];
				fy = centery - sin(rotation) * g_fRingDistances[y];

				m_pFieldBlocks[x][y].m_pBlockObject = xSceneGraphCreateQuad(tempstring, 0);
				xSceneGraphInsertQuad(&g_xGame.m_xSceneGraph, m_pFieldBlocks[x][y].m_pBlockObject, 1, BB_DEPTH_FIELDBLOCKS, 0, 1);
				xRenderable2DQuadSetPosition(m_pFieldBlocks[x][y].m_pBlockObject, fx - halfwidth, fy - halfheight);
				xRenderable2DQuadSetRotation(m_pFieldBlocks[x][y].m_pBlockObject, 90 + -rotation * (180.0f / PI));
				xRenderable2DQuadUpdateVisibility(m_pFieldBlocks[x][y].m_pBlockObject, false);
				xRenderable2DQuadUpdate(m_pFieldBlocks[x][y].m_pBlockObject);

				m_pFieldBlocks[x][y].m_pBlockGlowObject = xSceneGraphCreateQuad(glowtexture);
				xSceneGraphInsertQuad(&g_xGame.m_xSceneGraph, m_pFieldBlocks[x][y].m_pBlockGlowObject, 1, BB_DEPTH_FIELDBLOCKGLOW, 0, 0);
				xRenderable2DQuadSetPosition(m_pFieldBlocks[x][y].m_pBlockGlowObject, m_pFieldBlocks[x][y].m_pBlockObject->m_xRenderable2D.m_fX - 24.0f / glowscalex, m_pFieldBlocks[x][y].m_pBlockObject->m_xRenderable2D.m_fY - 24.0f / glowscaley);
				xRenderable2DQuadSetRotation(m_pFieldBlocks[x][y].m_pBlockGlowObject, m_pFieldBlocks[x][y].m_pBlockObject->m_xRenderable2D.m_fRotation);
				xRenderable2DQuadSetSize(m_pFieldBlocks[x][y].m_pBlockGlowObject, m_pFieldBlocks[x][y].m_pBlockGlowObject->m_xRenderable2D.m_fWidth / glowscalex, m_pFieldBlocks[x][y].m_pBlockGlowObject->m_xRenderable2D.m_fHeight / glowscaley);
				xRenderable2DQuadUpdateVisibility(m_pFieldBlocks[x][y].m_pBlockGlowObject, false);
				xRenderable2DQuadUpdate(m_pFieldBlocks[x][y].m_pBlockGlowObject);

				m_pFieldBlocks[x][y].m_pBlockOverlayObject = xSceneGraphCreateQuad(tempstring2, 0);
				xSceneGraphInsertQuad(&g_xGame.m_xSceneGraph, m_pFieldBlocks[x][y].m_pBlockOverlayObject, 1, BB_DEPTH_FIELDBLOCKOVERLAY, 0, 0);
				xRenderable2DQuadSetPosition(m_pFieldBlocks[x][y].m_pBlockOverlayObject, m_pFieldBlocks[x][y].m_pBlockObject->m_xRenderable2D.m_fX, m_pFieldBlocks[x][y].m_pBlockObject->m_xRenderable2D.m_fY);
				xRenderable2DQuadSetRotation(m_pFieldBlocks[x][y].m_pBlockOverlayObject, m_pFieldBlocks[x][y].m_pBlockObject->m_xRenderable2D.m_fRotation);
				xRenderable2DQuadUpdateVisibility(m_pFieldBlocks[x][y].m_pBlockOverlayObject, false);
				xRenderable2DQuadUpdate(m_pFieldBlocks[x][y].m_pBlockOverlayObject);
				m_pFieldBlocks[x][y].m_pBlockObject->m_fAnimationTime = BB_FIELD_UNFLASHWHITE + 0.1;

				m_pFieldBlocks[x][y].m_pBlockTexture = textures[0];
				m_pFieldBlocks[x][y].m_pShadowTexture = textures[1];

				rotation += (2 * PI) / BB_FIELDWIDTH;
			}
		}

		for(y = 0; y < BB_FIELDHEIGHT; y++)
		{
			for(x = 0; x < BB_FIELDWIDTH / 2; x++)
			{
				m_pRotateTails[x][y] = xSceneGraphCreateQuad(BB_IMAGE_BLOCKROTATIONTAIL, 0);
				xSceneGraphInsertQuad(&g_xGame.m_xSceneGraph, m_pRotateTails[x][y], 1, BB_DEPTH_FIELDBLOCKROTATETAIL, 0, 1);
				xRenderable2DQuadSetSize(m_pRotateTails[x][y], m_pFieldBlocks[0][y].m_pBlockObject->m_xRenderable2D.m_fWidth, m_pFieldBlocks[0][y].m_pBlockObject->m_xRenderable2D.m_fHeight);
				xRenderable2DQuadUpdateVisibility(m_pRotateTails[x][y], false);
			}
		}

		for(i = 0; i < BB_PLACETAILS_MAX; i++)
		{
			m_pPlaceTails[i] = xSceneGraphCreateQuad(BB_IMAGE_BLOCKPLACETAIL, 0);
			xSceneGraphInsertQuad(&g_xGame.m_xSceneGraph, m_pPlaceTails[i], 1, BB_DEPTH_FIELDBLOCKROTATETAIL, 0, 1);
			xRenderable2DQuadUpdateVisibility(m_pPlaceTails[i], 0);
		}
	}
	else
	{
		for(y = 0; y < BB_FIELDHEIGHT; y++)
		{
			for(x = 0; x < BB_FIELDWIDTH; x++)
			{
				m_pFieldBlocks[x][y].m_bClearable = 0;
				m_pFieldBlocks[x][y].m_iColorIndex = -1;
				m_pFieldBlocks[x][y].m_iUnfilledColorIndex = -1;
				m_pFieldBlocks[x][y].m_iNewColorIndex = -1;
				xRenderable2DQuadUpdateVisibility(m_pFieldBlocks[x][y].m_pBlockObject, 0);
				xRenderable2DQuadUpdateVisibility(m_pFieldBlocks[x][y].m_pBlockGlowObject, 0);
				xRenderable2DQuadUpdateVisibility(m_pFieldBlocks[x][y].m_pBlockOverlayObject, 0);
			}
		}

		for(i = 0; i < BB_PLACETAILS_MAX; i++)
			xRenderable2DQuadUpdateVisibility(m_pPlaceTails[i], 0);
	}

	xRenderable2DQuadUpdateColor(m_pBuildOverlay, &g_colFilledBlockColors[g_xGame.m_xPlayer.m_xPiece.m_iColorIndex]);

	xEmitterList *emitter = m_xBlockClearedEmitters.m_pNext;
	while(emitter)
	{
		if(emitter->m_pNext)
			emitter->m_pNext->m_pPrev = emitter->m_pPrev;

		if(emitter->m_pPrev)
			emitter->m_pPrev->m_pNext = emitter->m_pNext;

		xEmitterList *temp = emitter;
		emitter = emitter->m_pNext;

		temp->m_pData->Delete();
		delete temp->m_pData;
		delete temp;
	}

	NewPiece();

	return true;
}

bool xField::Update(double dTime)
{
	const xColor *tempcolor, *newtempcolor;
	xColor tempcolor2;
	float centerx, centery, fx, fy, halfwidth, halfheight, tempfloat, glowscalex, glowscaley;
	int tempint, oldframe, i, j;

	if(!g_xGame.m_bPaused && !g_xGame.m_bCountdown)
	{
		//check if an arrow was missed
		//if(g_xGameOptions.m_bCombosRequired && g_xGame.m_xPlayer.m_xPiece.m_bMissedCombo)

		//DEBUGLOG("%f %u %u %f %f %u %u %f %f\n", g_xGame.m_dCurBeatTime, g_xPaperAPI.m_dwCurrentTime, g_xGame.m_dwGameStartTime, (double)g_xPaperAPI.m_dwCurrentTime - (double)g_xGame.m_dwGameStartTime, ((double)g_xPaperAPI.m_dwCurrentTime - (double)g_xGame.m_dwGameStartTime) - (double)g_xGameOptions.m_dwStartOffset, m_dwLastPiecePushDownTime, g_xGameOptions.m_dwStartOffset, ((((double)g_xPaperAPI.m_dwCurrentTime - (double)g_xGame.m_dwGameStartTime) - (double)g_xGameOptions.m_dwStartOffset) - (double)m_dwLastPiecePushDownTime), m_dPiecePushDownInterval);
		if(g_xGame.m_xPlayer.m_xPiece.m_bDropping)
			UpdateDroppingPiece(this);
		else
			g_xGame.m_xPlayer.m_xPiece.Update(dTime, true);
	}
	else
		g_xGame.m_xPlayer.m_xPiece.Update(dTime, true);

	if(g_xGame.m_xPlayer.m_xPiece.m_dwCurTime > 200 && g_xGame.m_xPlayer.m_xPiece.m_iUnfilled)
	{
		tempcolor = &g_colUnfilledBlockColors[g_xGame.m_xPlayer.m_xPiece.m_iColorIndex];
		xRenderable2DQuadUpdateColor(m_pBuildOverlay, xColorInit(&tempcolor2,
																 tempcolor->R + (1.0f - tempcolor->R) * g_xGame.m_fBeatPercentage,
																 tempcolor->G + (1.0f - tempcolor->G) * g_xGame.m_fBeatPercentage,
																 tempcolor->B + (1.0f - tempcolor->B) * g_xGame.m_fBeatPercentage,
																 1.0f));
	}
	else
		xRenderable2DQuadUpdateColor(m_pBuildOverlay, &g_colUnfilledBlockColors[g_xGame.m_xPlayer.m_xPiece.m_iColorIndex]);

	xEmitterList *emitter = m_xBlockClearedEmitters.m_pNext;
	while(emitter)
	{
		emitter->m_pData->Update(dTime);

		if(emitter->m_pData->m_dLifeTime > BB_TIME_BLOCKCLEAREDEMITTER)
		{
			emitter->m_pData->Kill();

			if(emitter->m_pData->IsDone())
			{
				if(emitter->m_pNext)
					emitter->m_pNext->m_pPrev = emitter->m_pPrev;

				if(emitter->m_pPrev)
					emitter->m_pPrev->m_pNext = emitter->m_pNext;

				xEmitterList *temp = emitter;
				emitter = emitter->m_pNext;

				temp->m_pData->Delete();
				delete temp->m_pData;
				delete temp;
			}
			else
				emitter = emitter->m_pNext;
		}
		else
			emitter = emitter->m_pNext;
	}

	//if(!m_xPiecePlacedEmitter.IsDone())
	//	m_xPiecePlacedEmitter.Update(dTime);

	centerx = BB_FIELDX + m_pBackgroundObject->m_xRenderable2D.m_fWidth / 2.0;
	centery = BB_FIELDY + m_pBackgroundObject->m_xRenderable2D.m_fHeight / 2.0;

	if(m_fRotationTime < BB_FIELD_ROTATETIME)
	{
		m_fRotationTime += dTime;

		if(m_fRotationTime >= BB_FIELD_ROTATETIME)
		{
			ForceFinishRotation();
		}
	}

	for(i = 0; i < BB_FIELDHEIGHT; i++)
	{
		if(m_pBlockAnimationObject[i]->m_xRenderable2D.m_bVisible)
		{
			oldframe = m_pBlockAnimationObject[i]->m_iCurrentTexture;

			xRenderable2DQuadUpdateAnimation(m_pBlockAnimationObject[i], dTime);

			if(m_pBlockAnimationObject[i]->m_iCurrentTexture < oldframe)
				xRenderable2DQuadUpdateVisibility(m_pBlockAnimationObject[i], false);
		}
		else
		{
			for(j = 0; j < BB_FIELDWIDTH; j++)
			{
				if(m_pFieldBlocks[j][i].m_iColorIndex >= 0 && rand() < RAND_MAX / 8192)
				{
					m_pBlockAnimationObject[i]->m_fAnimationTime = 0;
					m_pBlockAnimationObject[i]->m_iCurrentTexture = 0;

					xRenderable2DQuadSetPosition(m_pBlockAnimationObject[i], m_pFieldBlocks[j][i].m_pBlockObject->m_xRenderable2D.m_fX, m_pFieldBlocks[j][i].m_pBlockObject->m_xRenderable2D.m_fY);
					xRenderable2DQuadSetRotation(m_pBlockAnimationObject[i], m_pFieldBlocks[j][i].m_pBlockObject->m_xRenderable2D.m_fRotation);
					xRenderable2DQuadUpdateVisibility(m_pBlockAnimationObject[i], true);
					xRenderable2DQuadUpdate(m_pBlockAnimationObject[i]);
					break;
				}
			}
		}

		halfwidth = (float)m_pFieldBlocks[0][i].m_pBlockTexture->m_iWidth / 2.0;
		halfheight = (float)m_pFieldBlocks[0][i].m_pBlockTexture->m_iHeight / 2.0;

		glowscalex = (float)m_pFieldBlocks[0][i].m_pBlockObject->m_xRenderable2D.m_fWidth / (float)m_pFieldBlocks[0][5].m_pBlockObject->m_xRenderable2D.m_fWidth;
		glowscaley = (float)m_pFieldBlocks[0][i].m_pBlockObject->m_xRenderable2D.m_fHeight / (float)m_pFieldBlocks[0][5].m_pBlockObject->m_xRenderable2D.m_fHeight;

		for(j = 0; j < BB_FIELDWIDTH; j++)
		{
			if(m_fRotationTime < BB_FIELD_ROTATETIME)
			{
				DEBUGSHADOWPIECE("Updating Rotating Field\n");
				xRenderable2DQuadUpdateVisibility(m_pBlockAnimationObject[i], false);

				if(m_pFieldBlocks[j][i].m_iColorIndex >= 0)
				{
					tempfloat = (2.0f * PI * m_fRotationTime * m_fRotationTime * m_fRotationTime * m_fRotationTime * m_fRotationTime * m_fRotationTime) / (BB_FIELDWIDTH * BB_FIELD_ROTATETIME * BB_FIELD_ROTATETIME * BB_FIELD_ROTATETIME * BB_FIELD_ROTATETIME * BB_FIELD_ROTATETIME * BB_FIELD_ROTATETIME);
					//tempfloat = (2.0f * PI * m_fRotationTime) / (BB_FIELDWIDTH * BB_FIELD_ROTATETIME);

					if(m_bRotateClockwise)
						tempfloat = ((float)j + 1.0f) * ((2.0f * PI) / BB_FIELDWIDTH) - tempfloat;
					else
						tempfloat = ((float)j - 1.0f) * ((2.0f * PI) / BB_FIELDWIDTH) + tempfloat;

					fx = centerx + cos(tempfloat) * g_fRingDistances[i];
					fy = centery - sin(tempfloat) * g_fRingDistances[i];

					xRenderable2DQuadSetPosition(m_pFieldBlocks[j][i].m_pBlockObject, fx - halfwidth, fy - halfheight);
					xRenderable2DQuadSetRotation(m_pFieldBlocks[j][i].m_pBlockObject, 90 + -tempfloat * (180.0f / PI));
					xRenderable2DQuadUpdate(m_pFieldBlocks[j][i].m_pBlockObject);

					xRenderable2DQuadSetPosition(m_pFieldBlocks[j][i].m_pBlockGlowObject, m_pFieldBlocks[j][i].m_pBlockObject->m_xRenderable2D.m_fX - 24.0f * glowscalex, m_pFieldBlocks[j][i].m_pBlockObject->m_xRenderable2D.m_fY - 24.0f * glowscaley);
					xRenderable2DQuadSetRotation(m_pFieldBlocks[j][i].m_pBlockGlowObject, m_pFieldBlocks[j][i].m_pBlockObject->m_xRenderable2D.m_fRotation);
					xRenderable2DQuadUpdate(m_pFieldBlocks[j][i].m_pBlockGlowObject);

					xRenderable2DQuadSetPosition(m_pFieldBlocks[j][i].m_pBlockOverlayObject, m_pFieldBlocks[j][i].m_pBlockObject->m_xRenderable2D.m_fX, m_pFieldBlocks[j][i].m_pBlockObject->m_xRenderable2D.m_fY);
					xRenderable2DQuadSetRotation(m_pFieldBlocks[j][i].m_pBlockOverlayObject, m_pFieldBlocks[j][i].m_pBlockObject->m_xRenderable2D.m_fRotation);
					xRenderable2DQuadUpdate(m_pFieldBlocks[j][i].m_pBlockOverlayObject);

					xRenderable2DQuadUpdateColor(m_pFieldBlocks[j][i].m_pBlockObject, &g_colFilledBlockColors[m_pFieldBlocks[j][i].m_iColorIndex]);
				}
			}
			else if(m_pFieldBlocks[j][i].m_iNewColorIndex != -1 && m_pFieldBlocks[j][i].m_iNewColorIndex != m_pFieldBlocks[j][i].m_iColorIndex)
			{
				tempint = g_xPaperAPI.m_dwCurrentTime - m_pFieldBlocks[j][i].m_dwColorAnimStartTime;

				if(tempint >= BB_FIELD_COLORTRANS_TOTAL)
				{
					xRenderable2DQuadUpdateColor(m_pFieldBlocks[j][i].m_pBlockObject, &g_colFilledBlockColors[m_pFieldBlocks[j][i].m_iNewColorIndex]);
					xRenderable2DQuadUpdateAlpha(m_pFieldBlocks[j][i].m_pBlockGlowObject, 0.0f);
					m_pFieldBlocks[j][i].m_iColorIndex = m_pFieldBlocks[j][i].m_iNewColorIndex;
					m_pFieldBlocks[j][i].m_iNewColorIndex = -1;
					UpdateGlowAlphas(0);
				}
				else
				{
					if(tempint <= BB_FIELD_COLORTRANS_1ST || (tempint <= BB_FIELD_COLORTRANS_2ND && tempint > BB_FIELD_COLORTRANS_UN1ST) ||
						(tempint <= BB_FIELD_COLORTRANS_3RD && tempint > BB_FIELD_COLORTRANS_UN2ND) ||
						(tempint <= BB_FIELD_COLORTRANS_4TH && tempint > BB_FIELD_COLORTRANS_UN3RD) ||
						(tempint <= BB_FIELD_COLORTRANS_5TH && tempint > BB_FIELD_COLORTRANS_UN4TH) ||
						(tempint <= BB_FIELD_COLORTRANS_6TH && tempint > BB_FIELD_COLORTRANS_UN5TH) ||
						(tempint <= BB_FIELD_COLORTRANS_7TH && tempint > BB_FIELD_COLORTRANS_UN6TH) ||
						(tempint <= BB_FIELD_COLORTRANS_8TH && tempint > BB_FIELD_COLORTRANS_UN7TH) ||
						(tempint <= BB_FIELD_COLORTRANS_9TH && tempint > BB_FIELD_COLORTRANS_UN8TH) ||
						(tempint <= BB_FIELD_COLORTRANS_10TH && tempint > BB_FIELD_COLORTRANS_UN9TH))
					{
						tempcolor = &g_colFilledBlockColors[m_pFieldBlocks[j][i].m_iColorIndex];
						newtempcolor = &g_colFilledBlockColors[m_pFieldBlocks[j][i].m_iNewColorIndex];

						if(tempint <= BB_FIELD_COLORTRANS_1ST)
							tempfloat = ((float)(tempint)) / BB_FIELD_COLORTRANS_1ST;
						else if(tempint <= BB_FIELD_COLORTRANS_2ND)
							tempfloat = ((float)(tempint - BB_FIELD_COLORTRANS_UN1ST)) / (BB_FIELD_COLORTRANS_2ND - BB_FIELD_COLORTRANS_UN1ST);
						else if(tempint <= BB_FIELD_COLORTRANS_3RD)
							tempfloat = ((float)(tempint - BB_FIELD_COLORTRANS_UN2ND)) / (BB_FIELD_COLORTRANS_3RD - BB_FIELD_COLORTRANS_UN2ND);
						else if(tempint <= BB_FIELD_COLORTRANS_4TH)
							tempfloat = ((float)(tempint - BB_FIELD_COLORTRANS_UN3RD)) / (BB_FIELD_COLORTRANS_4TH - BB_FIELD_COLORTRANS_UN3RD);
						else if(tempint <= BB_FIELD_COLORTRANS_5TH)
							tempfloat = ((float)(tempint - BB_FIELD_COLORTRANS_UN4TH)) / (BB_FIELD_COLORTRANS_5TH - BB_FIELD_COLORTRANS_UN4TH);
						else if(tempint <= BB_FIELD_COLORTRANS_6TH)
							tempfloat = ((float)(tempint - BB_FIELD_COLORTRANS_UN5TH)) / (BB_FIELD_COLORTRANS_6TH - BB_FIELD_COLORTRANS_UN5TH);
						else if(tempint <= BB_FIELD_COLORTRANS_7TH)
							tempfloat = ((float)(tempint - BB_FIELD_COLORTRANS_UN6TH)) / (BB_FIELD_COLORTRANS_7TH - BB_FIELD_COLORTRANS_UN6TH);
						else if(tempint <= BB_FIELD_COLORTRANS_8TH)
							tempfloat = ((float)(tempint - BB_FIELD_COLORTRANS_UN7TH)) / (BB_FIELD_COLORTRANS_8TH - BB_FIELD_COLORTRANS_UN7TH);
						else if(tempint <= BB_FIELD_COLORTRANS_9TH)
							tempfloat = ((float)(tempint - BB_FIELD_COLORTRANS_UN8TH)) / (BB_FIELD_COLORTRANS_9TH - BB_FIELD_COLORTRANS_UN8TH);
						else if(tempint <= BB_FIELD_COLORTRANS_10TH)
							tempfloat = ((float)(tempint - BB_FIELD_COLORTRANS_UN9TH)) / (BB_FIELD_COLORTRANS_10TH - BB_FIELD_COLORTRANS_UN9TH);
					}
					else
					{
						tempcolor = &g_colFilledBlockColors[m_pFieldBlocks[j][i].m_iNewColorIndex];
						newtempcolor = &g_colFilledBlockColors[m_pFieldBlocks[j][i].m_iColorIndex];

						if(tempint <= BB_FIELD_COLORTRANS_UN1ST)
							tempfloat = ((float)(tempint - BB_FIELD_COLORTRANS_1ST)) / (BB_FIELD_COLORTRANS_UN1ST - BB_FIELD_COLORTRANS_1ST);
						else if(tempint <= BB_FIELD_COLORTRANS_UN2ND)
							tempfloat = ((float)(tempint - BB_FIELD_COLORTRANS_2ND)) / (BB_FIELD_COLORTRANS_UN2ND - BB_FIELD_COLORTRANS_2ND);
						else if(tempint <= BB_FIELD_COLORTRANS_UN3RD)
							tempfloat = ((float)(tempint - BB_FIELD_COLORTRANS_3RD)) / (BB_FIELD_COLORTRANS_UN3RD - BB_FIELD_COLORTRANS_3RD);
						else if(tempint <= BB_FIELD_COLORTRANS_UN4TH)
							tempfloat = ((float)(tempint - BB_FIELD_COLORTRANS_4TH)) / (BB_FIELD_COLORTRANS_UN4TH - BB_FIELD_COLORTRANS_4TH);
						else if(tempint <= BB_FIELD_COLORTRANS_UN5TH)
							tempfloat = ((float)(tempint - BB_FIELD_COLORTRANS_5TH)) / (BB_FIELD_COLORTRANS_UN5TH - BB_FIELD_COLORTRANS_5TH);
						else if(tempint <= BB_FIELD_COLORTRANS_UN6TH)
							tempfloat = ((float)(tempint - BB_FIELD_COLORTRANS_6TH)) / (BB_FIELD_COLORTRANS_UN6TH - BB_FIELD_COLORTRANS_6TH);
						else if(tempint <= BB_FIELD_COLORTRANS_UN7TH)
							tempfloat = ((float)(tempint - BB_FIELD_COLORTRANS_7TH)) / (BB_FIELD_COLORTRANS_UN7TH - BB_FIELD_COLORTRANS_7TH);
						else if(tempint <= BB_FIELD_COLORTRANS_UN8TH)
							tempfloat = ((float)(tempint - BB_FIELD_COLORTRANS_8TH)) / (BB_FIELD_COLORTRANS_UN8TH - BB_FIELD_COLORTRANS_8TH);
						else if(tempint <= BB_FIELD_COLORTRANS_UN9TH)
							tempfloat = ((float)(tempint - BB_FIELD_COLORTRANS_9TH)) / (BB_FIELD_COLORTRANS_UN9TH - BB_FIELD_COLORTRANS_9TH);
					}

					m_pFieldBlocks[j][i].m_bClearable = 0;
					xRenderable2DQuadUpdateColor(m_pFieldBlocks[j][i].m_pBlockObject, xColorInit(&tempcolor2, tempcolor->R + (newtempcolor->R - tempcolor->R) * tempfloat, tempcolor->G + (newtempcolor->G - tempcolor->G) * tempfloat, tempcolor->B + (newtempcolor->B - tempcolor->B) * tempfloat, 1.0f));
					xRenderable2DQuadUpdateAlpha(m_pFieldBlocks[j][i].m_pBlockGlowObject, tempfloat);
					DEBUGLOG("Boss Color Transition: %i  %f  %f,%f,%f,%f\n", tempint, tempfloat, m_pFieldBlocks[j][i].m_pBlockObject->m_xRenderable2D.m_xColor.R, m_pFieldBlocks[j][i].m_pBlockObject->m_xRenderable2D.m_xColor.G, m_pFieldBlocks[j][i].m_pBlockObject->m_xRenderable2D.m_xColor.B, m_pFieldBlocks[j][i].m_pBlockObject->m_xRenderable2D.m_xColor.A);
				}
			}
			else if(m_pFieldBlocks[j][i].m_pBlockObject->m_fAnimationTime < BB_FIELD_UNFLASHWHITE)
			{
				m_pFieldBlocks[j][i].m_pBlockObject->m_fAnimationTime += dTime;

				if(m_pFieldBlocks[j][i].m_pBlockObject->m_fAnimationTime <= BB_FIELD_FLASHWHITE)
				{
					tempfloat = m_pFieldBlocks[j][i].m_pBlockObject->m_fAnimationTime;
					tempcolor = &g_colFilledBlockColors[m_pFieldBlocks[j][i].m_iColorIndex];
					xRenderable2DQuadUpdateColor(m_pFieldBlocks[j][i].m_pBlockObject, xColorInit(&tempcolor2, tempcolor->R + (1.0 - tempcolor->R) * (tempfloat / BB_FIELD_FLASHWHITE), tempcolor->G + (1.0 - tempcolor->G) * (tempfloat / BB_FIELD_FLASHWHITE), tempcolor->B + (1.0 - tempcolor->B) * (tempfloat / BB_FIELD_FLASHWHITE), 1.0f));
				}
				else
				{
					tempfloat = m_pFieldBlocks[j][i].m_pBlockObject->m_fAnimationTime - BB_FIELD_FLASHWHITE;
					tempcolor = &g_colFilledBlockColors[m_pFieldBlocks[j][i].m_iColorIndex];
					xRenderable2DQuadUpdateColor(m_pFieldBlocks[j][i].m_pBlockObject, xColorInit(&tempcolor2, 1.0 - (1.0 - tempcolor->R) * (tempfloat / (BB_FIELD_UNFLASHWHITE - BB_FIELD_FLASHWHITE)), 1.0 - (1.0 - tempcolor->G) * (tempfloat / (BB_FIELD_UNFLASHWHITE - BB_FIELD_FLASHWHITE)), 1.0 - (1.0 - tempcolor->B) * (tempfloat / (BB_FIELD_UNFLASHWHITE - BB_FIELD_FLASHWHITE)), 1.0));
				}
			}

			if(m_pFieldBlocks[j][i].m_bClearable)
				xRenderable2DQuadUpdateAlpha(m_pFieldBlocks[j][i].m_pBlockGlowObject, g_xGame.m_fBeatPercentage);
		}

		for(j = 0; j < BB_FIELDWIDTH / 2; j++)
		{
			if(m_pRotateTails[j][i]->m_xRenderable2D.m_bVisible)
			{
				oldframe = m_pRotateTails[j][i]->m_iCurrentTexture;

				xRenderable2DQuadUpdateAnimation(m_pRotateTails[j][i], dTime);

				if(m_pRotateTails[j][i]->m_iCurrentTexture < oldframe)
					xRenderable2DQuadUpdateVisibility(m_pRotateTails[j][i], 0);
			}
		}
	}

	for(i = 0; i < BB_PLACETAILS_MAX; i++)
	{
		if(m_pPlaceTails[i]->m_xRenderable2D.m_bVisible)
		{
			oldframe = m_pPlaceTails[i]->m_iCurrentTexture;

			xRenderable2DQuadUpdateAnimation(m_pPlaceTails[i], dTime);

			if(m_pPlaceTails[i]->m_iCurrentTexture < oldframe)
				xRenderable2DQuadUpdateVisibility(m_pPlaceTails[i], 0);
		}
	}

	return true;
}

void xField::ForceUpdateDroppingPiece()
{
	UpdateDroppingPiece(this);
}

FORCE_INLINE void UpdateDroppingPiece(xField *pField)
{
	if(!g_xGame.m_xPlayer.m_xPiece.m_bTouchedDown)
	{
		while(g_xPaperAPI.m_dwCurrentTime - pField->m_dwLastDropTime > BB_PIECEDROP_INTERVAL)
		{
			pField->MovePieceDown();

			if(!pField->CanMovePieceDown())
			{
				pField->PieceTouchedDown();
				break;
			}

			pField->m_dwLastDropTime += BB_PIECEDROP_INTERVAL;
		}
	}
}

void xField::RefreshAllRenderables()
{
	xEmitterList *emitter;
	int x, y;

	if(m_pBackgroundObject)
	{
		xRenderable2DQuadUpdateTexture(m_pBackgroundObject, m_pBackgroundObject->m_pTextures[0]);
		xRenderable2DQuadUpdate(m_pBackgroundObject);

		xRenderable2DQuadUpdateTexture(m_pBuildOverlay, m_pBuildOverlay->m_pTextures[0]);
		xRenderable2DQuadUpdate(m_pBuildOverlay);

		xRenderable2DQuadUpdateTexture(m_pPlacementFailureWarning, m_pPlacementFailureWarning->m_pTextures[0]);
		xRenderable2DQuadUpdate(m_pPlacementFailureWarning);

		for(y = 0; y < BB_FIELDHEIGHT; y++)
		{
			for(x = 0; x < BB_FIELDWIDTH; x++)
			{
				if(m_pFieldBlocks[x][y].m_pBlockObject)
				{
					xRenderable2DQuadUpdateTexture(m_pFieldBlocks[x][y].m_pBlockObject, m_pFieldBlocks[x][y].m_pBlockObject->m_pTextures[0]);
					xRenderable2DQuadUpdate(m_pFieldBlocks[x][y].m_pBlockObject);

					xRenderable2DQuadUpdateTexture(m_pFieldBlocks[x][y].m_pBlockGlowObject, m_pFieldBlocks[x][y].m_pBlockGlowObject->m_pTextures[0]);
					xRenderable2DQuadUpdate(m_pFieldBlocks[x][y].m_pBlockGlowObject);

					xRenderable2DQuadUpdateTexture(m_pFieldBlocks[x][y].m_pBlockOverlayObject, m_pFieldBlocks[x][y].m_pBlockOverlayObject->m_pTextures[0]);
					xRenderable2DQuadUpdate(m_pFieldBlocks[x][y].m_pBlockOverlayObject);
				}
			}

			for(x = 0; x < BB_FIELDWIDTH / 2; x++)
			{
				if(m_pRotateTails[x][y])
				{
					xRenderable2DQuadUpdateTexture(m_pRotateTails[x][y], m_pRotateTails[x][y]->m_pTextures[0]);
					xRenderable2DQuadUpdate(m_pRotateTails[x][y]);
				}
			}

			if(m_pBlockAnimationObject[y])
			{
				xRenderable2DQuadUpdateTexture(m_pBlockAnimationObject[y], m_pBlockAnimationObject[y]->m_pTextures[0]);
				xRenderable2DQuadUpdate(m_pBlockAnimationObject[y]);
			}
		}

		for(x = 0; x < BB_PLACETAILS_MAX; x++)
		{
			if(m_pPlaceTails[x])
			{
				xRenderable2DQuadUpdateTexture(m_pPlaceTails[x], m_pPlaceTails[x]->m_pTextures[0]);
				xRenderable2DQuadUpdate(m_pPlaceTails[x]);
			}
		}
	}

	emitter = m_xBlockClearedEmitters.m_pNext;
	while(emitter)
	{
		emitter->m_pData->RefreshRenderables(BB_EMITTER_BLOCKCLEARED);

		emitter = emitter->m_pNext;
	}
}

void xField::Shutdown()
{
/*	for(int x = 0; x < BB_FIELDWIDTH; x++)
	{
		for(int y = 0; y < BB_FIELDHEIGHT; y++)
		{
			if(m_pFieldBlocks[x][y] != NULL)
			{
				//delete m_pFieldBlocks[x][y]->m_pBlockObject;
				delete m_pFieldBlocks[x][y];
			}
		}
	}
*/
	xEmitterList *emitter = m_xBlockClearedEmitters.m_pNext;
	while(emitter)
	{
		if(emitter->m_pNext)
			emitter->m_pNext->m_pPrev = emitter->m_pPrev;

		if(emitter->m_pPrev)
			emitter->m_pPrev->m_pNext = emitter->m_pNext;

		xEmitterList *temp = emitter;
		emitter = emitter->m_pNext;

		temp->m_pData->Delete();
		delete temp->m_pData;
		delete temp;
	}
}

void xField::NewPiece()
{
	xRenderable2DQuadUpdateColor(m_pBuildOverlay, &g_colFilledBlockColors[g_xGame.m_xPlayer.m_xPiece.m_iColorIndex]);

	UpdateShadow();
}

void xField::RotateFieldClockwise()
{
	int tempindex[BB_FIELDHEIGHT], clearable[BB_FIELDHEIGHT], newtempindex[BB_FIELDHEIGHT], x, y, tempint;
	DWORD animtime[BB_FIELDHEIGHT];

	ForceFinishRotation();

	tempindex[0] = m_pFieldBlocks[0][0].m_iColorIndex;
	tempindex[1] = m_pFieldBlocks[0][1].m_iColorIndex;
	tempindex[2] = m_pFieldBlocks[0][2].m_iColorIndex;
	tempindex[3] = m_pFieldBlocks[0][3].m_iColorIndex;
	tempindex[4] = m_pFieldBlocks[0][4].m_iColorIndex;
	tempindex[5] = m_pFieldBlocks[0][5].m_iColorIndex;

	newtempindex[0] = m_pFieldBlocks[0][0].m_iNewColorIndex;
	newtempindex[1] = m_pFieldBlocks[0][1].m_iNewColorIndex;
	newtempindex[2] = m_pFieldBlocks[0][2].m_iNewColorIndex;
	newtempindex[3] = m_pFieldBlocks[0][3].m_iNewColorIndex;
	newtempindex[4] = m_pFieldBlocks[0][4].m_iNewColorIndex;
	newtempindex[5] = m_pFieldBlocks[0][5].m_iNewColorIndex;

	animtime[0] = m_pFieldBlocks[0][0].m_dwColorAnimStartTime;
	animtime[1] = m_pFieldBlocks[0][1].m_dwColorAnimStartTime;
	animtime[2] = m_pFieldBlocks[0][2].m_dwColorAnimStartTime;
	animtime[3] = m_pFieldBlocks[0][3].m_dwColorAnimStartTime;
	animtime[4] = m_pFieldBlocks[0][4].m_dwColorAnimStartTime;
	animtime[5] = m_pFieldBlocks[0][5].m_dwColorAnimStartTime;

	clearable[0] = m_pFieldBlocks[0][0].m_bClearable;
	clearable[1] = m_pFieldBlocks[0][1].m_bClearable;
	clearable[2] = m_pFieldBlocks[0][2].m_bClearable;
	clearable[3] = m_pFieldBlocks[0][3].m_bClearable;
	clearable[4] = m_pFieldBlocks[0][4].m_bClearable;
	clearable[5] = m_pFieldBlocks[0][5].m_bClearable;

	for(x = 0; x < BB_FIELDWIDTH - 1; x++)
	{
		m_pFieldBlocks[x][0].m_iColorIndex = m_pFieldBlocks[x + 1][0].m_iColorIndex;
		m_pFieldBlocks[x][1].m_iColorIndex = m_pFieldBlocks[x + 1][1].m_iColorIndex;
		m_pFieldBlocks[x][2].m_iColorIndex = m_pFieldBlocks[x + 1][2].m_iColorIndex;
		m_pFieldBlocks[x][3].m_iColorIndex = m_pFieldBlocks[x + 1][3].m_iColorIndex;
		m_pFieldBlocks[x][4].m_iColorIndex = m_pFieldBlocks[x + 1][4].m_iColorIndex;
		m_pFieldBlocks[x][5].m_iColorIndex = m_pFieldBlocks[x + 1][5].m_iColorIndex;

		m_pFieldBlocks[x][0].m_iNewColorIndex = m_pFieldBlocks[x + 1][0].m_iNewColorIndex;
		m_pFieldBlocks[x][1].m_iNewColorIndex = m_pFieldBlocks[x + 1][1].m_iNewColorIndex;
		m_pFieldBlocks[x][2].m_iNewColorIndex = m_pFieldBlocks[x + 1][2].m_iNewColorIndex;
		m_pFieldBlocks[x][3].m_iNewColorIndex = m_pFieldBlocks[x + 1][3].m_iNewColorIndex;
		m_pFieldBlocks[x][4].m_iNewColorIndex = m_pFieldBlocks[x + 1][4].m_iNewColorIndex;
		m_pFieldBlocks[x][5].m_iNewColorIndex = m_pFieldBlocks[x + 1][5].m_iNewColorIndex;

		m_pFieldBlocks[x][0].m_dwColorAnimStartTime = m_pFieldBlocks[x + 1][0].m_dwColorAnimStartTime;
		m_pFieldBlocks[x][1].m_dwColorAnimStartTime = m_pFieldBlocks[x + 1][1].m_dwColorAnimStartTime;
		m_pFieldBlocks[x][2].m_dwColorAnimStartTime = m_pFieldBlocks[x + 1][2].m_dwColorAnimStartTime;
		m_pFieldBlocks[x][3].m_dwColorAnimStartTime = m_pFieldBlocks[x + 1][3].m_dwColorAnimStartTime;
		m_pFieldBlocks[x][4].m_dwColorAnimStartTime = m_pFieldBlocks[x + 1][4].m_dwColorAnimStartTime;
		m_pFieldBlocks[x][5].m_dwColorAnimStartTime = m_pFieldBlocks[x + 1][5].m_dwColorAnimStartTime;

		m_pFieldBlocks[x][0].m_bClearable = m_pFieldBlocks[x + 1][0].m_bClearable;
		m_pFieldBlocks[x][1].m_bClearable = m_pFieldBlocks[x + 1][1].m_bClearable;
		m_pFieldBlocks[x][2].m_bClearable = m_pFieldBlocks[x + 1][2].m_bClearable;
		m_pFieldBlocks[x][3].m_bClearable = m_pFieldBlocks[x + 1][3].m_bClearable;
		m_pFieldBlocks[x][4].m_bClearable = m_pFieldBlocks[x + 1][4].m_bClearable;
		m_pFieldBlocks[x][5].m_bClearable = m_pFieldBlocks[x + 1][5].m_bClearable;
	}

	m_pFieldBlocks[BB_FIELDWIDTH - 1][0].m_iColorIndex = tempindex[0];
	m_pFieldBlocks[BB_FIELDWIDTH - 1][1].m_iColorIndex = tempindex[1];
	m_pFieldBlocks[BB_FIELDWIDTH - 1][2].m_iColorIndex = tempindex[2];
	m_pFieldBlocks[BB_FIELDWIDTH - 1][3].m_iColorIndex = tempindex[3];
	m_pFieldBlocks[BB_FIELDWIDTH - 1][4].m_iColorIndex = tempindex[4];
	m_pFieldBlocks[BB_FIELDWIDTH - 1][5].m_iColorIndex = tempindex[5];

	m_pFieldBlocks[BB_FIELDWIDTH - 1][0].m_iNewColorIndex = newtempindex[0];
	m_pFieldBlocks[BB_FIELDWIDTH - 1][1].m_iNewColorIndex = newtempindex[1];
	m_pFieldBlocks[BB_FIELDWIDTH - 1][2].m_iNewColorIndex = newtempindex[2];
	m_pFieldBlocks[BB_FIELDWIDTH - 1][3].m_iNewColorIndex = newtempindex[3];
	m_pFieldBlocks[BB_FIELDWIDTH - 1][4].m_iNewColorIndex = newtempindex[4];
	m_pFieldBlocks[BB_FIELDWIDTH - 1][5].m_iNewColorIndex = newtempindex[5];

	m_pFieldBlocks[BB_FIELDWIDTH - 1][0].m_dwColorAnimStartTime = animtime[0];
	m_pFieldBlocks[BB_FIELDWIDTH - 1][1].m_dwColorAnimStartTime = animtime[1];
	m_pFieldBlocks[BB_FIELDWIDTH - 1][2].m_dwColorAnimStartTime = animtime[2];
	m_pFieldBlocks[BB_FIELDWIDTH - 1][3].m_dwColorAnimStartTime = animtime[3];
	m_pFieldBlocks[BB_FIELDWIDTH - 1][4].m_dwColorAnimStartTime = animtime[4];
	m_pFieldBlocks[BB_FIELDWIDTH - 1][5].m_dwColorAnimStartTime = animtime[5];

	m_pFieldBlocks[BB_FIELDWIDTH - 1][0].m_bClearable = clearable[0];
	m_pFieldBlocks[BB_FIELDWIDTH - 1][1].m_bClearable = clearable[1];
	m_pFieldBlocks[BB_FIELDWIDTH - 1][2].m_bClearable = clearable[2];
	m_pFieldBlocks[BB_FIELDWIDTH - 1][3].m_bClearable = clearable[3];
	m_pFieldBlocks[BB_FIELDWIDTH - 1][4].m_bClearable = clearable[4];
	m_pFieldBlocks[BB_FIELDWIDTH - 1][5].m_bClearable = clearable[5];

	for(y = 0; y < BB_FIELDHEIGHT; y++)
	{
		tempint = 0;

		for(x = 0; x < BB_FIELDWIDTH; x++)
		{
			m_pFieldBlocks[x][y].m_iNewColorIndex = -1;

			xRenderable2DQuadUpdateColor(m_pFieldBlocks[x][y].m_pBlockObject, &g_colFilledBlockColors[m_pFieldBlocks[x][y].m_iColorIndex]);
			xRenderable2DQuadUpdateVisibility(m_pFieldBlocks[x][y].m_pBlockObject, m_pFieldBlocks[x][y].m_iColorIndex != -1);
			xRenderable2DQuadUpdateTexture(m_pFieldBlocks[x][y].m_pBlockObject, m_pFieldBlocks[x][y].m_pBlockTexture);

			xRenderable2DQuadUpdateColor(m_pFieldBlocks[x][y].m_pBlockGlowObject, &g_colBlockGlowColors[m_pFieldBlocks[x][y].m_iColorIndex]);
			xRenderable2DQuadUpdateVisibility(m_pFieldBlocks[x][y].m_pBlockGlowObject, m_pFieldBlocks[x][y].m_pBlockObject->m_xRenderable2D.m_bVisible);

			xRenderable2DQuadUpdateVisibility(m_pFieldBlocks[x][y].m_pBlockOverlayObject, m_pFieldBlocks[x][y].m_pBlockObject->m_xRenderable2D.m_bVisible);

			if(m_pFieldBlocks[x][y].m_pBlockObject->m_xRenderable2D.m_bVisible && m_pFieldBlocks[(x + 1) % BB_FIELDWIDTH][y].m_iColorIndex < 0)
			{
				xRenderable2DQuadSetPosition(m_pRotateTails[tempint][y], m_pFieldBlocks[(x + 1) % BB_FIELDWIDTH][y].m_pBlockObject->m_xRenderable2D.m_fX, m_pFieldBlocks[(x + 1) % BB_FIELDWIDTH][y].m_pBlockObject->m_xRenderable2D.m_fY);
				xRenderable2DQuadSetRotation(m_pRotateTails[tempint][y], m_pFieldBlocks[(x + 1) % BB_FIELDWIDTH][y].m_pBlockObject->m_xRenderable2D.m_fRotation);
				xRenderable2DQuadSetMirror(m_pRotateTails[tempint][y], 0);
				xRenderable2DQuadUpdateVisibility(m_pRotateTails[tempint][y], 1);
				xRenderable2DQuadUpdateColor(m_pRotateTails[tempint][y], &g_colFilledBlockColors[m_pFieldBlocks[x][y].m_iColorIndex]);
				xRenderable2DQuadUpdate(m_pRotateTails[tempint][y]);

				m_pRotateTails[tempint][y]->m_fAnimationTime = 0.0;
				m_pRotateTails[tempint][y]->m_iCurrentTexture = 0;

				tempint++;
			}
		}

		xRenderable2DQuadUpdateVisibility(m_pBlockAnimationObject[y], false);
	}

	UpdateGlowAlphas(0);

	UpdateShadow();

	m_fRotationTime = 0.0f;
	m_bRotateClockwise = true;
}

void xField::RotateFieldCounterClockwise()
{
	int tempindex[BB_FIELDHEIGHT], clearable[BB_FIELDHEIGHT], newtempindex[BB_FIELDHEIGHT], x, y, tempint;
	DWORD animtime[BB_FIELDHEIGHT];

	ForceFinishRotation();

	tempindex[0] = m_pFieldBlocks[BB_FIELDWIDTH - 1][0].m_iColorIndex;
	tempindex[1] = m_pFieldBlocks[BB_FIELDWIDTH - 1][1].m_iColorIndex;
	tempindex[2] = m_pFieldBlocks[BB_FIELDWIDTH - 1][2].m_iColorIndex;
	tempindex[3] = m_pFieldBlocks[BB_FIELDWIDTH - 1][3].m_iColorIndex;
	tempindex[4] = m_pFieldBlocks[BB_FIELDWIDTH - 1][4].m_iColorIndex;
	tempindex[5] = m_pFieldBlocks[BB_FIELDWIDTH - 1][5].m_iColorIndex;

	newtempindex[0] = m_pFieldBlocks[BB_FIELDWIDTH - 1][0].m_iNewColorIndex;
	newtempindex[1] = m_pFieldBlocks[BB_FIELDWIDTH - 1][1].m_iNewColorIndex;
	newtempindex[2] = m_pFieldBlocks[BB_FIELDWIDTH - 1][2].m_iNewColorIndex;
	newtempindex[3] = m_pFieldBlocks[BB_FIELDWIDTH - 1][3].m_iNewColorIndex;
	newtempindex[4] = m_pFieldBlocks[BB_FIELDWIDTH - 1][4].m_iNewColorIndex;
	newtempindex[5] = m_pFieldBlocks[BB_FIELDWIDTH - 1][5].m_iNewColorIndex;

	animtime[0] = m_pFieldBlocks[0][0].m_dwColorAnimStartTime;
	animtime[1] = m_pFieldBlocks[0][1].m_dwColorAnimStartTime;
	animtime[2] = m_pFieldBlocks[0][2].m_dwColorAnimStartTime;
	animtime[3] = m_pFieldBlocks[0][3].m_dwColorAnimStartTime;
	animtime[4] = m_pFieldBlocks[0][4].m_dwColorAnimStartTime;
	animtime[5] = m_pFieldBlocks[0][5].m_dwColorAnimStartTime;

	clearable[0] = m_pFieldBlocks[BB_FIELDWIDTH - 1][0].m_bClearable;
	clearable[1] = m_pFieldBlocks[BB_FIELDWIDTH - 1][1].m_bClearable;
	clearable[2] = m_pFieldBlocks[BB_FIELDWIDTH - 1][2].m_bClearable;
	clearable[3] = m_pFieldBlocks[BB_FIELDWIDTH - 1][3].m_bClearable;
	clearable[4] = m_pFieldBlocks[BB_FIELDWIDTH - 1][4].m_bClearable;
	clearable[5] = m_pFieldBlocks[BB_FIELDWIDTH - 1][5].m_bClearable;

	for(x = BB_FIELDWIDTH - 1; x > 0; x--)
	{
		m_pFieldBlocks[x][0].m_iColorIndex = m_pFieldBlocks[x - 1][0].m_iColorIndex;
		m_pFieldBlocks[x][1].m_iColorIndex = m_pFieldBlocks[x - 1][1].m_iColorIndex;
		m_pFieldBlocks[x][2].m_iColorIndex = m_pFieldBlocks[x - 1][2].m_iColorIndex;
		m_pFieldBlocks[x][3].m_iColorIndex = m_pFieldBlocks[x - 1][3].m_iColorIndex;
		m_pFieldBlocks[x][4].m_iColorIndex = m_pFieldBlocks[x - 1][4].m_iColorIndex;
		m_pFieldBlocks[x][5].m_iColorIndex = m_pFieldBlocks[x - 1][5].m_iColorIndex;

		m_pFieldBlocks[x][0].m_iNewColorIndex = m_pFieldBlocks[x - 1][0].m_iNewColorIndex;
		m_pFieldBlocks[x][1].m_iNewColorIndex = m_pFieldBlocks[x - 1][1].m_iNewColorIndex;
		m_pFieldBlocks[x][2].m_iNewColorIndex = m_pFieldBlocks[x - 1][2].m_iNewColorIndex;
		m_pFieldBlocks[x][3].m_iNewColorIndex = m_pFieldBlocks[x - 1][3].m_iNewColorIndex;
		m_pFieldBlocks[x][4].m_iNewColorIndex = m_pFieldBlocks[x - 1][4].m_iNewColorIndex;
		m_pFieldBlocks[x][5].m_iNewColorIndex = m_pFieldBlocks[x - 1][5].m_iNewColorIndex;

		m_pFieldBlocks[x][0].m_dwColorAnimStartTime = m_pFieldBlocks[x - 1][0].m_dwColorAnimStartTime;
		m_pFieldBlocks[x][1].m_dwColorAnimStartTime = m_pFieldBlocks[x - 1][1].m_dwColorAnimStartTime;
		m_pFieldBlocks[x][2].m_dwColorAnimStartTime = m_pFieldBlocks[x - 1][2].m_dwColorAnimStartTime;
		m_pFieldBlocks[x][3].m_dwColorAnimStartTime = m_pFieldBlocks[x - 1][3].m_dwColorAnimStartTime;
		m_pFieldBlocks[x][4].m_dwColorAnimStartTime = m_pFieldBlocks[x - 1][4].m_dwColorAnimStartTime;
		m_pFieldBlocks[x][5].m_dwColorAnimStartTime = m_pFieldBlocks[x - 1][5].m_dwColorAnimStartTime;

		m_pFieldBlocks[x][0].m_bClearable = m_pFieldBlocks[x - 1][0].m_bClearable;
		m_pFieldBlocks[x][1].m_bClearable = m_pFieldBlocks[x - 1][1].m_bClearable;
		m_pFieldBlocks[x][2].m_bClearable = m_pFieldBlocks[x - 1][2].m_bClearable;
		m_pFieldBlocks[x][3].m_bClearable = m_pFieldBlocks[x - 1][3].m_bClearable;
		m_pFieldBlocks[x][4].m_bClearable = m_pFieldBlocks[x - 1][4].m_bClearable;
		m_pFieldBlocks[x][5].m_bClearable = m_pFieldBlocks[x - 1][5].m_bClearable;
	}

	m_pFieldBlocks[0][0].m_iColorIndex = tempindex[0];
	m_pFieldBlocks[0][1].m_iColorIndex = tempindex[1];
	m_pFieldBlocks[0][2].m_iColorIndex = tempindex[2];
	m_pFieldBlocks[0][3].m_iColorIndex = tempindex[3];
	m_pFieldBlocks[0][4].m_iColorIndex = tempindex[4];
	m_pFieldBlocks[0][5].m_iColorIndex = tempindex[5];

	m_pFieldBlocks[0][0].m_iNewColorIndex = newtempindex[0];
	m_pFieldBlocks[0][1].m_iNewColorIndex = newtempindex[1];
	m_pFieldBlocks[0][2].m_iNewColorIndex = newtempindex[2];
	m_pFieldBlocks[0][3].m_iNewColorIndex = newtempindex[3];
	m_pFieldBlocks[0][4].m_iNewColorIndex = newtempindex[4];
	m_pFieldBlocks[0][5].m_iNewColorIndex = newtempindex[5];

	m_pFieldBlocks[0][0].m_dwColorAnimStartTime = animtime[0];
	m_pFieldBlocks[0][1].m_dwColorAnimStartTime = animtime[1];
	m_pFieldBlocks[0][2].m_dwColorAnimStartTime = animtime[2];
	m_pFieldBlocks[0][3].m_dwColorAnimStartTime = animtime[3];
	m_pFieldBlocks[0][4].m_dwColorAnimStartTime = animtime[4];
	m_pFieldBlocks[0][5].m_dwColorAnimStartTime = animtime[5];

	m_pFieldBlocks[0][0].m_bClearable = clearable[0];
	m_pFieldBlocks[0][1].m_bClearable = clearable[1];
	m_pFieldBlocks[0][2].m_bClearable = clearable[2];
	m_pFieldBlocks[0][3].m_bClearable = clearable[3];
	m_pFieldBlocks[0][4].m_bClearable = clearable[4];
	m_pFieldBlocks[0][5].m_bClearable = clearable[5];

	for(y = 0; y < BB_FIELDHEIGHT; y++)
	{
		tempint = 0;

		for(x = 0; x < BB_FIELDWIDTH; x++)
		{
			m_pFieldBlocks[x][y].m_iNewColorIndex = -1;

			xRenderable2DQuadUpdateColor(m_pFieldBlocks[x][y].m_pBlockObject, &g_colFilledBlockColors[m_pFieldBlocks[x][y].m_iColorIndex]);
			xRenderable2DQuadUpdateVisibility(m_pFieldBlocks[x][y].m_pBlockObject, m_pFieldBlocks[x][y].m_iColorIndex != -1);
			xRenderable2DQuadUpdateTexture(m_pFieldBlocks[x][y].m_pBlockObject, m_pFieldBlocks[x][y].m_pBlockTexture);

			xRenderable2DQuadUpdateColor(m_pFieldBlocks[x][y].m_pBlockGlowObject, &g_colBlockGlowColors[m_pFieldBlocks[x][y].m_iColorIndex]);
			xRenderable2DQuadUpdateVisibility(m_pFieldBlocks[x][y].m_pBlockGlowObject, m_pFieldBlocks[x][y].m_pBlockObject->m_xRenderable2D.m_bVisible);

			xRenderable2DQuadUpdateVisibility(m_pFieldBlocks[x][y].m_pBlockOverlayObject, m_pFieldBlocks[x][y].m_pBlockObject->m_xRenderable2D.m_bVisible);

			if(m_pFieldBlocks[x][y].m_pBlockObject->m_xRenderable2D.m_bVisible && ((x > 0 && m_pFieldBlocks[x - 1][y].m_iColorIndex < 0) || (x == 0 && m_pFieldBlocks[BB_FIELDWIDTH - 1][y].m_iColorIndex < 0)))
			{
				if(x > 0)
				{
					xRenderable2DQuadSetPosition(m_pRotateTails[tempint][y], m_pFieldBlocks[x - 1][y].m_pBlockObject->m_xRenderable2D.m_fX, m_pFieldBlocks[x - 1][y].m_pBlockObject->m_xRenderable2D.m_fY);
					xRenderable2DQuadSetRotation(m_pRotateTails[tempint][y], m_pFieldBlocks[x - 1][y].m_pBlockObject->m_xRenderable2D.m_fRotation);
				}
				else
				{
					xRenderable2DQuadSetPosition(m_pRotateTails[tempint][y], m_pFieldBlocks[BB_FIELDWIDTH - 1][y].m_pBlockObject->m_xRenderable2D.m_fX, m_pFieldBlocks[BB_FIELDWIDTH - 1][y].m_pBlockObject->m_xRenderable2D.m_fY);
					xRenderable2DQuadSetRotation(m_pRotateTails[tempint][y], m_pFieldBlocks[BB_FIELDWIDTH - 1][y].m_pBlockObject->m_xRenderable2D.m_fRotation);
				}

				xRenderable2DQuadSetMirror(m_pRotateTails[tempint][y], 1);
				xRenderable2DQuadUpdateVisibility(m_pRotateTails[tempint][y], 1);
				xRenderable2DQuadUpdateColor(m_pRotateTails[tempint][y], &g_colFilledBlockColors[m_pFieldBlocks[x][y].m_iColorIndex]);
				xRenderable2DQuadUpdate(m_pRotateTails[tempint][y]);

				m_pRotateTails[tempint][y]->m_fAnimationTime = 0.0;
				m_pRotateTails[tempint][y]->m_iCurrentTexture = 0;

				tempint++;
			}
		}

		xRenderable2DQuadUpdateVisibility(m_pBlockAnimationObject[y], false);
	}

	UpdateGlowAlphas(0);

	UpdateShadow();

	m_fRotationTime = 0.0f;
	m_bRotateClockwise = false;
}

void xField::DropPiece()
{
	xBlock *curblock;
	int i = 0;

	if(g_xGame.m_xPlayer.m_xPiece.m_bDropping)
		return;

	xRenderable2DQuadUpdateVisibility(g_xGame.m_xPlayer.m_xPiece.m_pBlockAnimation, 0);

	g_xGame.m_xPlayer.m_xPiece.m_iCurFieldX = BB_FIELD_PIECESTARTX;
	g_xGame.m_xPlayer.m_xPiece.m_iCurFieldY = BB_FIELD_PIECESTARTY;

	// Move the Current Piece down until it's no longer above the top of the play area
	curblock = g_xGame.m_xPlayer.m_xPiece.m_pBlockList;
	while(curblock)
	{
		xRenderable2DQuadUpdateVisibility(curblock->m_pBlockObject, 0);
		xRenderable2DQuadUpdateVisibility(curblock->m_pBlockOverlayObject, 0);
		xRenderable2DQuadUpdateVisibility(curblock->m_pBuildArrowObject, 0);

		//DEBUGLOG("DropPiece - Checking need for MovePieceDown: %i %i\n", g_xGame.m_xPlayer.m_xPiece.m_iCurFieldY, curblock->m_iRowID);
		if(g_xGame.m_xPlayer.m_xPiece.m_iCurFieldY + curblock->m_iRowID < 0)
		{
			if(CanMovePieceDown())
			{
				//DEBUGLOG("DropPiece - MovePieceDown\n");
				MovePieceDown();
			}
			else
			{
				//DEBUGLOG("DropPiece - PieceTouchedDown1\n");
				PieceTouchedDown();
				break;
			}
		}

		xRenderable2DQuadUpdateVisibility(m_pFieldBlocks[m_iShadowPieceX[i]][m_iShadowPieceY[i]].m_pBlockObject, 0);
		xRenderable2DQuadUpdateVisibility(m_pFieldBlocks[m_iShadowPieceX[i]][m_iShadowPieceY[i]].m_pBlockGlowObject, 0);
		xRenderable2DQuadUpdateVisibility(m_pFieldBlocks[m_iShadowPieceX[i]][m_iShadowPieceY[i]].m_pBlockOverlayObject, 0);
		//DEBUGLOG("Setting to Block Texture - %i,%i\n", m_iShadowPieceX[i], m_iShadowPieceY[i]);
		xRenderable2DQuadUpdateTexture(m_pFieldBlocks[m_iShadowPieceX[i]][m_iShadowPieceY[i]].m_pBlockObject, m_pFieldBlocks[m_iShadowPieceX[i]][m_iShadowPieceY[i]].m_pBlockTexture);

		i++;
		curblock = curblock->m_pNext;
	}

	g_xGame.m_xPlayer.m_xPiece.m_bDropping = true;

	if(!CanMovePieceDown())
	{
		PieceTouchedDown();
		//DEBUGLOG("DropPiece - PieceTouchedDown2\n");
	}

	m_dwLastDropTime = g_xPaperAPI.m_dwCurrentTime;
}

bool xField::CanMovePieceDown()
{
	xBlock *curblock = g_xGame.m_xPlayer.m_xPiece.m_pBlockList;
	while(curblock)
	{
		int fieldxloc = (g_xGame.m_xPlayer.m_xPiece.m_iCurFieldX + curblock->m_iColumnID) % BB_FIELDWIDTH;
		int fieldyloc = g_xGame.m_xPlayer.m_xPiece.m_iCurFieldY + curblock->m_iRowID;

		if(fieldyloc + 1 >= BB_FIELDHEIGHT)
		{
			//DEBUGLOG("CanMovePieceDown1(false) - x,%i - %i %i\n", fieldyloc + 1, g_xGame.m_xPlayer.m_xPiece.m_iCurFieldY, curblock->m_iRowID);
			return false;
		}

		if(fieldxloc < 0)
			fieldxloc += BB_FIELDWIDTH;

		if(fieldyloc + 1 >= 0 && m_pFieldBlocks[fieldxloc][fieldyloc + 1].m_iColorIndex >= 0)
		{
			//DEBUGLOG("CanMovePieceDown2(false) - %i,%i - %i %i\n", fieldxloc, fieldyloc + 1, g_xGame.m_xPlayer.m_xPiece.m_iCurFieldY, curblock->m_iRowID);
			return false;
		}

		curblock = curblock->m_pNext;
	}

	//DEBUGLOG("CanMovePieceDown(true)\n");
	return true;
}

void xField::MovePieceDown()
{
	int fieldxloc, fieldyloc;
	xBlock *curblock;

	curblock = g_xGame.m_xPlayer.m_xPiece.m_pBlockList;
	while(curblock)
	{
		fieldyloc = g_xGame.m_xPlayer.m_xPiece.m_iCurFieldY + curblock->m_iRowID;

		if(fieldyloc >= 0)
		{
			fieldxloc = (g_xGame.m_xPlayer.m_xPiece.m_iCurFieldX + curblock->m_iColumnID) % BB_FIELDWIDTH;

			if(fieldxloc < 0)
				fieldxloc += BB_FIELDWIDTH;

			//m_pFieldBlocks[fieldxloc][fieldyloc].m_iUnfilledColorIndex = -1;
			//DEBUGLOG("1. %i %i Clearing field block visible %i %i\n", curblock->m_iColumnID, curblock->m_iRowID, fieldxloc, fieldyloc);
			xRenderable2DQuadUpdateVisibility(m_pFieldBlocks[fieldxloc][fieldyloc].m_pBlockObject, 0);
			xRenderable2DQuadUpdateVisibility(m_pFieldBlocks[fieldxloc][fieldyloc].m_pBlockGlowObject, 0);
			xRenderable2DQuadUpdateVisibility(m_pFieldBlocks[fieldxloc][fieldyloc].m_pBlockOverlayObject, 0);

			xRenderable2DQuadSetPosition(m_pPlaceTails[m_iCurrentPlaceTail], m_pFieldBlocks[fieldxloc][fieldyloc].m_pBlockObject->m_xRenderable2D.m_fX - m_pFieldBlocks[fieldxloc][fieldyloc].m_pBlockObject->m_xRenderable2D.m_fWidth * 0.5, m_pFieldBlocks[fieldxloc][fieldyloc].m_pBlockObject->m_xRenderable2D.m_fY);
			xRenderable2DQuadSetSize(m_pPlaceTails[m_iCurrentPlaceTail], m_pFieldBlocks[fieldxloc][fieldyloc].m_pBlockObject->m_xRenderable2D.m_fWidth * 2, m_pFieldBlocks[fieldxloc][fieldyloc].m_pBlockObject->m_xRenderable2D.m_fHeight);
			xRenderable2DQuadSetRotation(m_pPlaceTails[m_iCurrentPlaceTail], m_pFieldBlocks[fieldxloc][fieldyloc].m_pBlockObject->m_xRenderable2D.m_fRotation);
			xRenderable2DQuadUpdateVisibility(m_pPlaceTails[m_iCurrentPlaceTail], 1);
			xRenderable2DQuadUpdateColor(m_pPlaceTails[m_iCurrentPlaceTail], &m_pFieldBlocks[fieldxloc][fieldyloc].m_pBlockObject->m_xRenderable2D.m_xColor);
			xRenderable2DQuadUpdate(m_pPlaceTails[m_iCurrentPlaceTail]);

			m_pPlaceTails[m_iCurrentPlaceTail]->m_fAnimationTime = 0.0;
			m_pPlaceTails[m_iCurrentPlaceTail]->m_iCurrentTexture = 0;

			m_iCurrentPlaceTail++;

			if(m_iCurrentPlaceTail >= BB_PLACETAILS_MAX)
				m_iCurrentPlaceTail = 0;
		}

		curblock = curblock->m_pNext;
	}

	curblock = g_xGame.m_xPlayer.m_xPiece.m_pBlockList;
	while(curblock)
	{
		fieldyloc = g_xGame.m_xPlayer.m_xPiece.m_iCurFieldY + curblock->m_iRowID + 1;

		if(fieldyloc >= 0)
		{
			fieldxloc = (g_xGame.m_xPlayer.m_xPiece.m_iCurFieldX + curblock->m_iColumnID) % BB_FIELDWIDTH;

			if(fieldxloc < 0)
				fieldxloc += BB_FIELDWIDTH;

			//m_pFieldBlocks[fieldxloc][fieldyloc].m_iUnfilledColorIndex = curblock->m_iColorIndex;
			xRenderable2DQuadUpdateColor(m_pFieldBlocks[fieldxloc][fieldyloc].m_pBlockObject, &g_colFilledBlockColors[curblock->m_iColorIndex]);
			xRenderable2DQuadUpdateColor(m_pFieldBlocks[fieldxloc][fieldyloc].m_pBlockGlowObject, &g_colBlockGlowColors[curblock->m_iColorIndex]);
			xRenderable2DQuadUpdateAlpha(m_pFieldBlocks[fieldxloc][fieldyloc].m_pBlockGlowObject, 0.0f);
			//DEBUGLOG("1. %i %i Setting field block visible %i %i\n", curblock->m_iColumnID, curblock->m_iRowID, fieldxloc, fieldyloc);
			xRenderable2DQuadUpdateVisibility(m_pFieldBlocks[fieldxloc][fieldyloc].m_pBlockObject, 1);
			xRenderable2DQuadUpdateVisibility(m_pFieldBlocks[fieldxloc][fieldyloc].m_pBlockGlowObject, 1);
			xRenderable2DQuadUpdateVisibility(m_pFieldBlocks[fieldxloc][fieldyloc].m_pBlockOverlayObject, 1);
		}
		//else
		//	DEBUGLOG("1. %i %i fieldyloc < 0 %i\n", curblock->m_iColumnID, curblock->m_iRowID, fieldyloc);

		curblock = curblock->m_pNext;
	}

	g_xGame.m_xPlayer.m_xPiece.m_iCurFieldY++;
}

#define DEBUGTOUCHDOWN 0
void xField::PieceTouchedDown()
{
	xBlock *curblock;
	float oldx;
	int fieldxloc, fieldyloc;
	bool movedblocks;

#if DEBUGTOUCHDOWN
	for(int y = 5; y >= 0; y--)
		DEBUGLOG("PieceTouchedDown Before: %i%s %i%s %i%s %i%s %i%s\n", m_pFieldBlocks[6][y].m_iColorIndex, m_pFieldBlocks[6][y].m_iColorIndex >= 0 ? (m_pFieldBlocks[6][y].m_pBlockObject->m_xRenderable2D.m_bVisible ? "t " : "f ") : " ",
																		m_pFieldBlocks[5][y].m_iColorIndex, m_pFieldBlocks[5][y].m_iColorIndex >= 0 ? (m_pFieldBlocks[5][y].m_pBlockObject->m_xRenderable2D.m_bVisible ? "t " : "f ") : " ",
																		m_pFieldBlocks[4][y].m_iColorIndex, m_pFieldBlocks[4][y].m_iColorIndex >= 0 ? (m_pFieldBlocks[4][y].m_pBlockObject->m_xRenderable2D.m_bVisible ? "t " : "f ") : " ",
																		m_pFieldBlocks[3][y].m_iColorIndex, m_pFieldBlocks[3][y].m_iColorIndex >= 0 ? (m_pFieldBlocks[3][y].m_pBlockObject->m_xRenderable2D.m_bVisible ? "t " : "f ") : " ",
																		m_pFieldBlocks[2][y].m_iColorIndex, m_pFieldBlocks[2][y].m_iColorIndex >= 0 ? (m_pFieldBlocks[2][y].m_pBlockObject->m_xRenderable2D.m_bVisible ? "t " : "f ") : " ");
#endif

	g_xGame.m_xPlayer.m_xPiece.m_bTouchedDown	= true;

	//m_xPiecePlacedEmitter.Reset();
	//m_xPiecePlacedEmitter.SetPosition(2000.0, 0.0);

	curblock = g_xGame.m_xPlayer.m_xPiece.m_pBlockList;	
	while(curblock)
	{
		if(curblock->m_pBlockObject)
		{
			fieldxloc = g_xGame.m_xPlayer.m_xPiece.m_iCurFieldX + curblock->m_iColumnID;
			fieldyloc = g_xGame.m_xPlayer.m_xPiece.m_iCurFieldY + curblock->m_iRowID;

#if DEBUGTOUCHDOWN
			DEBUGLOG("3. %i %i Setting field block visible: %i, %i\n", curblock->m_iColumnID, curblock->m_iRowID, fieldxloc, fieldyloc);
#endif

			if(fieldyloc < BB_FIELDHEIGHT && fieldyloc >= 0)
			{
				m_pFieldBlocks[fieldxloc][fieldyloc].m_iColorIndex = curblock->m_iColorIndex;
				xRenderable2DQuadUpdateVisibility(m_pFieldBlocks[fieldxloc][fieldyloc].m_pBlockObject, 1);
				xRenderable2DQuadUpdateVisibility(m_pFieldBlocks[fieldxloc][fieldyloc].m_pBlockGlowObject, 1);
				xRenderable2DQuadUpdateVisibility(m_pFieldBlocks[fieldxloc][fieldyloc].m_pBlockOverlayObject, 1);
			}
		}

		curblock = curblock->m_pNext;
	}

	do
	{
		movedblocks = false;

		curblock = g_xGame.m_xPlayer.m_xPiece.m_pBlockList;	
		while(curblock)
		{
			fieldyloc = g_xGame.m_xPlayer.m_xPiece.m_iCurFieldY + curblock->m_iRowID + 1;

			if(fieldyloc < BB_FIELDHEIGHT && fieldyloc >= 0)
			{
				fieldxloc = (g_xGame.m_xPlayer.m_xPiece.m_iCurFieldX + curblock->m_iColumnID) % BB_FIELDWIDTH;

				if(fieldxloc < 0)
					fieldxloc += BB_FIELDWIDTH;

				if(m_pFieldBlocks[fieldxloc][fieldyloc].m_iColorIndex < 0)
				{
					if(fieldyloc > 0)
					{
#if DEBUGTOUCHDOWN
						DEBUGLOG("2. %i %i Clearing field block visible %i %i\n", m_pFieldBlocks[fieldxloc][fieldyloc - 1].m_iColumnID, m_pFieldBlocks[fieldxloc][fieldyloc - 1].m_iRowID, fieldxloc, fieldyloc - 1);
#endif
						m_pFieldBlocks[fieldxloc][fieldyloc - 1].m_iColorIndex = -1;
						xRenderable2DQuadUpdateVisibility(m_pFieldBlocks[fieldxloc][fieldyloc - 1].m_pBlockObject, 0);
						xRenderable2DQuadUpdateVisibility(m_pFieldBlocks[fieldxloc][fieldyloc - 1].m_pBlockGlowObject, 0);
						xRenderable2DQuadUpdateVisibility(m_pFieldBlocks[fieldxloc][fieldyloc - 1].m_pBlockOverlayObject, 0);
					}

					curblock->m_iRowID++;

					m_pFieldBlocks[fieldxloc][fieldyloc].m_iColorIndex = curblock->m_iColorIndex;
					xRenderable2DQuadUpdateColor(m_pFieldBlocks[fieldxloc][fieldyloc].m_pBlockObject, &g_colFilledBlockColors[curblock->m_iColorIndex]);
					xRenderable2DQuadUpdateColor(m_pFieldBlocks[fieldxloc][fieldyloc].m_pBlockGlowObject, &g_colBlockGlowColors[curblock->m_iColorIndex]);

#if DEBUGTOUCHDOWN
					DEBUGLOG("2. %i %i Setting field block visible %i %i\n", m_pFieldBlocks[fieldxloc][fieldyloc].m_iColumnID, m_pFieldBlocks[fieldxloc][fieldyloc].m_iRowID, fieldxloc, fieldyloc);
#endif

					xRenderable2DQuadUpdateVisibility(m_pFieldBlocks[fieldxloc][fieldyloc].m_pBlockObject, 1);
					xRenderable2DQuadUpdateVisibility(m_pFieldBlocks[fieldxloc][fieldyloc].m_pBlockGlowObject, 1);
					xRenderable2DQuadUpdateVisibility(m_pFieldBlocks[fieldxloc][fieldyloc].m_pBlockOverlayObject, 1);

					movedblocks = true;
				}
			}

			curblock = curblock->m_pNext;
		}
	}while(movedblocks);

	UpdateGlowAlphas(1);

	curblock = g_xGame.m_xPlayer.m_xPiece.m_pBlockList;	
	while(curblock)
	{
		if(g_xGame.m_xPlayer.m_xPiece.m_iCurFieldY + curblock->m_iRowID < 0)
			g_xGame.Failed();

		curblock = curblock->m_pNext;
	}

#if DEBUGTOUCHDOWN
	for(int y = 5; y >= 0; y--)
		DEBUGLOG("PieceTouchedDown After: %i%s %i%s %i%s %i%s %i%s\n", m_pFieldBlocks[6][y].m_iColorIndex, m_pFieldBlocks[6][y].m_iColorIndex >= 0 ? (m_pFieldBlocks[6][y].m_pBlockObject->m_xRenderable2D.m_bVisible ? "t " : "f ") : " ",
																	   m_pFieldBlocks[5][y].m_iColorIndex, m_pFieldBlocks[5][y].m_iColorIndex >= 0 ? (m_pFieldBlocks[5][y].m_pBlockObject->m_xRenderable2D.m_bVisible ? "t " : "f ") : " ",
																	   m_pFieldBlocks[4][y].m_iColorIndex, m_pFieldBlocks[4][y].m_iColorIndex >= 0 ? (m_pFieldBlocks[4][y].m_pBlockObject->m_xRenderable2D.m_bVisible ? "t " : "f ") : " ",
																	   m_pFieldBlocks[3][y].m_iColorIndex, m_pFieldBlocks[3][y].m_iColorIndex >= 0 ? (m_pFieldBlocks[3][y].m_pBlockObject->m_xRenderable2D.m_bVisible ? "t " : "f ") : " ",
																	   m_pFieldBlocks[2][y].m_iColorIndex, m_pFieldBlocks[2][y].m_iColorIndex >= 0 ? (m_pFieldBlocks[2][y].m_pBlockObject->m_xRenderable2D.m_bVisible ? "t " : "f ") : " ");
#endif

	if(!g_xGameOptions.m_bTutorial)
		g_xGame.m_xPlayer.m_xPiece.Delete(true, true, true);
}

void xField::UpdateGlowAlphas(bool bDoClearableWhiteFlash)
{
	int x, y, x2, y2, possibleblocks;

	DEBUGCLEARBLOCKS("UpdateGlowAlphas\n");

	for(y = 0; y < BB_FIELDHEIGHT; y++)
		for(x = 0; x < BB_FIELDWIDTH; x++)
			xRenderable2DQuadUpdateAlpha(m_pFieldBlocks[x][y].m_pBlockGlowObject, 0.0f);

	m_iClearableBlockCount = 0;

	for(y = 0; y < BB_FIELDHEIGHT; y++)
	{
		for(x = 0; x < BB_FIELDWIDTH; x++)
		{
			// If it's a primary color and we haven't already checked to see if it's clearable
			if(m_pFieldBlocks[x][y].m_iColorIndex >= 0 && m_pFieldBlocks[x][y].m_iColorIndex < 3 && m_pFieldBlocks[x][y].m_iUnfilledColorIndex >= -1)
			{
				DEBUGCLEARBLOCKS("UpdateGlowAlphas calling CheckClearBlocks %i %i\n", x, y);
				possibleblocks = CheckClearBlocks(x, y, m_pFieldBlocks[x][y].m_iColorIndex);

				for(y2 = 0; y2 < BB_FIELDHEIGHT; y2++)
				{
					for(x2 = 0; x2 < BB_FIELDWIDTH; x2++)
					{
						if(m_pFieldBlocks[x2][y2].m_iUnfilledColorIndex == -255)
						{
							if(possibleblocks >= 10)
							{
								m_pFieldBlocks[x2][y2].m_iUnfilledColorIndex = -254;
								xRenderable2DQuadUpdateAlpha(m_pFieldBlocks[x2][y2].m_pBlockGlowObject, 1.0f);
								m_pFieldBlocks[x2][y2].m_bClearable = 1;

								if(bDoClearableWhiteFlash)
									m_pFieldBlocks[x2][y2].m_pBlockObject->m_fAnimationTime = 0.0f;
							}
							else if(possibleblocks >= 4)
							{
								m_pFieldBlocks[x2][y2].m_iUnfilledColorIndex = -254;

								if(g_xGame.m_xPlayer.m_xPiece.m_pBeatMarkerDimmer->m_xRenderable2D.m_bVisible)
									xRenderable2DQuadUpdateAlpha(m_pFieldBlocks[x2][y2].m_pBlockGlowObject, (float)possibleblocks / 20.0f);
								else
									xRenderable2DQuadUpdateAlpha(m_pFieldBlocks[x2][y2].m_pBlockGlowObject, (float)possibleblocks / 10.0f);
							}
							else
							{
								m_pFieldBlocks[x2][y2].m_iUnfilledColorIndex = -253;
								xRenderable2DQuadUpdateAlpha(m_pFieldBlocks[x2][y2].m_pBlockGlowObject, 0.0f);
							}
						}
					}
				}

				if(possibleblocks >= 10)
					m_iClearableBlockCount += possibleblocks;
			}
		}
	}

	for(y = 0; y < BB_FIELDHEIGHT; y++)
	{
		for(x = 0; x < BB_FIELDWIDTH; x++)
		{
			if(m_pFieldBlocks[x][y].m_iUnfilledColorIndex < -1)
				m_pFieldBlocks[x][y].m_iUnfilledColorIndex = -1;
		}
	}
}

void xField::UpdateShadow()
{
	xBlock *curblock, *shadowblock, *updateorder[9] = {0};
	bool movedblock, wouldcausefailure;
	int numdrops, shadowindex[9] = {0}, temp, i;

	for(curblock = g_xGame.m_xPlayer.m_xPiece.m_pBlockList, i = 0; curblock; curblock = curblock->m_pNext, i++)
	{
		shadowblock = &m_pFieldBlocks[m_iShadowPieceX[i]][m_iShadowPieceY[i]];

		if(shadowblock->m_iColorIndex < 0)
		{
			xRenderable2DQuadUpdateVisibility(shadowblock->m_pBlockObject, false);
			xRenderable2DQuadUpdateVisibility(shadowblock->m_pBlockGlowObject, false);
			xRenderable2DQuadUpdateVisibility(shadowblock->m_pBlockOverlayObject, false);
		}

		DEBUGSHADOWPIECE("Setting to Block Texture - %i,%i\n", m_iShadowPieceX[i], m_iShadowPieceY[i]);
		xRenderable2DQuadUpdateTexture(shadowblock->m_pBlockObject, shadowblock->m_pBlockTexture);

		m_iShadowPieceX[i] = BB_FIELD_PIECESTARTX + curblock->m_iColumnID;
		m_iShadowPieceY[i] = BB_FIELD_PIECESTARTY + curblock->m_iRowID;
		DEBUGSHADOWPIECE("UpdateShadow1 - %i - %i %i\n", i, m_iShadowPieceX[i], m_iShadowPieceY[i]);

		temp = ((-1 * curblock->m_iRowID) + 1) * 3 + (-1 * curblock->m_iColumnID) + 1;
		if(temp >= 0 && temp <= 9)
		{
			updateorder[temp] = curblock;
			shadowindex[temp] = i;
		}
	}

	movedblock = true;
	while(movedblock)
	{
		movedblock = false;

		for(i = 0; i < 9; i++)
		{
			curblock = updateorder[i];
			temp = shadowindex[i];

			if(!curblock)
				continue;

			DEBUGSHADOWPIECE("UpdateShadowCheck2 - %i - %i %i - %i %i %i\n", temp, m_iShadowPieceX[temp], m_iShadowPieceY[temp], m_iShadowPieceY[temp] + 1, m_pFieldBlocks[m_iShadowPieceX[temp]][m_iShadowPieceY[temp] + 1].m_iColorIndex, m_pFieldBlocks[m_iShadowPieceX[temp]][m_iShadowPieceY[temp] + 1].m_iUnfilledColorIndex);
			if(m_iShadowPieceY[temp] + 1 < BB_FIELDHEIGHT && (m_iShadowPieceY[temp] + 1 < 0 || (m_pFieldBlocks[m_iShadowPieceX[temp]][m_iShadowPieceY[temp] + 1].m_iColorIndex < 0 && m_pFieldBlocks[m_iShadowPieceX[temp]][m_iShadowPieceY[temp] + 1].m_iUnfilledColorIndex < 0)))
			{
				shadowblock = &m_pFieldBlocks[m_iShadowPieceX[temp]][m_iShadowPieceY[temp]];

				if(shadowblock->m_iColorIndex < 0)
				{
					xRenderable2DQuadUpdateVisibility(shadowblock->m_pBlockObject, false);
					xRenderable2DQuadUpdateVisibility(shadowblock->m_pBlockGlowObject, false);
					xRenderable2DQuadUpdateVisibility(shadowblock->m_pBlockOverlayObject, false);
				}

				DEBUGSHADOWPIECE("Setting to Block Texture - %i,%i\n", m_iShadowPieceX[temp], m_iShadowPieceY[temp]);
				xRenderable2DQuadUpdateTexture(shadowblock->m_pBlockObject, shadowblock->m_pBlockTexture);

				if(m_iShadowPieceY[temp] >= 0)
					shadowblock->m_iUnfilledColorIndex = -1;

				if(m_iShadowPieceY[temp] + 1 >= 0)
					m_pFieldBlocks[m_iShadowPieceX[temp]][m_iShadowPieceY[temp] + 1].m_iUnfilledColorIndex = curblock->m_iUnfilledColorIndex;

				m_iShadowPieceY[temp]++;
				DEBUGSHADOWPIECE("UpdateShadow2 - %i - %i %i\n", temp, m_iShadowPieceX[temp], m_iShadowPieceY[temp]);
				movedblock = true;
			}
			else
				DEBUGSHADOWPIECE("UpdateShadow2 - %i - No Move - %i\n", temp, movedblock);
		}
	}
	
	if(!g_xGame.m_xPlayer.m_xPiece.m_bTouchedDown)
	{
		wouldcausefailure = false;

		for(i -= 1; i >= 0; i--)
		{
			if(m_iShadowPieceY[i] < 0)
			{
				wouldcausefailure = true;
				break;
			}
		}

		for(curblock = g_xGame.m_xPlayer.m_xPiece.m_pBlockList, i = 0; curblock; curblock = curblock->m_pNext, i++)
		{
			DEBUGSHADOWPIECE("UpdateShadow3 - %i - %i %i\n", i, m_iShadowPieceX[i], m_iShadowPieceY[i]);
			if(m_iShadowPieceY[i] < 0)
				continue;

			shadowblock = &m_pFieldBlocks[m_iShadowPieceX[i]][m_iShadowPieceY[i]];

			if(wouldcausefailure)
			{
				xRenderable2DQuadUpdateColor(shadowblock->m_pBlockObject, &g_colFilledBlockColors[0]);
				xRenderable2DQuadUpdateTexture(shadowblock->m_pBlockObject, shadowblock->m_pBlockTexture);
				xRenderable2DQuadUpdateVisibility(shadowblock->m_pBlockGlowObject, 1);
				xRenderable2DQuadUpdateColor(shadowblock->m_pBlockGlowObject, &g_colFilledBlockColors[0]);

				if(g_xGame.m_xPlayer.m_xPiece.m_iUnfilled <= 0)
					xRenderable2DQuadUpdateVisibility(m_pPlacementFailureWarning, 1);
			}
			else
			{
				xRenderable2DQuadUpdateVisibility(m_pPlacementFailureWarning, 0);

				if(curblock->m_iColorIndex < 0)
					xRenderable2DQuadUpdateColor(shadowblock->m_pBlockObject, &g_colFilledBlockColors[shadowblock->m_iUnfilledColorIndex]);
				else
					xRenderable2DQuadUpdateColor(shadowblock->m_pBlockObject, &g_colFilledBlockColors[curblock->m_iColorIndex]);

				DEBUGSHADOWPIECE("Setting to Shadow Texture - %i,%i - %i - %i\n", m_iShadowPieceX[i], m_iShadowPieceY[i], (int)shadowblock->m_pBlockObject, (int)shadowblock->m_pShadowTexture);
				xRenderable2DQuadUpdateTexture(shadowblock->m_pBlockObject, shadowblock->m_pShadowTexture);

				xRenderable2DQuadUpdateVisibility(shadowblock->m_pBlockGlowObject, 0);
			}

			xRenderable2DQuadUpdateVisibility(shadowblock->m_pBlockObject, 1);
			xRenderable2DQuadUpdateVisibility(shadowblock->m_pBlockOverlayObject, 1);
			shadowblock->m_iUnfilledColorIndex = -1;
		}
	}
}

int xField::ClearBlocks(int *pWhiteBlocks, int *pRingsCleared)
{
	xEmitterList *emitter;
	int x, y, x2, y2, colorindex, possibleblocks, blockscleared = 0;
	bool ringcleared;

	DEBUGCLEARBLOCKS("ClearBlocks\n");

	*pWhiteBlocks = 0;
	*pRingsCleared = 0;

	for(y = 0; y < BB_FIELDHEIGHT; y++)
	{
		for(x = 0; x < BB_FIELDWIDTH; x++)
		{
			// If it's a primary color and we haven't already checked to see if it's clearable
			if(m_pFieldBlocks[x][y].m_iColorIndex >= 0 && m_pFieldBlocks[x][y].m_iColorIndex < 3 && m_pFieldBlocks[x][y].m_iUnfilledColorIndex >= -1)
			{
				DEBUGCLEARBLOCKS("ClearBlocks calling CheckClearBlocks %i %i\n", x, y);
				possibleblocks = CheckClearBlocks(x, y, m_pFieldBlocks[x][y].m_iColorIndex);

				for(y2 = 0; y2 < BB_FIELDHEIGHT; y2++)
				{
					for(x2 = 0; x2 < BB_FIELDWIDTH; x2++)
					{
						if(m_pFieldBlocks[x2][y2].m_iUnfilledColorIndex == -255)
						{
							if(possibleblocks >= 10)
							{
								m_pFieldBlocks[x2][y2].m_iUnfilledColorIndex = -254;

								if(m_pFieldBlocks[x2][y2].m_iColorIndex == BB_COLOR_WHITE)
									(*pWhiteBlocks)++;
							}
							else
								m_pFieldBlocks[x2][y2].m_iUnfilledColorIndex = -253;
						}
					}
				}
			}
		}
	}

	emitter = &m_xBlockClearedEmitters;
	while(emitter->m_pNext)
		emitter = emitter->m_pNext;

	for(y = 0; y < BB_FIELDHEIGHT; y++)
	{
		ringcleared = 1;

		for(x = 0; x < BB_FIELDWIDTH; x++)
		{
			m_pFieldBlocks[x][y].m_bClearable = 0;

			if(m_pFieldBlocks[x][y].m_iUnfilledColorIndex == -254)
			{
				blockscleared++;

#if 0 || !defined _DEBUG
				emitter->m_pNext			= new xEmitterList;
				emitter->m_pNext->m_pPrev	= emitter;
				emitter						= emitter->m_pNext;
				emitter->m_pData			= new xEmitter;

				emitter->m_pData->Init(BB_EMITTER_BLOCKCLEARED, BB_DEPTH_BLOCKCLEAREDEMITTER, 0, &g_xGame.m_xSceneGraph);
				emitter->m_pData->SetPosition(m_pFieldBlocks[x][y].m_pBlockObject->m_xRenderable2D.m_fX + m_pFieldBlocks[x][y].m_pBlockObject->m_xRenderable2D.m_fWidth / 2.0, m_pFieldBlocks[x][y].m_pBlockObject->m_xRenderable2D.m_fY + m_pFieldBlocks[x][y].m_pBlockObject->m_xRenderable2D.m_fHeight / 2.0);
				emitter->m_pData->SetColorIndex(m_pFieldBlocks[x][y].m_iColorIndex);
#endif
				for(y2 = y; y2 > 0; y2--)
				{
					if(m_pFieldBlocks[x][y2 - 1].m_iColorIndex >= 0)
					{
						m_pFieldBlocks[x][y2].m_iColorIndex = m_pFieldBlocks[x][y2 - 1].m_iColorIndex;
						xRenderable2DQuadUpdateColor(m_pFieldBlocks[x][y2].m_pBlockObject, &g_colFilledBlockColors[m_pFieldBlocks[x][y2].m_iColorIndex]);
						xRenderable2DQuadUpdateColor(m_pFieldBlocks[x][y2].m_pBlockGlowObject, &g_colBlockGlowColors[m_pFieldBlocks[x][y2].m_iColorIndex]);
					}
					else
					{
						m_pFieldBlocks[x][y2].m_iColorIndex = -1;
						xRenderable2DQuadUpdateVisibility(m_pFieldBlocks[x][y2].m_pBlockObject, false);
						xRenderable2DQuadUpdateVisibility(m_pFieldBlocks[x][y2].m_pBlockGlowObject, false);
						xRenderable2DQuadUpdateVisibility(m_pFieldBlocks[x][y2].m_pBlockOverlayObject, false);
						break;
					}
				}

				m_pFieldBlocks[x][0].m_iColorIndex = -1;
				xRenderable2DQuadUpdateVisibility(m_pFieldBlocks[x][0].m_pBlockObject, false);
				xRenderable2DQuadUpdateVisibility(m_pFieldBlocks[x][0].m_pBlockGlowObject, false);
				xRenderable2DQuadUpdateVisibility(m_pFieldBlocks[x][0].m_pBlockOverlayObject, false);
			}
			else
				ringcleared = 0;

			m_pFieldBlocks[x][y].m_iUnfilledColorIndex = -1;
		}

		if(ringcleared)
			(*pRingsCleared)++;
	}

	UpdateGlowAlphas(0);

	UpdateShadow();

	return blockscleared;
}

FORCE_INLINE int SearchForColor(xField *pThis, int iX, int iY, int iColorIndex, int iSearchColorIndex, int iAltColorIndex)
{
	int x, y, ret = 0;

	if(pThis->SearchForColor(iX, iY, iColorIndex, iSearchColorIndex))
		ret = pThis->CheckClearBlocks(iX, iY, iColorIndex, iSearchColorIndex, iAltColorIndex);

	for(y = 0; y < BB_FIELDHEIGHT; y++)
		for(x = 0; x < BB_FIELDWIDTH; x++)
			if(pThis->m_pFieldBlocks[x][y].m_iUnfilledColorIndex == 100)
				pThis->m_pFieldBlocks[x][y].m_iUnfilledColorIndex = -1;

	DEBUGCLEARBLOCKS("SearchForColor(%i,%i,%i,%i,%i) returning %i\n", iX, iY, iColorIndex, iSearchColorIndex, iAltColorIndex, ret);

	return ret;
}

FORCE_INLINE int InternalCheckClearBlocks(xField *pThis, int iX, int iY, int iOldColorIndex, int iAltColorIndex, int iAltColorIndex2, int iNewColorIndex, int iDebugIndex)
{
	if((iOldColorIndex == BB_COLOR_WHITE && iNewColorIndex <= BB_COLOR_YELLOW) || iNewColorIndex == BB_COLOR_WHITE || iNewColorIndex == iOldColorIndex || iNewColorIndex == iAltColorIndex || iNewColorIndex == iAltColorIndex2)
	{
		DEBUGCLEARBLOCKS("%i. CheckClearBlocks(%i,%i,%i,%i,%i) calling CheckClearBlocks(%i,%i,%i)\n", iDebugIndex, iX, iY, iOldColorIndex, iAltColorIndex, iAltColorIndex2, iX, iY, iNewColorIndex);
		return pThis->CheckClearBlocks(iX, iY, iNewColorIndex, iAltColorIndex, iAltColorIndex2);
	}
	else if(iOldColorIndex == BB_COLOR_RED)
	{
		if(iNewColorIndex == BB_COLOR_PURPLE)
			return SearchForColor(pThis, iX, iY, BB_COLOR_PURPLE, BB_COLOR_BLUE, BB_COLOR_RED);
		else if(iNewColorIndex == BB_COLOR_ORANGE)
			return SearchForColor(pThis, iX, iY, BB_COLOR_ORANGE, BB_COLOR_YELLOW, BB_COLOR_RED);
	}
	else if(iOldColorIndex == BB_COLOR_BLUE)
	{
		if(iNewColorIndex == BB_COLOR_PURPLE)
			return SearchForColor(pThis, iX, iY, BB_COLOR_PURPLE, BB_COLOR_RED, BB_COLOR_BLUE);
		else if(iNewColorIndex == BB_COLOR_GREEN)
			return SearchForColor(pThis, iX, iY, BB_COLOR_GREEN, BB_COLOR_YELLOW, BB_COLOR_BLUE);
	}
	else if(iOldColorIndex == BB_COLOR_YELLOW)
	{
		if(iNewColorIndex == BB_COLOR_ORANGE)
			return SearchForColor(pThis, iX, iY, BB_COLOR_ORANGE, BB_COLOR_RED, BB_COLOR_YELLOW);
		else if(iNewColorIndex == BB_COLOR_GREEN)
			return SearchForColor(pThis, iX, iY, BB_COLOR_GREEN, BB_COLOR_BLUE, BB_COLOR_YELLOW);
	}

	return 0;
}

int xField::CheckClearBlocks(int iX, int iY, int iColorIndex, int iAltColorIndex, int iAltColorIndex2)
{
	int x, y, ret = 1;

	m_pFieldBlocks[iX][iY].m_iUnfilledColorIndex = -255;

	if(iY > 0 && m_pFieldBlocks[iX][iY - 1].m_iColorIndex != -1 && m_pFieldBlocks[iX][iY - 1].m_iUnfilledColorIndex >= -1)
		ret += InternalCheckClearBlocks(this, iX, iY - 1, iColorIndex, iAltColorIndex, iAltColorIndex2, m_pFieldBlocks[iX][iY - 1].m_iColorIndex, 1);

	x = iX == 0 ? BB_FIELDWIDTH - 1 : iX - 1;
	if(m_pFieldBlocks[x][iY].m_iColorIndex != -1 && m_pFieldBlocks[x][iY].m_iUnfilledColorIndex >= -1)
		ret += InternalCheckClearBlocks(this, x, iY, iColorIndex, iAltColorIndex, iAltColorIndex2, m_pFieldBlocks[x][iY].m_iColorIndex, 2);

	x = iX + 1 < BB_FIELDWIDTH ? iX + 1 : 0;
	if(m_pFieldBlocks[x][iY].m_iColorIndex != -1 && m_pFieldBlocks[x][iY].m_iUnfilledColorIndex >= -1)
		ret += InternalCheckClearBlocks(this, x, iY, iColorIndex, iAltColorIndex, iAltColorIndex2, m_pFieldBlocks[x][iY].m_iColorIndex, 3);

	if(iY < BB_FIELDHEIGHT - 1 && m_pFieldBlocks[iX][iY + 1].m_iColorIndex != -1 && m_pFieldBlocks[iX][iY + 1].m_iUnfilledColorIndex >= -1)
		ret += InternalCheckClearBlocks(this, iX, iY + 1, iColorIndex, iAltColorIndex, iAltColorIndex2, m_pFieldBlocks[iX][iY + 1].m_iColorIndex, 4);

	DEBUGCLEARBLOCKS("5. CheckClearBlocks(%i,%i,%i) returning %i\n", iX, iY, iColorIndex, ret);

	return ret;
}

bool xField::SearchForColor(int iX, int iY, int iStartColorIndex, int iSearchColorIndex)
{
	int x, y, ret = 1;

	if(m_pFieldBlocks[iX][iY].m_iUnfilledColorIndex < -1 || m_pFieldBlocks[iX][iY].m_iUnfilledColorIndex >= 100)
	{
		DEBUGCLEARBLOCKS("xField::SearchForColor(%i,%i,%i,%i) returning false1\n", iX, iY, iStartColorIndex, iSearchColorIndex);
		return false;
	}

	m_pFieldBlocks[iX][iY].m_iUnfilledColorIndex = 100;

	if(iY > 0 && ((m_pFieldBlocks[iX][iY - 1].m_iColorIndex == iStartColorIndex && SearchForColor(iX, iY - 1, iStartColorIndex, iSearchColorIndex)) || m_pFieldBlocks[iX][iY - 1].m_iColorIndex == iSearchColorIndex))
		return true;

	x = iX == 0 ? BB_FIELDWIDTH - 1 : iX - 1;
	if((m_pFieldBlocks[x][iY].m_iColorIndex == iStartColorIndex && SearchForColor(x, iY, iStartColorIndex, iSearchColorIndex)) || m_pFieldBlocks[x][iY].m_iColorIndex == iSearchColorIndex)
		return true;

	x = iX + 1 < BB_FIELDWIDTH ? iX + 1 : 0;
	if((m_pFieldBlocks[x][iY].m_iColorIndex == iStartColorIndex && SearchForColor(x, iY, iStartColorIndex, iSearchColorIndex)) || m_pFieldBlocks[x][iY].m_iColorIndex == iSearchColorIndex)
		return true;

	if(iY < BB_FIELDHEIGHT - 1 && ((m_pFieldBlocks[iX][iY + 1].m_iColorIndex == iStartColorIndex && SearchForColor(iX, iY + 1, iStartColorIndex, iSearchColorIndex)) || m_pFieldBlocks[iX][iY + 1].m_iColorIndex == iSearchColorIndex))
		return true;

	DEBUGCLEARBLOCKS("xField::SearchForColor(%i,%i,%i,%i) returning false2\n", iX, iY, iStartColorIndex, iSearchColorIndex);
	return false;
}

void xField::ForceFinishRotation()
{
	float centerx, centery, fx, fy, halfwidth, halfheight, tempfloat, glowscalex, glowscaley;
	int i, j;

	DEBUGSHADOWPIECE("ForceFinishRotation\n");

	m_fRotationTime = BB_FIELD_ROTATETIME;

	centerx = BB_FIELDX + m_pBackgroundObject->m_xRenderable2D.m_fWidth / 2.0;
	centery = BB_FIELDY + m_pBackgroundObject->m_xRenderable2D.m_fHeight / 2.0;

	for(i = 0; i < BB_FIELDHEIGHT; i++)
	{
		halfwidth = (float)m_pFieldBlocks[0][i].m_pBlockTexture->m_iWidth / 2.0;
		halfheight = (float)m_pFieldBlocks[0][i].m_pBlockTexture->m_iHeight / 2.0;

		glowscalex = (float)m_pFieldBlocks[0][i].m_pBlockObject->m_xRenderable2D.m_fWidth / (float)m_pFieldBlocks[0][5].m_pBlockObject->m_xRenderable2D.m_fWidth;
		glowscaley = (float)m_pFieldBlocks[0][i].m_pBlockObject->m_xRenderable2D.m_fHeight / (float)m_pFieldBlocks[0][5].m_pBlockObject->m_xRenderable2D.m_fHeight;

		for(j = 0; j < BB_FIELDWIDTH; j++)
		{
			xRenderable2DQuadUpdateVisibility(m_pBlockAnimationObject[i], false);

			if(m_pFieldBlocks[j][i].m_iColorIndex >= 0)
			{
				tempfloat = (2.0f * PI) / BB_FIELDWIDTH;
				//tempfloat = (2.0f * PI * m_fRotationTime) / (BB_FIELDWIDTH * BB_FIELD_ROTATETIME);

				if(m_bRotateClockwise)
					tempfloat = ((float)j + 1.0f) * ((2.0f * PI) / BB_FIELDWIDTH) - tempfloat;
				else
					tempfloat = ((float)j - 1.0f) * ((2.0f * PI) / BB_FIELDWIDTH) + tempfloat;
				//tempfloat = ((float)j + 1.0f) * ((2.0f * PI) / BB_FIELDWIDTH);

				fx = centerx + cos(tempfloat) * g_fRingDistances[i];
				fy = centery - sin(tempfloat) * g_fRingDistances[i];

				xRenderable2DQuadSetPosition(m_pFieldBlocks[j][i].m_pBlockObject, fx - halfwidth, fy - halfheight);
				xRenderable2DQuadSetRotation(m_pFieldBlocks[j][i].m_pBlockObject, 90 + -tempfloat * (180.0f / PI));
				xRenderable2DQuadUpdate(m_pFieldBlocks[j][i].m_pBlockObject);

				xRenderable2DQuadSetPosition(m_pFieldBlocks[j][i].m_pBlockGlowObject, m_pFieldBlocks[j][i].m_pBlockObject->m_xRenderable2D.m_fX - 24.0f * glowscalex, m_pFieldBlocks[j][i].m_pBlockObject->m_xRenderable2D.m_fY - 24.0f * glowscaley);
				xRenderable2DQuadSetRotation(m_pFieldBlocks[j][i].m_pBlockGlowObject, m_pFieldBlocks[j][i].m_pBlockObject->m_xRenderable2D.m_fRotation);
				xRenderable2DQuadUpdate(m_pFieldBlocks[j][i].m_pBlockGlowObject);

				xRenderable2DQuadSetPosition(m_pFieldBlocks[j][i].m_pBlockOverlayObject, m_pFieldBlocks[j][i].m_pBlockObject->m_xRenderable2D.m_fX, m_pFieldBlocks[j][i].m_pBlockObject->m_xRenderable2D.m_fY);
				xRenderable2DQuadSetRotation(m_pFieldBlocks[j][i].m_pBlockOverlayObject, m_pFieldBlocks[j][i].m_pBlockObject->m_xRenderable2D.m_fRotation);
				xRenderable2DQuadUpdate(m_pFieldBlocks[j][i].m_pBlockOverlayObject);

				xRenderable2DQuadUpdateColor(m_pFieldBlocks[j][i].m_pBlockObject, &g_colFilledBlockColors[m_pFieldBlocks[j][i].m_iColorIndex]);
			}
		}
	}
}
