/////////////////////////////////////////////////////////////////
// Name: xGUICheckBox.h
/////////////////////////////////////////////////////////////////
// Description:
// - A check box on the UI.
/////////////////////////////////////////////////////////////////
// - 07.11.2004, Note, DayleFlowers (Xienen)
//   File created
/////////////////////////////////////////////////////////////////
#ifndef XGUICHECKBOX_H_
#define XGUICHECKBOX_H_

#include "xGUIObject.h"
#include "xGUIText.h"

enum xGUICheckBoxState
{
	PE_GUI_CHECKBOXSTATE_NONE = 0,
	PE_GUI_CHECKBOXSTATE_HOVER,
	PE_GUI_CHECKBOXSTATE_CLICKED,
	PE_GUI_CHECKBOXSTATE_CHECKED,
	PE_GUI_CHECKBOXSTATE_CHECKEDHOVER
};

void xGUICheckBoxPreUpdate(xGUIObject* pThis, DWORD dwTime);
void xGUICheckBoxClearState(xGUIObject* pThis, DWORD dwTime);
void xGUICheckBoxUpdate(xGUIObject* pThis, double dTime);
void xGUICheckBoxUpdateRenderables(xGUIObject* pThis);
void xGUICheckBoxRefreshRenderables(xGUIObject* pThis);

class xGUICheckBox : public xGUIObject
{
public:
	xGUICheckBox()
	{
		pfnPreUpdate			= &xGUICheckBoxPreUpdate;
		pfnClearState			= &xGUICheckBoxClearState;
		pfnUpdate				= &xGUICheckBoxUpdate;
		pfnUpdateRenderables	= &xGUICheckBoxUpdateRenderables;
		pfnRefreshRenderables	= &xGUICheckBoxRefreshRenderables;

		m_iCheckBoxState	= PE_GUI_CHECKBOXSTATE_NONE;
		m_bWasClicked		= false;
		m_bChecked			= false;

		m_pTextObject	= NULL;
	}

	int  LoadObject(const char *strThemeName);
	void Shutdown();

	void SetState(xGUICheckBoxState iState) { m_iCheckBoxState = iState; xRenderable2DQuadUpdateTexture(m_pBackground, m_pTextures[iState]); }
	void SetValue(bool bNewValue) { m_bChecked = bNewValue; SetState(m_bChecked ? PE_GUI_CHECKBOXSTATE_CHECKED : PE_GUI_CHECKBOXSTATE_NONE); }

	char				  m_strBackgroundPath[256];
	xRenderable2DQuad	 *m_pBackground;
	xTexture			**m_pTextures;
	xGUIText			 *m_pTextObject;
	xGUICheckBoxState	  m_iCheckBoxState;
	bool				  m_bWasClicked;
	bool				  m_bChecked;
};

#endif