/////////////////////////////////////////////////////////////////
// Name: xGUIComboBox.h
/////////////////////////////////////////////////////////////////
// Description:
// - This handles combo boxes for the GUI.
/////////////////////////////////////////////////////////////////
// - 07.11.2004, Note, DayleFlowers (Xienen)
//   File created
/////////////////////////////////////////////////////////////////
#ifndef XGUICOMBOBOX_H_
#define XGUICOMBOBOX_H_

#include "xGUIObject.h"
#include "xGUITextBox.h"
#include "xGUIButton.h"
#include "xGUIListBox.h"

void xGUIComboBoxPreUpdate(xGUIObject* pThis, DWORD dwTime);
//void xGUIComboBoxUpdate(xGUIObject* pThis, double dTime);
void xGUIComboBoxUpdateRenderables(xGUIObject* pThis);
void xGUIComboBoxRefreshRenderables(xGUIObject* pThis);

class xGUIComboBox : public xGUIObject
{
public:
	xGUIComboBox()
	{
		pfnPreUpdate			= &xGUIComboBoxPreUpdate;
		//pfnUpdate				= &xGUIComboBoxUpdate;
		pfnUpdateRenderables	= &xGUIComboBoxUpdateRenderables;
		pfnRefreshRenderables	= &xGUIComboBoxRefreshRenderables;

		m_bListVisible	= 0;
	}

	void InitRenderable(const char *strThemeName, const char *strTextBoxBackground, const char *strButtonBackground, const char *strListBoxBackground, const char *strListBoxSelectedBackground, const char *strScrollbarBackground, const char *strScrollUpArrowBackground, const char *strScrollDownArrowBackground, const char *strScrollThumb);
	int  LoadObject(const char *strThemeName);
	void Shutdown();

	void  AddItem(const char* strNewItem) { m_xListBox.AddItem(strNewItem); }
	int   GetNumItems() { return m_xListBox.m_iNumItems; }
	bool  SetSelectedByString(const char *strItem) { if(m_xListBox.SetSelectedByString(strItem)) { m_xTextBox.SetText(m_xListBox.GetSelectedString()); return true; } return false; }
	int   GetSelectedIndex() { return m_xListBox.GetSelectedIndex(); }
	char* GetSelectedString() { return m_xListBox.GetSelectedString(); }

	// Settings
	float	m_fTextBoxBorder;
	float	m_fDownButtonWidth;
	float	m_fDownButtonHeight;
	float	m_fDownButtonButtonOffsetX;
	float	m_fDownButtonButtonOffsetY;
	float	m_fListHeight;
	float	m_fListBorder;
	float	m_fListOffsetY;
	bool	m_bListScrollbarInset;
	float	m_fListScrollbarOffsetX;
	float	m_fListScrollbarWidth;

	// Components
	xGUITextBox	m_xTextBox;
	xGUIButton	m_xDownButton;
	xGUIListBox	m_xListBox;

	// Status Variables
	int  m_iSelected;
	bool m_bListVisible;
};

#endif