#include "Paper.h"

void xGUIListBox::InitRenderable(const char *strThemeName, const char *strBackground, const char *strSelectedBackground, const char *strScrollbarBG, const char *strScrollbarThumb, const char *strScrollbarUpArrow, const char *strScrollbarDownArrow)
{
	char backgroundpath[256] = {0};

	if(!strBackground || strBackground[0] == '\0')
		sprintf(backgroundpath, "Data/Themes/%s/ListBoxBG.p2d", strThemeName);
	else
		strcpy(backgroundpath, strBackground);

	if(m_bStretch)
	{
		m_pBackground = xSceneGraphCreateQuad(backgroundpath, 0);
		xRenderable2DQuadSetPosition(m_pBackground, GetAbsoluteX(), GetAbsoluteY());
		xRenderable2DQuadSetSize(m_pBackground, GetWidth(), GetHeight());
		xSceneGraphInsertQuad(m_pSceneGraph, m_pBackground, 9, GetAbsoluteDepth());
		xRenderable2DQuad9Update(m_pBackground);
	}
	else
	{
		m_pBackground = xSceneGraphCreateQuad(backgroundpath, 0);
		xRenderable2DQuadSetPosition(m_pBackground, GetAbsoluteX(), GetAbsoluteY());
		xSceneGraphInsertQuad(m_pSceneGraph, m_pBackground, 1, GetAbsoluteDepth());
		xRenderable2DQuadUpdate(m_pBackground);
	}

	if(!strSelectedBackground || strSelectedBackground[0] == '\0')
		sprintf(backgroundpath, "Data/Themes/%s/ListBoxSelectionBG.p2d", strThemeName);
	else
		strcpy(backgroundpath, strSelectedBackground);

	m_pSelectedBackground = xSceneGraphCreateQuad(backgroundpath, 0);
	xSceneGraphInsertQuad(m_pSceneGraph, m_pSelectedBackground, 1, GetAbsoluteDepth() + 0.001);
	xRenderable2DQuadUpdateVisibility(m_pSelectedBackground, false);
	xRenderable2DQuadUpdate(m_pSelectedBackground);

	m_iNumItems = 0;
	m_iNumVisibleItems = GetHeight() / (((float)xFontGetSize(m_pFont)) + m_fItemSpacing);
	m_iTopVisibleItem = 0;

	m_pTextObjects = (xRenderable2DText*)dlmalloc(sizeof(xRenderable2DText) * m_iNumVisibleItems);

	if(m_bScrollbar)
	{
		m_pScrollbar = new xGUIScrollbar;
		m_pScrollbar->Init();
		m_pScrollbar->m_pParent = this;
		m_pScrollbar->m_pGUI = m_pGUI;
		m_pScrollbar->m_pOwningWindow = m_pOwningWindow;
		m_pScrollbar->m_pSceneGraph = m_pSceneGraph;
		m_pScrollbar->m_iVisibleObjects = m_iNumVisibleItems;
		m_pScrollbar->m_fScrollButtonWidth = m_iScrollbarWidth;
		m_pScrollbar->m_fScrollButtonHeight = m_iScrollbarWidth;
		m_pScrollbar->SetDepth(0.005);
		m_pScrollbar->SetX(GetWidth() + m_fScrollbarOffset);
		m_pScrollbar->SetY(m_fBorder);
		m_pScrollbar->SetWidth(m_iScrollbarWidth);
		m_pScrollbar->SetHeight(GetHeight() - m_fBorder * 2);
		m_pScrollbar->InitRenderable(strThemeName, strScrollbarBG, strScrollbarThumb, strScrollbarUpArrow, strScrollbarDownArrow);
	}
}

int xGUIListBox::LoadObject(const char *strThemeName)
{
	xGUIObject::LoadObject(strThemeName);

	m_fBorder			= m_pParser->ToFlt("m_fBorder");
	m_fItemSpacing		= m_pParser->ToFlt("m_fItemSpacing");
	m_bScrollbar		= m_pParser->ToBool("m_bScrollbar");
	m_iScrollbarWidth	= m_pParser->ToInt("m_iScrollbarWidth");
	m_fScrollbarOffset	= m_pParser->ToFlt("m_fScrollbarOffset", m_fBorder);

	if(m_bScrollbar)
		SetWidth(GetWidth() - m_iScrollbarWidth - m_fBorder);

	InitRenderable(strThemeName, m_pParser->GetVariable("m_strBackground"), m_pParser->GetVariable("m_strSelectedBackground"), m_pParser->GetVariable("m_strScrollbarBG"), m_pParser->GetVariable("m_strScrollbarThumb"), m_pParser->GetVariable("m_strScrollbarUpArrow"), m_pParser->GetVariable("m_strScrollbarDownArrow"));

	return PE_RES_NOERROR;
}

void xGUIListBoxPreUpdate(xGUIObject* pThis, DWORD dwTime)
{
	int oldtopobject;

	if(!pThis->m_pParent->GetAbsoluteFocus())
		pThis->m_bHasFocus = false;

	xGUIObjectPreUpdate(pThis, dwTime);

	if(((xGUIListBox*)pThis)->m_bScrollbar)
	{
		oldtopobject = ((xGUIListBox*)pThis)->m_iTopVisibleItem;

		((xGUIListBox*)pThis)->m_pScrollbar->pfnPreUpdate(((xGUIListBox*)pThis)->m_pScrollbar, dwTime);

		((xGUIListBox*)pThis)->m_iTopVisibleItem = ((xGUIListBox*)pThis)->m_pScrollbar->m_iTopObject;

		if(((xGUIListBox*)pThis)->m_iTopVisibleItem != oldtopobject)
			xGUIListBoxUpdateRenderables(pThis);
	}

	if(g_xPaperAPI.m_xInput.m_lMouseX > pThis->GetAbsoluteX() && g_xPaperAPI.m_xInput.m_lMouseX < pThis->GetAbsoluteX() + pThis->GetWidth() &&
	   g_xPaperAPI.m_xInput.m_lMouseY > pThis->GetAbsoluteY() && g_xPaperAPI.m_xInput.m_lMouseY < pThis->GetAbsoluteY() + pThis->GetHeight())
	{
		if(g_xPaperAPI.m_xInput.m_buttonMouseLeft.JustPressed(true))
		{
			g_xPaperAPI.m_xInput.m_buttonMouseLeft.Eaten();

			pThis->m_bHasFocus = true;

			if(!((xGUIListBox*)pThis)->m_bScrollbar || g_xPaperAPI.m_xInput.m_lMouseX < ((xGUIListBox*)pThis)->m_pScrollbar->GetAbsoluteX())
			{
				((xGUIListBox*)pThis)->m_iSelected = ((xGUIListBox*)pThis)->m_iTopVisibleItem + ((g_xPaperAPI.m_xInput.m_lMouseY - pThis->GetAbsoluteY()) / (xFontGetSize(pThis->m_pFont) + ((xGUIListBox*)pThis)->m_fItemSpacing));

				if(((xGUIListBox*)pThis)->m_iSelected >= 0 && ((xGUIListBox*)pThis)->m_iSelected < ((xGUIListBox*)pThis)->m_iNumItems)
				{
					if(dwTime - pThis->PressTime() < 300) //Set Clicked only on Double Click
					{
						pThis->m_bClicked = true;

						if(pThis->m_strDblClickCommand)
							pThis->m_pGUI->pfnRunInputCommand(pThis->m_strDblClickCommand, pThis->m_strDblClickParams, pThis->m_pOwningWindow, pThis);

						if(pThis->m_pDblClickSound)
							pThis->m_pDblClickSound->Play(g_xPaperAPI.m_fVolume);
					}
					else
						pThis->SetPressTime(dwTime);

					xRenderable2DQuadSetPosition(((xGUIListBox*)pThis)->m_pSelectedBackground, ((xGUIListBox*)pThis)->m_pSelectedBackground->m_xRenderable2D.m_fX, pThis->GetAbsoluteY() + (((xGUIListBox*)pThis)->m_fBorder / 2.0) + ((xGUIListBox*)pThis)->GetItemY(((xGUIListBox*)pThis)->m_iSelected));
					xRenderable2DQuadUpdateVisibility(((xGUIListBox*)pThis)->m_pSelectedBackground, true);
					xRenderable2DQuadUpdate(((xGUIListBox*)pThis)->m_pSelectedBackground);
				}
				else
					xRenderable2DQuadUpdateVisibility(((xGUIListBox*)pThis)->m_pSelectedBackground, false);
			}
		}
		else
			pThis->m_bClicked = false;
	}
	else
	{
		pThis->m_bClicked = false;

		if(g_xPaperAPI.m_xInput.m_buttonMouseLeft.JustPressed())
			pThis->m_bHasFocus = false;
	}

	if(g_xPaperAPI.m_bHasFocus && pThis->m_bHasFocus)
	{
		if(g_xPaperAPI.m_xInput.m_keyEnter.IsDown() || g_xPaperAPI.m_xInput.m_keyNumEnter.IsDown())
		{
			if(pThis->m_strEnterPressCommand)
			{
				if(g_xPaperAPI.m_xInput.m_keyEnter.JustPressed() || g_xPaperAPI.m_xInput.m_keyNumEnter.JustPressed())
				{
					pThis->m_pGUI->pfnRunInputCommand(pThis->m_strEnterPressCommand, pThis->m_strEnterPressParams, pThis->m_pOwningWindow, pThis);
					g_xPaperAPI.m_xInput.m_keyEnter.Eaten();
					g_xPaperAPI.m_xInput.m_keyNumEnter.Eaten();

					if(pThis->m_pEnterPressSound)
						pThis->m_pEnterPressSound->Play(g_xPaperAPI.m_fVolume);
				}
			}
		}
	}
}

void xGUIListBoxUpdate(xGUIObject* pThis, double dTime)
{
	xColor tempcolor;

	if(!pThis->m_pParent->GetAbsoluteFocus())
		pThis->m_bHasFocus = false;

	if(!pThis->m_xAnimation.m_bDone)
		xAnimationUpdate(&pThis->m_xAnimation, dTime);

	if(((xGUIListBox*)pThis)->m_bScrollbar)
		((xGUIListBox*)pThis)->m_pScrollbar->pfnUpdate(((xGUIListBox*)pThis)->m_pScrollbar, dTime);

	xGUIObjectUpdate(pThis, dTime);
}

void xGUIListBoxUpdateRenderables(xGUIObject* pThis)
{
	xColor tempcolor;
	int i;
	float listboxx = pThis->GetAbsoluteX();
	float listboxy = pThis->GetAbsoluteY();
	bool visible = !pThis->GetAbsoluteHidden();

	xRenderable2DQuadSetPosition(((xGUIListBox*)pThis)->m_pBackground, listboxx, listboxy);
	xRenderable2DQuadUpdateAlpha(((xGUIListBox*)pThis)->m_pBackground, pThis->GetAbsoluteColor(&tempcolor)->A);
	xRenderable2DQuadUpdateVisibility(((xGUIListBox*)pThis)->m_pBackground, visible);

	if(pThis->m_bStretch)
		xRenderable2DQuad9Update(((xGUIListBox*)pThis)->m_pBackground);
	else
		xRenderable2DQuadUpdate(((xGUIListBox*)pThis)->m_pBackground);

	xList<char> *curentryitem = ((xGUIListBox*)pThis)->m_xStringItemList.m_pNext;
	for(i = 0; i < ((xGUIListBox*)pThis)->m_iTopVisibleItem; i++)
	{
		if(i == ((xGUIListBox*)pThis)->m_iSelected)
			xRenderable2DQuadUpdateVisibility(((xGUIListBox*)pThis)->m_pSelectedBackground, false);

		curentryitem = curentryitem->m_pNext;
	}

	for(i = 0; i < ((xGUIListBox*)pThis)->m_iNumVisibleItems && i < ((xGUIListBox*)pThis)->m_iNumItems; i++)
	{
		xRenderable2DTextSetPosition(&((xGUIListBox*)pThis)->m_pTextObjects[i], listboxx + ((xGUIListBox*)pThis)->m_fBorder, listboxy + ((xGUIListBox*)pThis)->m_fBorder + ((xGUIListBox*)pThis)->GetItemY(((xGUIListBox*)pThis)->m_iTopVisibleItem + i));
		xRenderable2DTextUpdateAlpha(&((xGUIListBox*)pThis)->m_pTextObjects[i], tempcolor.A);
		xRenderable2DTextUpdateVisibility(&((xGUIListBox*)pThis)->m_pTextObjects[i], visible);
		xRenderable2DTextSetText(&((xGUIListBox*)pThis)->m_pTextObjects[i], pThis->m_pSceneGraph, curentryitem->m_pData);
		curentryitem = curentryitem->m_pNext;

		if(i + ((xGUIListBox*)pThis)->m_iTopVisibleItem == ((xGUIListBox*)pThis)->m_iSelected)
		{
			xRenderable2DQuadSetPosition(((xGUIListBox*)pThis)->m_pSelectedBackground, listboxx + (((xGUIListBox*)pThis)->m_fBorder / 2.0), listboxy + (((xGUIListBox*)pThis)->m_fBorder / 2.0) + ((xGUIListBox*)pThis)->GetItemY(((xGUIListBox*)pThis)->m_iSelected));
			xRenderable2DQuadUpdateVisibility(((xGUIListBox*)pThis)->m_pSelectedBackground, true);
		}
	}

	if(!visible || ((xGUIListBox*)pThis)->m_iSelected >= ((xGUIListBox*)pThis)->m_iTopVisibleItem + ((xGUIListBox*)pThis)->m_iNumVisibleItems)
		xRenderable2DQuadUpdateVisibility(((xGUIListBox*)pThis)->m_pSelectedBackground, false);

	xRenderable2DQuadUpdate(((xGUIListBox*)pThis)->m_pSelectedBackground);
	xRenderable2DQuadUpdateAlpha(((xGUIListBox*)pThis)->m_pSelectedBackground, tempcolor.A);

	if(((xGUIListBox*)pThis)->m_bScrollbar)
		xGUIScrollbarUpdateRenderables(((xGUIListBox*)pThis)->m_pScrollbar);
}

void xGUIListBoxUpdateDepth(xGUIObject* pThis)
{
	int i;

	xRenderable2DQuadUpdateDepth(((xGUIListBox*)pThis)->m_pBackground, pThis->m_pSceneGraph, pThis->GetAbsoluteDepth());
	xRenderable2DQuadUpdateDepth(((xGUIListBox*)pThis)->m_pSelectedBackground, pThis->m_pSceneGraph, pThis->GetAbsoluteDepth() + 0.001);

	for(i = 0; i < ((xGUIListBox*)pThis)->m_iNumVisibleItems && i < ((xGUIListBox*)pThis)->m_iNumItems; i++)
		xRenderable2DTextUpdateDepth(&((xGUIListBox*)pThis)->m_pTextObjects[i], pThis->m_pSceneGraph, pThis->GetAbsoluteDepth() + 0.002);
}

void xGUIListBoxRefreshRenderables(xGUIObject* pThis)
{
	int i;

	xRenderable2DQuadUpdateTexture(((xGUIListBox*)pThis)->m_pBackground, ((xGUIListBox*)pThis)->m_pBackground->m_pTextures[0]);
	xRenderable2DQuadUpdateTexture(((xGUIListBox*)pThis)->m_pSelectedBackground, ((xGUIListBox*)pThis)->m_pSelectedBackground->m_pTextures[0]);

	for(i = 0; i < ((xGUIListBox*)pThis)->m_iNumVisibleItems && i < ((xGUIListBox*)pThis)->m_iNumItems; i++)
		xRenderable2DTextRefreshTextures(&((xGUIListBox*)pThis)->m_pTextObjects[i]);

	xGUIListBoxUpdateRenderables(pThis);
}

void xGUIListBox::Shutdown()
{
	int i;

	xGUIObject::Shutdown();

	if(m_pBackground)
		xSceneGraphDeleteQuad(m_pSceneGraph, m_pBackground, false);

	if(m_pSelectedBackground)
		xSceneGraphDeleteQuad(m_pSceneGraph, m_pSelectedBackground, false);

	if(m_pTextObjects)
	{
		for(i = 0; i < m_iNumVisibleItems && i < m_iNumItems; i++)
			xRenderable2DTextDelete(&m_pTextObjects[i], m_pSceneGraph);

		dlfree(m_pTextObjects);
	}

	if(m_pScrollbar)
	{
		m_pScrollbar->Shutdown();
		delete m_pScrollbar;
	}
}

void xGUIListBox::AddItem(const char* strNewItem)
{
	xList<char> *curitem = &m_xStringItemList;
	while(curitem->m_pNext)
		curitem = curitem->m_pNext;

	curitem->m_pNext = new xList<char>;
	curitem->m_pNext->m_pPrev = curitem;
	curitem->m_pNext->m_pData = new char[strlen(strNewItem) + 1];
	strcpy(curitem->m_pNext->m_pData, strNewItem);

	if(m_iNumItems < m_iNumVisibleItems)
	{
		if(m_iNumItems == 0)
		{
			m_iSelected = 0;
			xRenderable2DQuadSetPosition(m_pSelectedBackground, GetAbsoluteX() + (m_fBorder / 2.0), GetAbsoluteY() + (m_fBorder / 2.0));
			xRenderable2DQuadSetSize(m_pSelectedBackground, GetWidth() - m_fBorder + (m_fScrollbarOffset < 0 ? m_fScrollbarOffset : 0), xFontGetSize(m_pFont) + (m_fItemSpacing / 2.0));
			xRenderable2DQuadUpdateVisibility(m_pSelectedBackground, true);
			xRenderable2DQuadUpdate(m_pSelectedBackground);
		}

		xRenderable2DTextInit(&m_pTextObjects[m_iNumItems], GetAbsoluteDepth() + 0.002);
		xRenderable2DTextSetPosition(&m_pTextObjects[m_iNumItems], GetAbsoluteX() + m_fBorder, GetAbsoluteY() + m_fBorder + GetItemY(m_iNumItems));
		xRenderable2DTextSetFont(&m_pTextObjects[m_iNumItems], m_pFont);
		xRenderable2DTextSetText(&m_pTextObjects[m_iNumItems], m_pSceneGraph, strNewItem);
	}

	m_iNumItems++;

	if(m_bScrollbar)
	{
		m_pScrollbar->m_iNumObjects = m_iNumItems;
		xGUIScrollbarUpdateRenderables(m_pScrollbar);
	}
}

char* xGUIListBox::GetSelectedString()
{
	xList<char> *curitem = &m_xStringItemList;
	for(int i = 0; curitem->m_pNext; i++)
	{
		curitem = curitem->m_pNext;

		if(i == m_iSelected)
			return curitem->m_pData;
	}

	return NULL;
}

bool xGUIListBox::SetSelectedByString(const char *strItem)
{
	xList<char> *curitem = &m_xStringItemList;
	for(int i = 0; curitem->m_pNext; i++)
	{
		curitem = curitem->m_pNext;

		if(!stricmp(curitem->m_pData, strItem))
		{
			m_iSelected = i;
			return true;
		}
	}

	return false;
}
