#include "Paper.h"

void xGUIObject::Init()
{
	xRenderable2DInit(&m_xRenderable);
	xAnimationInit(&m_xAnimation, this, &m_xRenderable, pfnUpdateRenderables);
}

int xGUIObject::Init(const char *strThemeName)
{
	bool loaded = false;

	Init();

	char function[256], params[3][52];
	while(!m_pParser->ReadLine(function, params[0], params[1], params[2]))
	{
		if(!stricmp(function, "EndObject"))
		{
			if(!loaded)
				return LoadObject(strThemeName);
			else
				break;
		}
		else if(!stricmp(function, "AddChildObject"))
		{
			if(!loaded)
			{
				LoadObject(strThemeName);
				loaded = true;
			}

			m_strThemeName = strThemeName;

			if(AddChildObject(params[0]))
				assert(0);
		}
		else if(!stricmp(function, "StartAnimation"))
		{
			if(!loaded)
			{
				LoadObject(strThemeName);
				loaded = true;
			}

			LoadAnimation();
		}
	}

	return PE_RES_NOERROR;
}

int xGUIObject::LoadObject(const char *strThemeName)
{
	char tempcommand[256] = {0};
	char **tempparams;
	int tempnumparams;
	char *tempvariable;

	m_pFont = m_pGUI->GetFont(m_pParser->GetVariable("m_strFontName"));

	SetDepth(m_pParser->ToFlt("m_fDepth"));
	SetX(m_pParser->ToFlt("m_iX"));
	SetY(m_pParser->ToFlt("m_iY"));
	SetWidth(m_pParser->ToFlt("m_iWidth"));
	SetHeight(m_pParser->ToFlt("m_iHeight"));
	SetRotation(m_pParser->ToFlt("m_fRotation"));
	SetScale(m_pParser->ToFlt("m_fScaleX", 1.0), m_pParser->ToFlt("m_fScaleY", 1.0));
	SetHidden(m_pParser->ToBool("m_bHidden"));
	m_bHasFocus	= m_pParser->ToBool("m_bHasFocus");
	m_bSelected	= m_pParser->ToBool("m_bSelected");
	m_bDisabled	= m_pParser->ToBool("m_bDisabled");
	m_bStretch	= m_pParser->ToBool("m_bStretch");
	m_dwHoverDelay = m_pParser->ToDWd("m_iHoverDelay", m_dwHoverDelay);

	SetName(m_pParser->GetVariable("m_strName"));

	tempvariable = m_pParser->GetVariable("m_strLClickCommand");
	if(tempvariable && tempvariable[0] != '\0')
	{
		m_strLClickCommand = new char[256];
		memset(m_strLClickCommand, 0, 256);
		GetCommandAndParams(m_strLClickCommand, m_strLClickParams, tempvariable);
	}

	tempvariable = m_pParser->GetVariable("m_strDblClickCommand");
	if(tempvariable && tempvariable[0] != '\0')
	{
		m_strDblClickCommand = new char[256];
		memset(m_strDblClickCommand, 0, 256);
		GetCommandAndParams(m_strDblClickCommand, m_strDblClickParams, tempvariable);
	}

	tempvariable = m_pParser->GetVariable("m_strRClickCommand");
	if(tempvariable && tempvariable[0] != '\0')
	{
		m_strRClickCommand = new char[256];
		memset(m_strRClickCommand, 0, 256);
		GetCommandAndParams(m_strRClickCommand, m_strRClickParams, tempvariable);
	}

	tempvariable = m_pParser->GetVariable("m_strEnterPressCommand");
	if(tempvariable && tempvariable[0] != '\0')
	{
		m_strEnterPressCommand = new char[256];
		memset(m_strEnterPressCommand, 0, 256);
		GetCommandAndParams(m_strEnterPressCommand, m_strEnterPressParams, tempvariable);
	}

	tempvariable = m_pParser->GetVariable("m_strHoverCommand");
	if(tempvariable && tempvariable[0] != '\0')
	{
		m_strHoverCommand = new char[256];
		memset(m_strHoverCommand, 0, 256);
		GetCommandAndParams(m_strHoverCommand, m_strHoverParams, tempvariable);
	}

	tempvariable = m_pParser->GetVariable("m_strUnHoverCommand");
	if(tempvariable && tempvariable[0] != '\0')
	{
		m_strUnHoverCommand = new char[256];
		memset(m_strUnHoverCommand, 0, 256);
		GetCommandAndParams(m_strUnHoverCommand, m_strUnHoverParams, tempvariable);
	}

	tempvariable = m_pParser->GetVariable("m_strDragCommand");
	if(tempvariable && tempvariable[0] != '\0')
	{
		m_strDragCommand = new char[256];
		memset(m_strDragCommand, 0, 256);
		GetCommandAndParams(m_strDragCommand, m_strDragParams, tempvariable);
	}

	tempvariable = m_pParser->GetVariable("m_strDropCommand");
	if(tempvariable && tempvariable[0] != '\0')
	{
		m_strDropCommand = new char[256];
		memset(m_strDropCommand, 0, 256);
		GetCommandAndParams(m_strDropCommand, m_strDropParams, tempvariable);
	}

	tempvariable = m_pParser->GetVariable("m_strHoverSound");
	if(tempvariable && tempvariable[0] != '\0')
		m_pHoverSound = g_xPaperAPI.m_xAudio.LoadSoundWithRandom(tempvariable);

	tempvariable = m_pParser->GetVariable("m_strClickSound");
	if(tempvariable && tempvariable[0] != '\0')
		m_pClickSound = g_xPaperAPI.m_xAudio.LoadSoundWithRandom(tempvariable);

	tempvariable = m_pParser->GetVariable("m_strDblClickSound");
	if(tempvariable && tempvariable[0] != '\0')
		m_pDblClickSound = g_xPaperAPI.m_xAudio.LoadSoundWithRandom(tempvariable);

	tempvariable = m_pParser->GetVariable("m_strEnterPressSound");
	if(tempvariable && tempvariable[0] != '\0')
		m_pEnterPressSound = g_xPaperAPI.m_xAudio.LoadSoundWithRandom(tempvariable);

	tempvariable = m_pParser->GetVariable("m_iTabIndex");
	if(tempvariable && tempvariable[0] != '\0')
		m_iTabIndex = m_pParser->ToInt("m_iTabIndex");

	int selectiongroup = m_pParser->ToInt("m_iSelectionGroup");
	if(selectiongroup > 0)
	{
		m_pSelectionGroup = m_pOwningWindow->m_pData->m_pSelectionGroups[selectiongroup - 1];
		m_pSelectionGroup->AddItem(this);
	}

	return PE_RES_NOERROR;
}

void xGUIObject::LoadAnimation()
{
	char function[256], params[3][52];
	while(!m_pParser->ReadLine(function, params[0], params[1], params[2]))
	{
		if(!stricmp(function, "AddKeyFrame"))
		{
			//Get All Key Frame Variables
			float x		 = m_pParser->ToFlt("m_iX");
			float y		 = m_pParser->ToFlt("m_iY");
			float width	 = m_pParser->ToFlt("m_iWidth");
			float height = m_pParser->ToFlt("m_iHeight");
			float angle	 = m_pParser->ToFlt("m_fAngle");
			float scalex = m_pParser->ToFlt("m_fScaleX", 1.0);
			float scaley = m_pParser->ToFlt("m_fScaleY", 1.0);
			float alpha	 = m_pParser->ToFlt("m_iAlpha", 255.0) / 255.0;

			xAnimationAddKeyFrame(&m_xAnimation, atoi(params[0]), x, y, width, height, angle, scalex, scaley, alpha);
		}
		else if(!stricmp(function, "EndAnimation"))
		{
			xAnimationLoadedAllKeyFrames(&m_xAnimation);

			if(params[0][0] == 't')
				m_xAnimation.m_bLoop = true;

			break;
		}
	}
}

void xGUIObjectPreUpdate(xGUIObject* pThis, DWORD dwTime)
{
	if(pThis->GetHidden())
		return;

	xGUIObjectList *curobj = &pThis->m_xChildObjectList;
	while(curobj->m_pNext)
	{
		curobj = curobj->m_pNext;

		if(curobj->m_pData->pfnPreUpdate)
			curobj->m_pData->pfnPreUpdate(curobj->m_pData, dwTime);
	}
}

void xGUIObjectClearState(xGUIObject* pThis, DWORD dwTime)
{
	xGUIObjectList *curobj = &pThis->m_xChildObjectList;
	while(curobj->m_pNext)
	{
		curobj = curobj->m_pNext;

		if(curobj->m_pData->pfnClearState)
			curobj->m_pData->pfnClearState(curobj->m_pData, dwTime);
	}
}

void xGUIObjectUpdate(xGUIObject* pThis, double dTime)
{
	if(pThis->GetHidden())
		return;

	xGUIObjectList *curobj = &pThis->m_xChildObjectList;
	while(curobj->m_pNext)
	{
		curobj = curobj->m_pNext;

		if(curobj->m_pData->pfnUpdate)
			curobj->m_pData->pfnUpdate(curobj->m_pData, dTime);
	}
}

void xGUIObjectUpdateRenderables(xGUIObject* pThis)
{
	xGUIObjectList *curobj = pThis->m_xChildObjectList.m_pNext;
	while(curobj)
	{
		curobj->m_pData->UpdateRenderables();
		curobj = curobj->m_pNext;
	}
}

void xGUIObjectUpdateDepth(xGUIObject* pThis)
{
	xGUIObjectList *curobj = pThis->m_xChildObjectList.m_pNext;
	while(curobj)
	{
		curobj->m_pData->UpdateDepth();
		curobj = curobj->m_pNext;
	}
}

void xGUIObjectRefreshRenderables(xGUIObject* pThis)
{
	xGUIObjectList *curobj = pThis->m_xChildObjectList.m_pNext;
	while(curobj)
	{
		if(curobj->m_pData->pfnRefreshRenderables)
			curobj->m_pData->RefreshRenderables();

		curobj = curobj->m_pNext;
	}
}

void xGUIObject::Shutdown()
{
	xGUIObjectList *curobj = m_xChildObjectList.m_pNext;
	if(curobj)
	{
		while(curobj->m_pNext)
		{
			curobj = curobj->m_pNext;
			curobj->m_pPrev->m_pData->Shutdown();
			delete curobj->m_pPrev;
		}

		curobj->m_pData->Shutdown();
		delete curobj;
	}

	if(m_strLClickCommand)
	{
		delete [] m_strLClickCommand;

		if(m_strLClickParams)
		{
			delete [] m_strLClickParams[0];

			delete [] m_strLClickParams;
		}
	}

	if(m_strRClickCommand)
	{
		delete [] m_strRClickCommand;

		if(m_strRClickParams)
		{
			delete [] m_strRClickParams[0];

			delete [] m_strRClickParams;
		}
	}

	if(m_strEnterPressCommand)
	{
		delete [] m_strEnterPressCommand;

		if(m_strEnterPressParams)
		{
			delete [] m_strEnterPressParams[0];

			delete [] m_strEnterPressParams;
		}
	}

	if(m_strHoverCommand)
	{
		delete [] m_strHoverCommand;

		if(m_strHoverParams)
		{
			delete [] m_strHoverParams[0];

			delete [] m_strHoverParams;
		}
	}

	if(m_strDragCommand)
	{
		delete [] m_strDragCommand;

		if(m_strDragParams)
		{
			delete [] m_strDragParams[0];

			delete [] m_strDragParams;
		}
	}

	if(m_strDropCommand)
	{
		delete [] m_strDropCommand;

		if(m_strDropParams)
		{
			delete [] m_strDropParams[0];

			delete [] m_strDropParams;
		}
	}
}

int xGUIObject::AddChildObject(int iType)
{
	xGUIObjectList *list;
	xGUIObjectList *curobj = &m_xChildObjectList;
	while(curobj->m_pNext)
		curobj = curobj->m_pNext;

	curobj->m_pNext			 = new xGUIObjectList;
	curobj->m_pNext->m_pPrev = curobj;
	curobj					 = curobj->m_pNext;
	
	switch(iType)
	{
		case PE_GUI_IMAGE:
			curobj->m_pData = new xGUIImage;
			break;
		case PE_GUI_MODEL:
			curobj->m_pData = new xGUIModel;
			break;
		case PE_GUI_TEXT:
			curobj->m_pData = new xGUIText;
			break;
		case PE_GUI_TEXTBOX:
			curobj->m_pData = new xGUITextBox;
			break;
		case PE_GUI_LISTBOX:
			curobj->m_pData = new xGUIListBox;
			break;
		case PE_GUI_COLUMNLISTBOX:
			curobj->m_pData = new xGUIColumnListBox;
			break;
		case PE_GUI_COMBOBOX:
			curobj->m_pData = new xGUIComboBox;
			break;
		case PE_GUI_BUTTON:
			curobj->m_pData = new xGUIButton;
			break;
		case PE_GUI_CHECKBOX:
			curobj->m_pData = new xGUICheckBox;
			break;
		case PE_GUI_TREELIST:
			curobj->m_pData = new xGUITreeList;
			break;
		case PE_GUI_SCROLLBAR:
			curobj->m_pData = new xGUIScrollbar;
			break;
		case PE_GUI_SLIDER:
			curobj->m_pData = new xGUISlider;
			break;
		default:
			return NULL;
	}

	curobj->m_pData->m_pSceneGraph		= m_pSceneGraph;
	curobj->m_pData->m_pParent			= this;
	curobj->m_pData->m_pParser			= m_pParser;
	curobj->m_pData->m_pGUI				= m_pGUI;
	curobj->m_pData->m_pOwningWindow	= m_pOwningWindow;

	curobj->m_pData->Init(m_strThemeName);

	list = m_xChildObjectList.m_pNext;
	while(list)
	{
		if(curobj->m_pData->m_xRenderable.m_fDepth > list->m_pData->m_xRenderable.m_fDepth)
		{
			curobj->m_pPrev->m_pNext = NULL;
			curobj->m_pPrev = list->m_pPrev;
			curobj->m_pPrev->m_pNext = curobj;
			list->m_pPrev = curobj;
			curobj->m_pNext = list;
			break;
		}

		list = list->m_pNext;
	}

	return PE_RES_NOERROR;
}

int xGUIObject::AddChildObject(char *strType)
{
	if(!stricmp(strType, "Image"))
		return AddChildObject(PE_GUI_IMAGE);
	else if(!stricmp(strType, "Model"))
		return AddChildObject(PE_GUI_MODEL);
	else if(!stricmp(strType, "Text"))
		return AddChildObject(PE_GUI_TEXT);
	else if(!stricmp(strType, "TextBox"))
		return AddChildObject(PE_GUI_TEXTBOX);
	else if(!stricmp(strType, "ListBox"))
		return AddChildObject(PE_GUI_LISTBOX);
	else if(!stricmp(strType, "ColumnListBox"))
		return AddChildObject(PE_GUI_COLUMNLISTBOX);
	else if(!stricmp(strType, "ComboBox"))
		return AddChildObject(PE_GUI_COMBOBOX);
	else if(!stricmp(strType, "Button"))
		return AddChildObject(PE_GUI_BUTTON);
	else if(!stricmp(strType, "CheckBox"))
		return AddChildObject(PE_GUI_CHECKBOX);
	else if(!stricmp(strType, "TreeList"))
		return AddChildObject(PE_GUI_TREELIST);
	else if(!stricmp(strType, "ScrollBar"))
		return AddChildObject(PE_GUI_SCROLLBAR);
	else if(!stricmp(strType, "Slider"))
		return AddChildObject(PE_GUI_SLIDER);

	return PE_RES_INVALIDGUIOBJECTTYPE;
}

xGUIObject* xGUIObject::GetChildByName(const char *strName)
{
	xGUIObject *temp;
	xGUIObjectList *curobj = &m_xChildObjectList;

	while(curobj->m_pNext)
	{
		curobj = curobj->m_pNext;
		if(!stricmp(curobj->m_pData->m_strName, strName))
			return curobj->m_pData;

		temp = curobj->m_pData->GetChildByName(strName);
		if(temp)
			return temp;
	}

	return NULL;
}

int xGUIObject::GetCommandAndParams(char *strCommandOut, char** &strParamsOut, char *strLine)
{
	if(!strLine)
		return 0;

	int numparams = 0;
	int j = 0;
	int length = strlen(strLine);
	bool bFoundOpenParenthesis = false;

	for(int i = 0; i < length; i++)
	{
		if(strLine[i] == '(')
		{
			strCommandOut[j] = '\0';

			bFoundOpenParenthesis = true;

			numparams = 1;
			for(j = i; j < length && strLine[j] != ')'; j++)
			{
				if(strLine[j] == ',')
					numparams++;
			}

			strParamsOut = new char*[numparams];
			for(j = 0; j < numparams; j++)
			{
				strParamsOut[j] = new char[256];
				memset(strParamsOut[j], 0, 256);
			}

			numparams = 0;
			j = 0;

			continue;
		}
		else if(strLine[i] == ')')
		{
			strParamsOut[numparams][j] = '\0';
			break;
		}
		else if(bFoundOpenParenthesis)
		{
			if(strLine[i] == ',')
			{
				strParamsOut[numparams][j] = '\0';

				numparams++;
				j = 0;

				if(strLine[i + 1] == ' ')
					i++;

				continue;
			}
			else
				strParamsOut[numparams][j++] = strLine[i];
		}
		else
		{
			strCommandOut[j++] = strLine[i];
		}
	}

	if(!bFoundOpenParenthesis)
		strCommandOut[0] = '\0';

	return numparams;
}

void xGUISelectionGroup::AddItem(xGUIObject *pSelectable)
{
	xGUIObjectList* obj = &m_xSelectableList;

	while(obj->m_pNext)
		obj = obj->m_pNext;

	obj->m_pNext			= new xGUIObjectList;
	obj->m_pNext->m_pPrev	= obj;
	obj->m_pNext->m_pData	= pSelectable;
}

void xGUISelectionGroup::ClearSelected()
{
	xGUIObjectList* obj = m_xSelectableList.m_pNext;

	while(obj)
	{
		obj->m_pData->m_bSelected = false;
		obj = obj->m_pNext;
	}
}
