/////////////////////////////////////////////////////////////////
// Name: xGUISlider.h
/////////////////////////////////////////////////////////////////
// Description:
// - This handles sliders for the GUI.
/////////////////////////////////////////////////////////////////
// - 07.11.2004, Note, DayleFlowers (Xienen)
//   File created
/////////////////////////////////////////////////////////////////
#ifndef XGUISLIDER_H_
#define XGUISLIDER_H_

#include "xGUIObject.h"

void xGUISliderPreUpdate(xGUIObject* pThis, DWORD dwTime);
void xGUISliderUpdate(xGUIObject* pThis, double dTime);
void xGUISliderUpdateRenderables(xGUIObject* pThis);
void xGUISliderRefreshRenderables(xGUIObject* pThis);

class xGUISlider : public xGUIObject
{
public:
	xGUISlider()
	{
		pfnPreUpdate			= &xGUISliderPreUpdate;
		pfnUpdate				= &xGUISliderUpdate;
		pfnUpdateRenderables	= &xGUISliderUpdateRenderables;
		pfnRefreshRenderables	= &xGUISliderRefreshRenderables;

		m_pBackground		= 0;
		m_pThumb			= 0;
		m_fBGOffsetY		= 0.0;
		m_bDragging			= false;
		m_iNumObjects		= 0;
		m_iVisibleObjects	= 1;
		m_iTopObject		= 0;
	}

	void  InitRenderable(const char *strThemeName, const char *strBackground = 0, const char *strThumb = 0);
	int   LoadObject(const char *strThemeName);
	void  Shutdown();

	float GetValue() { return (float)m_iTopObject / (float)m_iNumObjects; }
	void  SetValue(float fValue) { m_iTopObject = (float)m_iNumObjects * fValue; }

	xRenderable2DQuad	*m_pBackground;
	xRenderable2DQuad	*m_pThumb;
	float				 m_fBGOffsetY;
	bool				 m_bDragging;
	DWORD				 m_dwThumbClickOffset;

	int	m_iNumObjects;
	int	m_iVisibleObjects;
	int	m_iTopObject;
};

#endif