#include "Paper.h"

FORCE_INLINE void UpdateTextObject(xGUITextBox *pTextBox);

void xGUITextBox::InitRenderable(const char *strThemeName, const char *strBackground)
{
	char backgroundpath[256] = {0};

	if(!strBackground || strBackground[0] == '\0')
		sprintf(backgroundpath, "Data/Themes/%s/TextBoxBG.p2d", strThemeName);
	else
		strcpy(backgroundpath, strBackground);

	if(m_bStretch)
	{
		m_pBackground = xSceneGraphCreateQuad(backgroundpath, 0);
		xRenderable2DQuadSetPosition(m_pBackground, GetAbsoluteX(), GetAbsoluteY());
		xRenderable2DQuadSetSize(m_pBackground, GetWidth(), GetHeight());
		xSceneGraphInsertQuad(m_pSceneGraph, m_pBackground, 9, GetAbsoluteDepth());
		xRenderable2DQuad9Update(m_pBackground);
	}
	else
	{
		m_pBackground = xSceneGraphCreateQuad(backgroundpath, 0);
		xRenderable2DQuadSetPosition(m_pBackground, GetAbsoluteX(), GetAbsoluteY());
		xSceneGraphInsertQuad(m_pSceneGraph, m_pBackground, 1, GetAbsoluteDepth());
		xRenderable2DQuadUpdate(m_pBackground);
	}

	m_xTextObject.m_pParent		= this;
	m_xTextObject.m_pSceneGraph	= m_pSceneGraph;
	m_xTextObject.m_bMasked		= m_bMasked;
	m_xTextObject.m_bColorized	= m_bColorized;
	m_xTextObject.SetDepth(0.001);
	m_xTextObject.SetX(m_fBorder);
	m_xTextObject.SetY(m_fBorder);
	m_xTextObject.SetWidth(GetWidth());
	m_xTextObject.SetHeight(GetHeight());
	m_xTextObject.SetFont(m_pFont);
	m_xTextObject.InitRenderable();

	m_strBuffer = new char[m_iMaxLength + 1];
	memset(m_strBuffer, 0, m_iMaxLength + 1);

	m_xTextObject.m_iMaxLength = m_iMaxLength;
	m_xTextObject.m_strBuffer = new char[m_iMaxLength + 1];
	memset(m_xTextObject.m_strBuffer, 0, m_iMaxLength + 1);

	m_pCursor = xSceneGraphCreateLine();
	xSceneGraphInsertLine(m_pSceneGraph, m_pCursor, GetAbsoluteDepth() + 0.002);
	xRenderable2DLineUpdateColor(m_pCursor, &m_xCursorColor);
	xRenderable2DLineUpdate(m_pCursor);
	xRenderable2DLineUpdateVisibility(m_pCursor, m_bEditable);
}

int xGUITextBox::LoadObject(const char *strThemeName)
{
	char *tempvariable;

	m_xTextObject.Init();

	xGUIObject::LoadObject(strThemeName);

	m_fBorder		= m_pParser->ToFlt("m_fBorder", 2.0);
	m_iMaxLength	= m_pParser->ToInt("m_iMaxLength");
	m_bAllowSpace	= m_pParser->ToBool("m_bAllowSpace");
	m_bMasked		= m_pParser->ToBool("m_bMasked");
	m_bColorized	= m_pParser->ToBool("m_bColorized");

	m_pParser->ToColor("m_colText", &m_xTextObject.m_xNormalColor);
	m_pParser->ToColor("m_colOutline", &m_xTextObject.m_xOutlineColor);
	m_pParser->ToColor("m_colCursor", &m_xCursorColor);

	InitRenderable(strThemeName, m_pParser->GetVariable("m_strBackground"));

	m_xTextObject.SetText(m_pParser->GetVariable("m_strText"));

	return PE_RES_NOERROR;
}

void xGUITextBoxPreUpdate(xGUIObject* pThis, DWORD dwTime)
{
	char temptext[256], pressed;

	if(!pThis->m_pParent->GetAbsoluteFocus())
		pThis->m_bHasFocus = false;

	xGUIObjectPreUpdate(pThis, dwTime);

	if(((xGUITextBox*)pThis)->m_bEditable)
	{
		if(g_xPaperAPI.m_xInput.m_lMouseX > pThis->GetAbsoluteX() && g_xPaperAPI.m_xInput.m_lMouseX < pThis->GetAbsoluteX() + pThis->GetWidth() &&
		   g_xPaperAPI.m_xInput.m_lMouseY > pThis->GetAbsoluteY() && g_xPaperAPI.m_xInput.m_lMouseY < pThis->GetAbsoluteY() + pThis->GetHeight())
		{
			if(g_xPaperAPI.m_xInput.m_buttonMouseLeft.JustPressed(true))
			{
				((xGUITextBox*)pThis)->m_dwCursorClickTime = dwTime;
				pThis->m_bHasFocus = true;
			}
		}
		else if(g_xPaperAPI.m_xInput.m_buttonMouseLeft.JustPressed())
			pThis->m_bHasFocus = false;

		if(g_xPaperAPI.m_bHasFocus && pThis->m_bHasFocus)
		{
			if(g_xPaperAPI.m_xInput.m_keyBackspace.IsDown() && ((xGUITextBox*)pThis)->m_iCurrentLength > 0)
			{
				if(g_xPaperAPI.m_xInput.m_keyBackspace.JustPressed() || g_xPaperAPI.m_xInput.m_keyBackspace.ShouldRepeat(dwTime))
				{
					((xGUITextBox*)pThis)->m_strBuffer[--((xGUITextBox*)pThis)->m_iCurrentLength] = '\0';
					UpdateTextObject(((xGUITextBox*)pThis));
				}
			}
			else if(g_xPaperAPI.m_xInput.m_keyEnter.IsDown() || g_xPaperAPI.m_xInput.m_keyNumEnter.IsDown())
			{
				if(pThis->m_strEnterPressCommand)
				{
					if(g_xPaperAPI.m_xInput.m_keyEnter.JustPressed(true) || g_xPaperAPI.m_xInput.m_keyNumEnter.JustPressed(true))
					{
						g_xPaperAPI.m_xInput.m_keyEnter.Eaten();
						g_xPaperAPI.m_xInput.m_keyNumEnter.Eaten();
						pThis->m_pGUI->pfnRunInputCommand(pThis->m_strEnterPressCommand, pThis->m_strEnterPressParams, pThis->m_pOwningWindow, pThis);

						if(pThis->m_pEnterPressSound)
							pThis->m_pEnterPressSound->Play(g_xPaperAPI.m_fVolume);
					}
				}
			}
			else if((g_xPaperAPI.m_xInput.m_keyLControl.IsDown() || g_xPaperAPI.m_xInput.m_keyRControl.IsDown()) && g_xPaperAPI.m_xInput.m_keyV.JustPressed())
			{
				pThis->m_pGUI->pfnHandlePaste(g_xPaperAPI.m_xPlatform.GetClipboardContents(temptext, 255), pThis->m_pOwningWindow, pThis);
			}
			else if(((xGUITextBox*)pThis)->m_iCurrentLength < ((xGUITextBox*)pThis)->m_iMaxLength)
			{
				pressed = g_xPaperAPI.m_xInput.GetCharacterPressed(dwTime, ((xGUITextBox*)pThis)->m_bAllowSpace);

				if(pressed != '\0')
				{
					((xGUITextBox*)pThis)->m_strBuffer[((xGUITextBox*)pThis)->m_iCurrentLength++] = pressed;
					((xGUITextBox*)pThis)->m_strBuffer[((xGUITextBox*)pThis)->m_iCurrentLength] = '\0';
					UpdateTextObject(((xGUITextBox*)pThis));
				}
			}

			if(((xGUITextBox*)pThis)->m_dwCursorClickTime == 0)
			{
				UpdateTextObject(((xGUITextBox*)pThis));
				((xGUITextBox*)pThis)->m_dwCursorClickTime = dwTime;
			}

			xRenderable2DLineUpdateVisibility(((xGUITextBox*)pThis)->m_pCursor, (((dwTime - ((xGUITextBox*)pThis)->m_dwCursorClickTime) / 500) % 2) == 0);
		}
		else if(((xGUITextBox*)pThis)->m_pCursor->m_xRenderable2D.m_bVisible)
			xRenderable2DLineUpdateVisibility(((xGUITextBox*)pThis)->m_pCursor, false);
	}
}

void xGUITextBoxUpdate(xGUIObject* pThis, double dTime)
{
	if(!pThis->m_pParent->GetAbsoluteFocus())
		pThis->m_bHasFocus = false;

	if(!pThis->m_xAnimation.m_bDone)
		xAnimationUpdate(&pThis->m_xAnimation, dTime);

	xGUITextUpdate(&((xGUITextBox*)pThis)->m_xTextObject, dTime);

	xGUIObjectUpdate(pThis, dTime);
}

void xGUITextBoxUpdateRenderables(xGUIObject* pThis)
{
	xColor tempcolor;

	xRenderable2DQuadSetPosition(((xGUITextBox*)pThis)->m_pBackground, pThis->GetAbsoluteX(), pThis->GetAbsoluteY());
	xRenderable2DQuadUpdateAlpha(((xGUITextBox*)pThis)->m_pBackground, pThis->GetAbsoluteColor(&tempcolor)->A);
	xRenderable2DQuadUpdateVisibility(((xGUITextBox*)pThis)->m_pBackground, !pThis->GetAbsoluteHidden());

	if(pThis->m_bStretch)
		xRenderable2DQuad9Update(((xGUITextBox*)pThis)->m_pBackground);
	else
		xRenderable2DQuadUpdate(((xGUITextBox*)pThis)->m_pBackground);

	UpdateTextObject((xGUITextBox*)pThis);
}

void xGUITextBoxUpdateDepth(xGUIObject* pThis)
{
	xRenderable2DQuadUpdateDepth(((xGUITextBox*)pThis)->m_pBackground, pThis->m_pSceneGraph, pThis->GetAbsoluteDepth());

	xGUITextUpdateDepth(&((xGUITextBox*)pThis)->m_xTextObject);

	xRenderable2DLineUpdateDepth(((xGUITextBox*)pThis)->m_pCursor, pThis->m_pSceneGraph, pThis->GetAbsoluteDepth() + 0.002);
}

void xGUITextBoxRefreshRenderables(xGUIObject* pThis)
{
	xRenderable2DQuadUpdateTexture(((xGUITextBox*)pThis)->m_pBackground, ((xGUITextBox*)pThis)->m_pBackground->m_pTextures[0]);
	xGUITextRefreshRenderables(&((xGUITextBox*)pThis)->m_xTextObject);
}

void xGUITextBox::Shutdown()
{
	xGUIObject::Shutdown();

	if(m_pBackground)
		xSceneGraphDeleteQuad(m_pSceneGraph, m_pBackground, false);

	if(m_pCursor)
		xSceneGraphDeleteLine(m_pSceneGraph, m_pCursor);

	m_xTextObject.Shutdown();

	if(m_strBuffer)
		delete [] m_strBuffer;
}

int xGUITextBox::HandlePaste(char *strInput, bool bOverwrite)
{
	int ret = 0;

	if(strInput[0] == '\0')
		return 0;

	if(bOverwrite)
	{
		m_iCurrentLength = 0;
		m_strBuffer[0] = '\0';
	}

	do
	{
		m_strBuffer[m_iCurrentLength++] = strInput[ret++];
		m_strBuffer[m_iCurrentLength] = '\0';
	}while(m_iCurrentLength < m_iMaxLength && strInput[ret] != '\0');
	
	UpdateTextObject(this);

	return ret;
}

FORCE_INLINE void UpdateTextObject(xGUITextBox *pTextBox)
{
	int stringlen, i;
	float cursorx;

	if(pTextBox->m_bMasked)
	{
		for(i = 0; i < pTextBox->m_iCurrentLength; i++)
			pTextBox->m_xTextObject.m_strBuffer[i] = '*';

		pTextBox->m_xTextObject.m_strBuffer[pTextBox->m_iCurrentLength] = '\0';
	}
	else
		strcpy(pTextBox->m_xTextObject.m_strBuffer, pTextBox->m_strBuffer);

	cursorx = xFontGetWidth(pTextBox->m_pFont, pTextBox->m_xTextObject.m_strBuffer);
	while(cursorx > pTextBox->GetWidth())
	{
		cursorx -= xFontGetWidth(pTextBox->m_pFont, pTextBox->m_xTextObject.m_strBuffer[0]);

		stringlen = strlen(pTextBox->m_xTextObject.m_strBuffer);

		for(i = 0; i < stringlen; i++)
			pTextBox->m_xTextObject.m_strBuffer[i] = pTextBox->m_xTextObject.m_strBuffer[i + 1];
	}

	xGUITextUpdateRenderable(&pTextBox->m_xTextObject);

	xRenderable2DLineSetStartPoint(pTextBox->m_pCursor, pTextBox->GetAbsoluteX() + pTextBox->m_xTextObject.GetX() + cursorx + 3.0, pTextBox->GetAbsoluteY() + 3.0);
	xRenderable2DLineSetEndPoint(pTextBox->m_pCursor, pTextBox->m_pCursor->m_xRenderable2D.m_fX, pTextBox->GetAbsoluteY() + pTextBox->GetHeight() - 3.0);
	xRenderable2DLineUpdate(pTextBox->m_pCursor);
}