#include "peGame.h"

void xHTTPQuery::CheckForUpdate()
{
	m_strFileList = 0;
	m_iFileListOffset = 0;

	StartQuery(BB_HTTPQUERY_UPDATE);
}

void xHTTPQuery::Register(char *strUserName, char *strPassword, char *strCDKey)
{
	m_strUserName = strUserName;
	m_strCDKey = strCDKey;

	GenerateMD5(strPassword, m_strPassword);

	StartQuery(BB_HTTPQUERY_REGISTER);
}
	
void xHTTPQuery::Login(char *strUserName, char *strPassword, bool bPasswordEncrypted)
{
	m_strUserName = strUserName;

	if(!bPasswordEncrypted)
		GenerateMD5(strPassword, m_strPassword);
	else
		strcpy(m_strPassword, strPassword);

	StartQuery(BB_HTTPQUERY_LOGIN);
}

void xHTTPQuery::GetServerList(xGUIColumnListBox *pServerListBox)
{
	m_pServerListBox = pServerListBox;

	StartQuery(BB_HTTPQUERY_GETSERVERLIST);
}

void xHTTPQuery::AddServerToList(int iServerPort, char* strUserName, char *strSongName, int iSongDifficulty)
{
	m_iServerPort		= iServerPort;
	m_strUserName		= strUserName;
	m_strSongName		= strSongName;
	m_iSongDifficulty	= iSongDifficulty;

	StartQuery(BB_HTTPQUERY_ADDSERVERTOLIST);
}

void xHTTPQuery::RemoveServerFromList(int iServerPort, char* strUserName)
{
	m_iServerPort	= iServerPort;
	m_strUserName	= strUserName;

	StartQuery(BB_HTTPQUERY_REMOVESERVERFROMLIST);
}

void xHTTPQuery::OpponentConnected(int iServerPort, char* strUserName, char* strOpponentName)
{
	m_iServerPort		= iServerPort;
	m_strUserName		= strUserName;
	m_strOpponentName	= strOpponentName;

	StartQuery(BB_HTTPQUERY_OPPONENTCONNECT);
}

void xHTTPQuery::BattleFinished(char *strServerAddr, int iServerPort, int iIsServer, char *strUserName)
{
	m_strServerAddress = strServerAddr;
	m_iServerPort = iServerPort;
	m_iIsServer = iIsServer;
	m_strUserName = strUserName;

	StartQuery(BB_HTTPQUERY_BATTLEFINISHED);
}

void xHTTPQuery::GetLeaderboardData(char* strUserName)
{
	m_strUserName = strUserName;

	StartQuery(BB_HTTPQUERY_GETLEADERBOARDDATA);
}

void xHTTPQuery::UnlockAchievement(char* strAchievement, char* strUserName, char* strPassword)
{
#ifndef DEMO_RELEASE
	m_strAchievement = strAchievement;
	m_strUserName = strUserName;
	
	strcpy(m_strPassword, strPassword);

	StartQuery(BB_HTTPQUERY_UNLOCKACHIEVEMENT);
#endif
}

void xHTTPQuery::GetAchievements(char* strUserName)
{
	m_strUserName = strUserName;
	
	StartQuery(BB_HTTPQUERY_GETACHIEVEMENTS);
}

void xHTTPQuery::GetSPLeaderboard(char* strUserName, int iDifficulty, int iStartIndex)
{
	m_strUserName = strUserName;
	m_iDifficulty = iDifficulty;
	m_iIndex = iStartIndex;

	StartQuery(BB_HTTPQUERY_GETSPLEADERBOARD);
}

void xHTTPQuery::UpdateSPLeaderboard(char* strUserName, char* strPassword, int iDifficulty, int iCompletionPercentage, int iAverageCrowdPercentage, int iTotalPlayTime)
{
	m_strUserName = strUserName;
	m_iDifficulty = iDifficulty;
	m_iCompletion = iCompletionPercentage;
	m_iCrowd = iAverageCrowdPercentage;
	m_iTime = iTotalPlayTime;

	strcpy(m_strPassword, strPassword);

	StartQuery(BB_HTTPQUERY_UPDATESPLEADERBOARD);
}

void xHTTPQuery::Update()
{
	DWORD useless;
	char tempbuffer[MAX_NETWORK_BUFFERSIZE + 1] = {0}, temp[256] = {0}, myip[16] = {0};
	xFileIO fileio;
	bool foundend = false;
	int i, j, k, len;

	if(!m_bHasConnected && !g_xPaperAPI.m_xHTTPNetwork.IsConnected())
		return;

	m_bHasConnected = true;

	if(m_iCurrentStep == 0)
	{
		switch(m_iQueryType)
		{
			case BB_HTTPQUERY_UPDATE:
				g_xPaperAPI.m_xHTTPNetwork.Send(BB_HTTP_COMMAND_UPDATE, strlen(BB_HTTP_COMMAND_UPDATE));
				break;
			case BB_HTTPQUERY_REGISTER:
				sprintf(temp, BB_HTTP_COMMAND_REGISTER, m_strUserName, m_strPassword, m_strCDKey);
				g_xPaperAPI.m_xHTTPNetwork.Send(temp, strlen(temp));
				break;
			case BB_HTTPQUERY_LOGIN:
				sprintf(temp, BB_HTTP_COMMAND_LOGIN, m_strUserName, m_strPassword);
				g_xPaperAPI.m_xHTTPNetwork.Send(temp, strlen(temp));
				break;
			case BB_HTTPQUERY_GETSERVERLIST:
				g_xPaperAPI.m_xHTTPNetwork.Send(BB_HTTP_COMMAND_GETSERVERLIST, strlen(BB_HTTP_COMMAND_GETSERVERLIST));
				break;
			case BB_HTTPQUERY_ADDSERVERTOLIST:
				sprintf(temp, BB_HTTP_COMMAND_ADDSERVER, m_iServerPort, m_strUserName, m_strSongName, m_iSongDifficulty);
				g_xPaperAPI.m_xHTTPNetwork.Send(temp, strlen(temp));
				break;
			case BB_HTTPQUERY_REMOVESERVERFROMLIST:
				sprintf(temp, BB_HTTP_COMMAND_REMOVESERVER, m_iServerPort, m_strUserName);
				g_xPaperAPI.m_xHTTPNetwork.Send(temp, strlen(temp));
				break;
			case BB_HTTPQUERY_OPPONENTCONNECT:
				sprintf(temp, BB_HTTP_COMMAND_OPPONENTCONNECTED, m_iServerPort, m_strUserName, m_strOpponentName);
				g_xPaperAPI.m_xHTTPNetwork.Send(temp, strlen(temp));
				break;
			case BB_HTTPQUERY_BATTLEFINISHED:
				sprintf(temp, BB_HTTP_COMMAND_BATTLEFINISHED, m_strServerAddress, m_iServerPort, m_iIsServer, m_strUserName);
				g_xPaperAPI.m_xHTTPNetwork.Send(temp, strlen(temp));
				break;
			case BB_HTTPQUERY_GETLEADERBOARDDATA:
				g_xMenu.AddMenuWindow(BB_WINDOW_MENU_LEADERBOARD);
				m_pWindow = g_xMenu.m_xGUI.GetWindow(BB_WINDOW_MENU_LEADERBOARD);
				m_iIndex = 0;
				sprintf(temp, BB_HTTP_COMMAND_GETLEADERBOARDDATA, m_strUserName, 0);
				g_xPaperAPI.m_xHTTPNetwork.Send(temp, strlen(temp));
				break;
			case BB_HTTPQUERY_UNLOCKACHIEVEMENT:
				sprintf(temp, BB_HTTP_COMMAND_UNLOCKACHIEVEMENT, m_strAchievement, m_strUserName, m_strPassword);
				g_xPaperAPI.m_xHTTPNetwork.Send(temp, strlen(temp));
				break;
			case BB_HTTPQUERY_GETACHIEVEMENTS:
				sprintf(temp, BB_HTTP_COMMAND_GETACHIEVEMENTS, m_strUserName);
				g_xPaperAPI.m_xHTTPNetwork.Send(temp, strlen(temp));
				break;
			case BB_HTTPQUERY_GETSPLEADERBOARD:
				m_pWindow = g_xMenu.m_xGUI.GetWindow(BB_WINDOW_MENU_SPLEADERBOARD);
				sprintf(temp, BB_HTTP_COMMAND_GETSPLEADERBOARD, m_strUserName, m_iDifficulty, m_iIndex);
				g_xPaperAPI.m_xHTTPNetwork.Send(temp, strlen(temp));
				m_iIndex = 0;
				break;
			case BB_HTTPQUERY_UPDATESPLEADERBOARD:
				sprintf(temp, BB_HTTP_COMMAND_UPDATESPLEADERBOARD, m_strUserName, m_strPassword, m_iDifficulty, m_iCompletion, m_iCrowd, m_iTime);
				g_xPaperAPI.m_xHTTPNetwork.Send(temp, strlen(temp));
				break;
		}

		m_iCurrentStep++;
	}

	g_xPaperAPI.m_xHTTPNetwork.Update();

	g_xPaperAPI.m_xHTTPNetwork.Receive(tempbuffer, useless);

	if(tempbuffer[0] == '\0')
		return;

	strcat(m_strBuffer, tempbuffer);

	if(!m_bFoundContentStart)
	{
		len = strlen(m_strBuffer);
		for(i = 0; i < len; i++ )
		{
			if(m_strBuffer[i] == '\r' && i + 1 < len && m_strBuffer[i + 1] == '\n' && i + 2 < len && m_strBuffer[i + 2] == '\r' && i + 3 < len && m_strBuffer[i + 3] == '\n')
			{
				m_bFoundContentStart = true;

				i += 4;
				j = 0;
				for(; i < len; i++, j++)
					m_strBuffer[j] = m_strBuffer[i];

				m_strBuffer[j] = '\0';
			}
		}

		if(!m_bFoundContentStart)
		{
			if(len >= 3)
			{
				m_strBuffer[0] = m_strBuffer[len - 3];
				m_strBuffer[1] = m_strBuffer[len - 2];
				m_strBuffer[2] = m_strBuffer[len - 1];
				m_strBuffer[3] = '\0';
			}

			return;
		}
	}

	if(m_iQueryType == BB_HTTPQUERY_UPDATE)
	{
		if(m_iCurrentStep == 1 && m_strBuffer[0] != 'B')
			return;

		len = strlen(m_strBuffer);

		if(m_iCurrentStep == 1)
		{
			for(i = 0; i < len; i++)
			{
				if(m_strBuffer[i] == ':' && m_strBuffer[i + 1] == ' ')
				{
					i += 2;
					for(j = i; j < len; j++)
					{
						if(m_strBuffer[j] == '\n')
						{
							m_strBuffer[j] = '\0';
							m_strFileList = new char[atoi(m_strBuffer + i)];

							for(i = 0; j < len; i++, j++)
								m_strBuffer[i] = m_strBuffer[j];

							len -= (j - i);

							m_iCurrentStep++;

							break;
						}
					}
				}

				if(m_strFileList)
					break;
			}
		}

		if(m_iCurrentStep == 2)
		{
			for(i = 0; i < len; i++)
			{
				if(m_strBuffer[i] == ':' && m_strBuffer[i + 1] == ' ')
				{
					i += 2;
					for(j = i; j < len; j++)
					{
						if(m_strBuffer[j] == '\n')
						{
							m_strBuffer[j] = '\0';
							m_iPreviousVersion = atoi(m_strBuffer + i);

							for(i = 0; j < len; i++, j++)
								m_strBuffer[i] = m_strBuffer[j];

							len -= (j - i);

							m_iCurrentStep++;

							break;
						}
					}
				}

				if(m_iCurrentStep == 3)
					break;
			}
		}

		if(m_iCurrentStep == 3)
		{
			for(i = 0; i < len; i++)
			{
				if(m_strBuffer[i] == ':' && m_strBuffer[i + 1] == ' ')
				{
					i += 2;
					for(j = i; j < len; j++)
					{
						if(m_strBuffer[j] == '\n')
						{
							m_strBuffer[j] = '\0';
							m_iCurrentVersion = atoi(m_strBuffer + i);

							for(i = 0; j < len; i++, j++)
								m_strBuffer[i] = m_strBuffer[j];

							len -= (j - i);

							m_iCurrentStep++;

							break;
						}
					}
				}

				if(m_iCurrentStep == 4)
					break;
			}
		}

		if(m_iCurrentStep == 4)
		{
			for(i = 0; i < len; i++)
			{
				if(m_strBuffer[i] == ':' && m_strBuffer[i + 1] == ' ')
				{
					memset(m_strDownloadLocation, 0, 64);

					k = 0;
					i += 2;
					for(j = i; j < len; j++)
					{
						if(m_strBuffer[j] == '\n')
						{
							for(j++, i = 0; j < len; i++, j++)
								m_strBuffer[i] = m_strBuffer[j];

							len -= (j - i);

							m_iCurrentStep++;

							break;
						}
						else
							m_strDownloadLocation[k++] = m_strBuffer[j];
					}
				}

				if(m_iCurrentStep == 5)
					break;
			}
		}

		if(m_iCurrentStep == 5)
		{
			for(i = 0; i < len; i++)
			{
				if(m_strBuffer[i] == ':' && m_strBuffer[i + 1] == ' ')
				{
					memset(m_strDownloadHost, 0, 64);

					k = 0;
					i += 2;
					for(j = i; j < len; j++)
					{
						if(m_strBuffer[j] == '\n')
						{
							j += 2; // Skip over both new lines

							for(i = 0; j < len; i++, j++)
								m_strBuffer[i] = m_strBuffer[j];

							len -= (j - i);

							m_iCurrentStep++;

							break;
						}
						else
							m_strDownloadHost[k++] = m_strBuffer[j];
					}
				}

				if(m_iCurrentStep == 6)
					break;
			}
		}

		if(m_iCurrentStep == 6)
		{
			for(i = 0; i < len; i++)
			{
				if(m_strBuffer[i] == ':' && m_strBuffer[i + 1] == ' ')
				{
					memset(m_strDownloaderHash, 0, 32);

					k = 0;
					i += 2;
					for(j = i; j < len; j++)
					{
						if(m_strBuffer[j] == '\n')
						{
							j += 2; // Skip over both new lines

							for(i = 0; j < len; i++, j++)
								m_strBuffer[i] = m_strBuffer[j];

							len -= (j - i);

							m_iCurrentStep++;

							break;
						}
						else
							m_strDownloaderHash[k++] = m_strBuffer[j];
					}
				}

				if(m_iCurrentStep == 7)
					break;
			}
		}

		if(m_iCurrentStep == 7)
		{
			for(i = 0; i < len; i++)
			{
				if(m_strBuffer[i] == '\n' && m_strBuffer[i + 1] == '\n' && m_strBuffer[i + 2] == '\n')
				{
					m_strFileList[m_iFileListOffset++] = '\n';
					m_strFileList[m_iFileListOffset++] = '\0';

					g_xPaperAPI.m_xHTTPNetwork.Close();
					m_iOldQueryType = m_iQueryType;
					m_iQueryType = BB_HTTPQUERY_NONE;
					m_bHasConnected = false;
					return;
				}

				m_strFileList[m_iFileListOffset++] = m_strBuffer[i];
			}

			for(i = len - 1, j = 0; i > 0; i--)
			{
				if(m_strBuffer[i] != '\n')
				{
					m_strBuffer[j] = '\0';
					break;
				}
				else
					m_strBuffer[j++] = '\n';
			}
		}
	}
	else if(m_iQueryType == BB_HTTPQUERY_ADDSERVERTOLIST)
	{
		if(m_strBuffer[0] != '-')
			return;

		j = 0;
		len = strlen(m_strBuffer);
		for(i = 1; i < len && j < 16; i++)
		{
			if(m_strBuffer[i] == '\n' && i + 1 < len && m_strBuffer[i + 1] == '\n')
			{
				foundend = true;
				break;
			}

			myip[j++] = m_strBuffer[i];
		}

		if(!foundend)
			return;

		// Close the HTTP connection
		g_xPaperAPI.m_xHTTPNetwork.Close();
		m_iQueryType = BB_HTTPQUERY_NONE;
		m_bHasConnected = false;

		// Start the Listen Server
		if(g_xGame.InitListenServer(myip, BB_DEFAULT_SERVERPORT, "BkgStreet", m_strSongName, m_iSongDifficulty))
		{
			g_xMenu.StopMusic();
			g_pCurGameState = &g_xGame;
		}
		else
		{
			g_xMenu.OnFailedToInitListenServer(BB_DEFAULT_SERVERPORT);
		}

		return;
	}
	else if(m_iQueryType == BB_HTTPQUERY_GETSERVERLIST)
	{
		int address = -1, rank = -1, player = -1, song = -1, difficulty = -1, lastserver = 0, portsplit = -1;
		char tempstring[256] = {0}, pointsstring[4] = {0};
		len = strlen(m_strBuffer);
		for(i = 0; i < len; i++)
		{
			if(address == -1 && m_strBuffer[i] == ':')
			{
				portsplit = i;
				continue;
			}

			if(m_strBuffer[i] == '\n')
			{
				if(address == -1)
					address = i;
				else if(rank == -1)
					rank = i;
				else if(player == -1)
					player = i;
				else if(song == -1)
					song = i;
				else if(difficulty == -1)
					difficulty = i;
				else
				{
					m_strBuffer[address] = '\0';
					m_strBuffer[rank] = '\0';
					m_strBuffer[player] = '\0';
					m_strBuffer[song] = '\0';
					m_strBuffer[i] = '\0';
					
					const char *beatlevel = BB_STRING_BEGINNER;
					if(m_strBuffer[difficulty - 1] == '0' + BB_DIFFICULTY_ADVANCED)
						beatlevel = BB_STRING_NOVICE;
					else if(m_strBuffer[difficulty - 1] == '0' + BB_DIFFICULTY_EXPERT)
						beatlevel = BB_STRING_EXPERT;

					int serverrank = atoi(&m_strBuffer[address + 1]);
					int serverpoints = atoi(&m_strBuffer[difficulty + 1]);
					if ( serverrank < g_xGame.m_xPlayer.m_iRank )
					{
						serverpoints = serverpoints - g_xGame.m_xPlayer.m_iPoints;
						if ( serverpoints > 100 )
							serverpoints = 100;
					}
					else
					{
						serverpoints = 11 - (serverrank - g_xGame.m_xPlayer.m_iRank);
						if ( serverpoints < 1 )
							serverpoints = 1;
					}

					itoa(serverpoints, pointsstring, 10);

					sprintf(tempstring, BB_MUSICDIR_PATH, &m_strBuffer[player + 1]);

					if(fileio.DirectoryExists(tempstring) && stricmp(&m_strBuffer[rank + 1], g_xGame.m_xPlayer.m_strAccountName))
						m_pServerListBox->AddItem(&m_strBuffer[lastserver], &m_strBuffer[address + 1], &m_strBuffer[rank + 1], &m_strBuffer[player + 1], beatlevel, pointsstring, "999");

					m_strBuffer[portsplit] = '\0';
					int port = atoi(&m_strBuffer[portsplit + 1]) + 1;
					g_xMenu.PingServer(&m_strBuffer[lastserver], port, m_pServerListBox->m_iNumItems - 1);

					lastserver = i + 1;

					address = -1;
					rank = -1;
					player = -1;
					song = -1;
				}

				if(i + 1 < len && m_strBuffer[i + 1] == '\n')
				{
					g_xPaperAPI.m_xHTTPNetwork.Close();
					m_iQueryType = BB_HTTPQUERY_NONE;
					m_bHasConnected = false;

					if(m_pServerListBox->m_iNumItems > 0)
						g_xMenu.InitPingInfo();

					return;
				}
			}
		}

		if(lastserver)
		{
			int i = 0;
			for(; i < len; i++)
				m_strBuffer[i] = m_strBuffer[lastserver++];
			for(; i < MAX_NETWORK_BUFFERSIZE; i++)
				m_strBuffer[i] = '\0';
		}
	}
	else if(m_iQueryType == BB_HTTPQUERY_LOGIN)
	{
		if(m_strBuffer[0] != '-')
			return;

		int j = 0, len = strlen(m_strBuffer);
		char myrank[16] = {0};
		char mypoints[16] = {0};
		bool myrankfound = false, foundend = false;
		for(int i = 1; i < len && j < 16; i++)
		{
			if(m_strBuffer[i] == '\n')
			{
				if(!myrankfound)
				{
					myrankfound = true;
					j = 0;
					continue;
				}
				else if(i + 1 < len && m_strBuffer[i + 1] == '\n')
				{
					foundend = true;
					break;
				}
			}

			if(!myrankfound)
				myrank[j++] = m_strBuffer[i];
			else
				mypoints[j++] = m_strBuffer[i];
		}

		if(!foundend)
			return;

		m_iReturnValue = atoi(myrank);
		m_iPoints = atoi(mypoints);

		// Close the HTTP connection
		g_xPaperAPI.m_xHTTPNetwork.Close();
		m_iOldQueryType = m_iQueryType;
		m_iQueryType = BB_HTTPQUERY_NONE;
		m_bHasConnected = false;
	}
	else if(m_iQueryType == BB_HTTPQUERY_REGISTER)
	{
		if(m_strBuffer[0] != '-')
			return;

		int j = 0, len = strlen(m_strBuffer);
		char error[16] = {0};
		bool foundend = false;
		for(int i = 1; i < len && j < 16; i++)
		{
			if(m_strBuffer[i] == '\n' && i + 1 < len && m_strBuffer[i + 1] == '\n')
			{
				foundend = true;
				break;
			}

			error[j++] = m_strBuffer[i];
		}

		if(!foundend)
			return;

		m_iReturnValue = atoi(error);

		// Close the HTTP connection
		g_xPaperAPI.m_xHTTPNetwork.Close();
		m_iOldQueryType = m_iQueryType;
		m_iQueryType = BB_HTTPQUERY_NONE;
		m_bHasConnected = false;
	}
	else if(m_iQueryType == BB_HTTPQUERY_GETLEADERBOARDDATA)
	{
		int rank = -1, player = -1, lastrank = 0;
		int len = strlen(m_strBuffer);
		char tempstring[256] = {0};
		xColor drawcolor;
		for(int i = 0; i < len; i++)
		{
			if(m_strBuffer[i] == '\n')
			{
				if(rank == -1)
					rank = i;
				else if(player == -1)
					player = i;
				else
				{
					m_strBuffer[rank] = '\0';
					m_strBuffer[player] = '\0';
					m_strBuffer[i] = '\0';

					if(!stricmp(&m_strBuffer[rank + 1], g_xGame.m_xPlayer.m_strAccountName))
						xColorInit(&drawcolor, 0.8f, 0.2f, 0.2f, 1.0f);
					else
						xColorInit(&drawcolor, 1.0f, 1.0f, 1.0f, 1.0f);

					sprintf(tempstring, BB_NAME_RANK, m_iIndex);
					xGUIText *text = (xGUIText*)m_pWindow->m_pData->GetChildByName(tempstring);
					text->SetText(&m_strBuffer[lastrank]);
					text->SetColor(&drawcolor);

					sprintf(tempstring, BB_NAME_PLAYER, m_iIndex);
					text = (xGUIText*)m_pWindow->m_pData->GetChildByName(tempstring);
					text->SetText(&m_strBuffer[rank + 1]);
					text->SetColor(&drawcolor);

					sprintf(tempstring, BB_NAME_POINTS, m_iIndex);
					text = (xGUIText*)m_pWindow->m_pData->GetChildByName(tempstring);
					text->SetText(&m_strBuffer[player + 1]);
					text->SetColor(&drawcolor);

					m_iIndex++;
					
					lastrank = i + 1;

					rank = -1;
					player = -1;
				}

				if(i + 1 < len && m_strBuffer[i + 1] == '\n')
				{
					g_xPaperAPI.m_xHTTPNetwork.Close();
					m_iQueryType = BB_HTTPQUERY_NONE;
					m_bHasConnected = false;

					return;
				}
			}
		}

		if(lastrank)
		{
			int i = 0;
			for(; i < len; i++)
				m_strBuffer[i] = m_strBuffer[lastrank++];
			for(; i < MAX_NETWORK_BUFFERSIZE; i++)
				m_strBuffer[i] = '\0';
		}
	}
	else if(m_iQueryType == BB_HTTPQUERY_GETACHIEVEMENTS)
	{
		int index = -1, j = 0, last = 0;
		int len = strlen(m_strBuffer);
		char tempstring[12] = {0};
		for(int i = 0; i < len; i++)
		{
			if(m_strBuffer[i] == '=')
			{
				tempstring[j] = '\0';
				j = 0;
				index = atoi(tempstring) - 1;
				continue;
			}
			else if(m_strBuffer[i] == '\n')
			{
				tempstring[j] = '\0';
				j = 0;

				m_pAchievements[index] = atoi(tempstring);

				last = i + 1;

				if(last < len && m_strBuffer[last] == '\n')
				{
					g_xPaperAPI.m_xHTTPNetwork.Close();
					m_iOldQueryType = m_iQueryType;
					m_iQueryType = BB_HTTPQUERY_NONE;
					m_bHasConnected = false;

					return;
				}
			}
			else
				tempstring[j++] = m_strBuffer[i];
		}

		if(last)
		{
			int i = 0;
			for(; i < len; i++)
				m_strBuffer[i] = m_strBuffer[last++];
			for(; i < MAX_NETWORK_BUFFERSIZE; i++)
				m_strBuffer[i] = '\0';
		}
	}
	else if(m_iQueryType == BB_HTTPQUERY_GETSPLEADERBOARD)
	{
		int rank = -1, player = -1, completion = -1, crowd = -1, time, lastrank = 0;
		int len = strlen(m_strBuffer);
		char tempstring[256] = {0};
		xColor drawcolor;
		for(int i = 0; i < len; i++)
		{
			if(m_strBuffer[i] == '\n')
			{
				if(rank == -1)
					rank = i;
				else if(player == -1)
					player = i;
				else if(completion == -1)
					completion = i;
				else if(crowd == -1)
					crowd = i;
				else
				{
					m_strBuffer[rank] = '\0';
					m_strBuffer[player] = '\0';
					m_strBuffer[completion] = '\0';
					m_strBuffer[crowd] = '\0';
					m_strBuffer[i] = '\0';

					if(!stricmp(&m_strBuffer[rank + 1], m_strUserName))
						xColorInit(&drawcolor, 0.8f, 0.2f, 0.2f, 1.0f);
					else
						xColorInit(&drawcolor, 1.0f, 1.0f, 1.0f, 1.0f);

					sprintf(tempstring, BB_NAME_RANK, m_iIndex);
					xGUIText *text = (xGUIText*)m_pWindow->m_pData->GetChildByName(tempstring);
					text->SetText(&m_strBuffer[lastrank]);
					text->SetColor(&drawcolor);

					if(m_iIndex == 0)
						m_iStartIndex = atoi(&m_strBuffer[lastrank]);

					sprintf(tempstring, BB_NAME_PLAYER, m_iIndex);
					text = (xGUIText*)m_pWindow->m_pData->GetChildByName(tempstring);
					text->SetText(&m_strBuffer[rank + 1]);
					text->SetColor(&drawcolor);

					sprintf(tempstring, BB_NAME_COMPLETION, m_iIndex);
					text = (xGUIText*)m_pWindow->m_pData->GetChildByName(tempstring);
					sprintf(tempstring, "%s%%", &m_strBuffer[player + 1]);
					text->SetText(tempstring);
					text->SetColor(&drawcolor);

					sprintf(tempstring, BB_NAME_CROWD, m_iIndex);
					text = (xGUIText*)m_pWindow->m_pData->GetChildByName(tempstring);
					sprintf(tempstring, "%s%%", &m_strBuffer[completion + 1]);
					text->SetText(tempstring);
					text->SetColor(&drawcolor);

					sprintf(tempstring, BB_NAME_TIME, m_iIndex);
					text = (xGUIText*)m_pWindow->m_pData->GetChildByName(tempstring);
					time = atoi(&m_strBuffer[crowd + 1]);
					sprintf(tempstring, "%i:%02i:%02i", time / 3600, (time - ((time / 3600) * 3600)) / 60, time % 60);
					text->SetText(tempstring);
					text->SetColor(&drawcolor);

					m_iIndex++;
					
					lastrank = i + 1;

					rank = -1;
					player = -1;
					completion = -1;
					crowd = -1;
				}

				if(i + 1 < len && m_strBuffer[i + 1] == '\n')
				{
					while(m_iIndex < 10)
					{
						sprintf(tempstring, BB_NAME_RANK, m_iIndex);
						((xGUIText*)m_pWindow->m_pData->GetChildByName(tempstring))->SetText("");

						sprintf(tempstring, BB_NAME_PLAYER, m_iIndex);
						((xGUIText*)m_pWindow->m_pData->GetChildByName(tempstring))->SetText("");

						sprintf(tempstring, BB_NAME_COMPLETION, m_iIndex);
						((xGUIText*)m_pWindow->m_pData->GetChildByName(tempstring))->SetText("");

						sprintf(tempstring, BB_NAME_CROWD, m_iIndex);
						((xGUIText*)m_pWindow->m_pData->GetChildByName(tempstring))->SetText("");

						sprintf(tempstring, BB_NAME_TIME, m_iIndex);
						((xGUIText*)m_pWindow->m_pData->GetChildByName(tempstring))->SetText("");

						m_iIndex++;
					}

					g_xPaperAPI.m_xHTTPNetwork.Close();
					m_iQueryType = BB_HTTPQUERY_NONE;
					m_bHasConnected = false;

					return;
				}
			}
		}

		if(lastrank)
		{
			int i = 0;
			for(; i < len; i++)
				m_strBuffer[i] = m_strBuffer[lastrank++];
			for(; i < MAX_NETWORK_BUFFERSIZE; i++)
				m_strBuffer[i] = '\0';
		}
	}
	else
	{
		// Close the HTTP connection
		g_xPaperAPI.m_xHTTPNetwork.Close();
		m_iOldQueryType = m_iQueryType;
		m_iQueryType = BB_HTTPQUERY_NONE;
		m_bHasConnected = false;
	}
}

void xHTTPQuery::CancelQuery()
{
	g_xPaperAPI.m_xHTTPNetwork.Close();

	memset(m_strBuffer, 0, MAX_NETWORK_BUFFERSIZE);

	ClearQuery();
}

bool xHTTPQuery::UpdateQueryComplete()
{
	if(m_iOldQueryType == BB_HTTPQUERY_UPDATE && m_iQueryType == BB_HTTPQUERY_NONE)
	{
		m_iOldQueryType = BB_HTTPQUERY_NONE;
		return true;
	}

	return false;
}

bool xHTTPQuery::RegisterQueryComplete(int &iOutErrorCode)
{
	if(m_iOldQueryType == BB_HTTPQUERY_REGISTER && m_iQueryType == BB_HTTPQUERY_NONE)
	{
		m_iOldQueryType = BB_HTTPQUERY_NONE;
		iOutErrorCode = m_iReturnValue;
		return true;
	}

	return false;
}

bool xHTTPQuery::LoginQueryComplete(int &iOutRank, int &iOutPoints)
{
	if(m_iOldQueryType == BB_HTTPQUERY_LOGIN && m_iQueryType == BB_HTTPQUERY_NONE)
	{
		m_iOldQueryType = BB_HTTPQUERY_NONE;
		iOutRank = m_iReturnValue;
		return true;
	}

	return false;
}

bool xHTTPQuery::GetAchievementsComplete(int *iOutAchievements, int iSize)
{
	if(m_iOldQueryType == BB_HTTPQUERY_GETACHIEVEMENTS && m_iQueryType == BB_HTTPQUERY_NONE)
	{
		m_iOldQueryType = BB_HTTPQUERY_NONE;
		memcpy(iOutAchievements, m_pAchievements, iSize * sizeof(int));
		return true;
	}

	return false;
}

void xHTTPQuery::GenerateMD5(char *strInput, char strOutput[33])
{
	md5_state_t state;
	md5_byte_t digest[16];

	md5_init(&state);
	md5_append(&state, (const md5_byte_t*)strInput, strlen(strInput));
	md5_finish(&state, digest);

	for(int i = 0; i < 16; i++)
	    sprintf(strOutput + i * 2, "%02x", digest[i]);
}

void xHTTPQuery::StartQuery(xHTTPQueryType iQueryType)
{
	char strIP[20] = {0};

	if(m_iQueryType != BB_HTTPQUERY_NONE)
		g_xPaperAPI.m_xHTTPNetwork.Close();

	addrinfo hints, *result = NULL;
	memset(&hints, 0, sizeof(hints));
	hints.ai_flags = AI_PASSIVE;
	hints.ai_family = AF_UNSPEC;
	hints.ai_socktype = SOCK_STREAM;
	hints.ai_protocol = IPPROTO_TCP;

	DWORD retval;
	if((retval = getaddrinfo(BB_HTTP_SERVERDOMAIN, NULL, &hints, &result)) != 0)
		return;

	if(getnameinfo(result->ai_addr, result->ai_addrlen, strIP, 256, NULL, 0, NI_NUMERICHOST) != 0)
		return;

	freeaddrinfo(result);

	// Get Ready to Add this Server to the Server List
	CancelQuery();
	m_iQueryType = iQueryType;

	g_xPaperAPI.m_xHTTPNetwork.Connect(strIP, 80);
}
