/////////////////////////////////////////////////////////////////
// Name: xLocalPlayer.h
/////////////////////////////////////////////////////////////////
// Description:
// - Serves as an object for a Local Player.
/////////////////////////////////////////////////////////////////
// - 7.15.2004, Update, Dayle Flowers(Xienen)
//   File Created
/////////////////////////////////////////////////////////////////
#ifndef XLOCALPLAYER_H_
#define XLOCALPLAYER_H_

#include "xPlayer.h"
#include "xMultiplier.h"
#include "xPlayerProfile.h"
#include "xGameOptions.h"

extern xPlayerProfile	g_xCurrentProfile;
extern xGameOptions		g_xGameOptions;

class xLocalPlayer : public xPlayer
{
public:
	xLocalPlayer()
	{
		m_strCDKey[0]				= '+';
		m_strAccountName[0]			= '\0';
		m_iNumBlocksCleared			= 0;
		m_iNumPiecesUsed			= 0;
		m_bViewingPostPopup			= 0;
		m_bReadyToMoveOn			= 0;
		m_pHitTimeObject			= 0;
		m_pBlocksCleared			= 0;
		m_pCombo					= 0;
		m_bShowEscapeMessage		= 0;
		m_pHitTimeSounds[0]			= 0;
		m_dPlayerMoveApplauseDelay	= BB_PLAYERMOVE_APPLAUSEDELAY;
		m_dEnemyMoveApplauseDelay	= BB_PLAYERMOVE_APPLAUSEDELAY;
		m_bAllowClearing			= 1;
	}

	bool Init();
	void Reset();
	bool PreUpdate(DWORD dwTime);
	bool Update(double dTime);
	void RefreshAllRenderables();
	void Shutdown();

	void FillInBlock(bool bUsePieceColor) { m_xPiece.FillInBlock(bUsePieceColor, m_xMultiplier.TimerRunning()); m_xField.UpdateShadow(); }
	void SuccessfullyAddedBlock();
	void BlocksCleared(int iBlockCount, int iWhiteBlockCount, int iRingCount);
	void HitWrongColor(DWORD dwHitTime);
	void MissedBeat();
	void MissedCombo();

	void  WonGame();

	//void LoadProfile(char *strProfileName);
	void LevelComplete(int iLevelIndex, DWORD dwGameCompletionTime);

	char		 m_strCDKey[32];
	char		 m_strAccountName[33];
	int			 m_iComboCount;
	int			 m_iNumBlocksCleared;
	int			 m_iNumPiecesUsed;
	bool		 m_bViewingPostPopup;
	bool		 m_bReadyToMoveOn;
	xPiece		 m_xPiece;
	xBeatManager m_xBeatManager;
	DWORD		 m_dwColorKeyPressedTime;
	DWORD		 m_dwLastRedBuildKeyPress;
	DWORD		 m_dwLastBlueBuildKeyPress;
	DWORD		 m_dwLastYellowBuildKeyPress;
	bool		 m_bRotationKeyPressed;
	bool		 m_bAllowClearing;
	int			 m_iBlocksCleared;

	xSound	*m_pHitTimeSounds[7];
	xSound	*m_pSlideSound;
	xSound	*m_pRotateSound;
	xSound	*m_pDropSound;
	xSound	*m_pTouchDownSound;
	xSound	*m_pBlocksClearedSound;
	xSound	*m_pBlocksClearedWonSound;
	xSound	*m_pPlayerMoveSound;

	xMultiplier			  m_xMultiplier;
	xRenderable2DQuad	 *m_pHitTimeObject;
	xTexture			**m_pHitTimeTextures;
	xRenderable2DText	  m_xBlocksClearedText;
	float				  m_fBlocksClearedTextSize;
	xRenderable2DQuad	 *m_pBlocksCleared;
	xRenderable2DQuad	 *m_pBlocksClearedDesc;
	xTexture			**m_pBlocksClearedDescTextures;
	float				  m_fBlocksClearedTime;
	float				  m_fBlocksClearedTotalTime;
	float				  m_fBlocksClearedHangTime;
	char				  m_strBlocksCleared[4];
	xRenderable2DText	  m_xComboText;
	float				  m_fComboTextSize;
	xRenderable2DQuad	 *m_pCombo;
	float				  m_fComboTime;
	bool				  m_bComboFade;
	char				  m_strCombo[8];
	double				  m_dPlayerMoveApplauseDelay;
	double				  m_dEnemyMoveApplauseDelay;
	bool				  m_bShowEscapeMessage;
	xEmitter			  m_xBlockAddedEmitter;
};

#endif