/////////////////////////////////////////////////////////////////
// Name: xModel.h
/////////////////////////////////////////////////////////////////
// Description:
// - Abstract base class for different model objects, composed
//   of (a) mesh(es)
/////////////////////////////////////////////////////////////////
// - 1.27.2010, Update, Dayle Flowers(Xienen)
//   Created the file
/////////////////////////////////////////////////////////////////
#ifndef XMODEL_H_
#define XMODEL_H_

struct xFace
{
	int	m_iVertIndicies[3];
};

struct xMesh
{
	int			 m_iFaceCount;
	int			 m_iVertCount;
	int			 m_iTexVertCount;
	xTexture	*m_pTexture;
	char		 m_strName[256];
	xFace		*m_pFaces;
	xVector		*m_pVertices;
	xVector		*m_pNormals;
	xVector2D	*m_pTexVertices;
};

class xModel
{
public:
	virtual	void Init(const char* strName, int iAnimationCount, xSceneGraph *pSceneGraph, float fRenderDepth) {}
			void PreUpdate(DWORD dwTime) { pfnPreUpdate(this, dwTime); }
			void Update(double dTime) { pfnUpdate(this, dTime); }
	virtual	void Delete() {}

			void SetTranslation(float fX, float fY, float fZ) { m_vecTranslation.x = fX; m_vecTranslation.y = fY; m_vecTranslation.z = fZ; }
	virtual	void SetRotation(float fX, float fY, float fZ) {}

	xVector m_vecTranslation;

protected:
	void (*pfnPreUpdate)(xModel* pThis, DWORD dwTime);
	void (*pfnUpdate)(xModel* pThis, double dTime);

	xSceneGraph	*m_pSceneGraph;
};

#endif
