/////////////////////////////////////////////////////////////////
// Name: xOptions.h
/////////////////////////////////////////////////////////////////
// Description:
// - Holds all option settings for the game.
/////////////////////////////////////////////////////////////////
// - 7.15.2004, Update, Dayle Flowers(Xienen)
//   File Created
/////////////////////////////////////////////////////////////////
// - 8.07.2004, Update, Alayton Norgard (Adept)
//   Key added for dropping a piece
/////////////////////////////////////////////////////////////////
#ifndef XOPTIONS_H_
#define XOPTIONS_H_

enum GameButtons
{
	KEY_RED = 0,
	KEY_BLUE,
	KEY_YELLOW,
	KEY_ROTATEPIECE,
	KEY_ROTATEBOARDCLOCKWISE,
	KEY_ROTATEBOARDCOUNTERCLOCKWISE,
	KEY_DROPPIECE,
	KEY_CLEAR,
	KEY_TYPEMESSAGE,
	KEY_PAUSE,
	KEY_GOTOMENU,
	MAX_GAME_BUTTONS
};

enum GameAltButtons
{
	KEY_RED_ALT = MAX_GAME_BUTTONS,
	KEY_BLUE_ALT,
	KEY_YELLOW_ALT,
	KEY_ROTATEPIECE_ALT,
	KEY_ROTATEBOARDCLOCKWISE_ALT,
	KEY_ROTATEBOARDCOUNTERCLOCKWISE_ALT,
	KEY_DROPPIECE_ALT,
	KEY_CLEAR_ALT,
	KEY_TYPEMESSAGE_ALT,
	KEY_PAUSE_ALT,
	KEY_GOTOMENU_ALT,
	MAX_GAME_ALT_BUTTONS
};

extern class xPlayerProfile;

class xOptions
{
public:
	xOptions()
	{
		m_bCharacterOutlines = 1;
		m_bLimitedParticles = 0;
		m_fMusicVolume = 1.0f;
		m_fSoundVolume = 1.0f;
		m_fVoiceOverVolume = 0.7f;
	}

	int LoadOptions(const char *strOptionsFile);
	int SaveOptions(const char *strOptionsFile);

	//NOTE: strProfileName must be 29 characters or less(prolly best to limit it to 16, 20, or 25)
	bool LoadProfileByHash(char *strHash, xPlayerProfile *pPlayer);
	int  LoadPlayerProfile(char *strProfileName, xPlayerProfile *pPlayer);
	int  SavePlayerProfile(xPlayerProfile *pPlayer);

	xList<xPlayerProfile>* GetAllAvailableProfiles();

	bool	 m_bFirstRun;
	int		 m_iScreenWidth;
	int		 m_iScreenHeight;
	bool	 m_bFullScreen;
	bool	 m_bCharacterOutlines;
	bool	 m_bLimitedParticles;
	float	 m_fMusicVolume;
	float	 m_fSoundVolume;
	float	 m_fVoiceOverVolume;
	xButton *m_pButtons[MAX_GAME_ALT_BUTTONS];

protected:
	int		m_iResult;
	xParser m_xParser;

private:
	//NOTE: strProfileName must be 29 characters or less(prolly best to limit it to 16, 20, or 25)
	void CreateProfileHash(char *strProfileName, char strOutHash[24]);
};

#endif