#ifndef _XPAPER_H_
#define _XPAPER_H_

#include "xPlatform.h"
#include "xAudio.h"
#include "xFileIO.h"
#include "xInput.h"
#include "xNetworkClient.h"
#include "xEngineSettings.h"

enum xNetMode
{
	PE_NETMODE_SINGLEPLAYER,
	PE_NETMODE_LISTENSERVER,
	PE_NETMODE_CLIENT
};

class xPaper
{
public:
	int  Init(HWND *hWnd, HINSTANCE *hInstance, void *winproc);
	void PreUpdate();
	void Update();
	void Shutdown();

	void UpdateScreenOffsetsAndRatios();
	void ChangeScreenResolution(int iScreenWidth, int iScreenHeight, bool bFullscreen);
	void ValidateCDKey(char *strCDKey);

	bool		 m_bChangingScreenResolution;
	xNetMode	 m_iNetMode;
	bool		 m_bRunning;
	bool		 m_bHasFocus;
	bool		 m_bMinimized;
	bool		 m_bDragged;
	HWND		 m_hWnd;
	HINSTANCE	 m_hInst;
	void		*m_pfWinProc;
	int			 m_iResult;
	int			 m_iCurrentFPS;
	int			 m_iFPS;
	float		 m_fScreenRatioX;
	float		 m_fScreenRatioY;
	int			 m_iScreenOffsetX;
	int			 m_iScreenOffsetY;
	char		 m_strExitCommand[64];
	bool		 m_bOutlineModels;
	bool		 m_bLimitParticles;
	float		 m_fVolume;

	DWORD m_dwCurrentTime;
	DWORD m_dwLastTime;

	xEngineSettings			m_xEngineSettings;
	class xPlatform			m_xPlatform;
	class xAudio			m_xAudio;
	class xInput			m_xInput;
	class xNetworkClient	m_xNetwork;
	class xNetworkClient	m_xHTTPNetwork;
	class xNetworkClient	m_xPingNetwork;
	class xNetworkClient	m_xFTPNetwork;
	class xNetworkClient	m_xFTPFileTransfer;
};

#endif