/////////////////////////////////////////////////////////////////
// Name: xRenderable2DBox.h
/////////////////////////////////////////////////////////////////
// Description:
// - A renderable box(outline)
/////////////////////////////////////////////////////////////////
// - 30.12.2010, Created, Dayle Flowers (Xienen)
//   Created
/////////////////////////////////////////////////////////////////
#ifndef XRENDERABLE2DBOX_H_
#define XRENDERABLE2DBOX_H_

#include "xEngineDefines.h"
#include "xRenderable2D.h"

struct xRenderable2DBox
{
	xRenderable2D	m_xRenderable2D;
	float			m_fLineWidth;
};

FORCE_INLINE void xRenderable2DBoxInit(xRenderable2DBox *pThis)
{
	xRenderable2DInit(&pThis->m_xRenderable2D);
	
	pThis->m_fLineWidth = 1.0;
}

FORCE_INLINE void xRenderable2DBoxSetBlendMode(xRenderable2DBox *pThis, int iBlendMode) { xRenderable2DSetBlendMode(&pThis->m_xRenderable2D, iBlendMode); }
FORCE_INLINE void xRenderable2DBoxSetPosition(xRenderable2DBox *pThis, float fX, float fY) { xRenderable2DSetPosition(&pThis->m_xRenderable2D, fX, fY); }
FORCE_INLINE void xRenderable2DBoxSetSize(xRenderable2DBox *pThis, float fWidth, float fHeight) { xRenderable2DSetSize(&pThis->m_xRenderable2D, fWidth, fHeight); }
FORCE_INLINE void xRenderable2DBoxSetColor(xRenderable2DBox *pThis, const xColor *pSource) { xRenderable2DSetColor(&pThis->m_xRenderable2D, pSource); }
FORCE_INLINE void xRenderable2DBoxSetAlpha(xRenderable2DBox *pThis, float fAlpha) { xRenderable2DSetAlpha(&pThis->m_xRenderable2D, fAlpha); }
FORCE_INLINE void xRenderable2DBoxSetLineWidth(xRenderable2DBox *pThis, float fLineWidth) { pThis->m_fLineWidth = fLineWidth; if(pThis->m_xRenderable2D.m_pVertData) pThis->m_xRenderable2D.m_pVertData->m_pTextureData->m_fLineWidth = fLineWidth; }

FORCE_INLINE void xRenderable2DBoxUpdateColor(xRenderable2DBox *pThis, const xColor *pSource) { xRenderable2DUpdateColor(&pThis->m_xRenderable2D, pSource); }
FORCE_INLINE void xRenderable2DBoxUpdateVisibility(xRenderable2DBox *pThis, bool bVisible) { xRenderable2DUpdateVisibility(&pThis->m_xRenderable2D, bVisible); }

void xRenderable2DBoxUpdate(xRenderable2DBox *pThis);

#endif