/////////////////////////////////////////////////////////////////
// Name: xRenderable2DQuad.h
/////////////////////////////////////////////////////////////////
// Description:
// - A renderable line
/////////////////////////////////////////////////////////////////
// - 23.8.2010, Created, Dayle Flowers (Xienen)
//   Created this as base class for xObject2D and xGUIObject to
//   allow for generic Animation system(xKeyFrame)
// - 14.12.2010, Updated, Dayle Flowers (Xienen)
//   Switched to C-style data structures
/////////////////////////////////////////////////////////////////
#ifndef XRENDERABLE2DLINE_H_
#define XRENDERABLE2DLINE_H_

#include "xEngineDefines.h"
#include "xRenderable2D.h"

struct xRenderable2DLine
{
	xRenderable2D	m_xRenderable2D;
	float			m_fLineWidth;
};

FORCE_INLINE void xRenderable2DLineInit(xRenderable2DLine *pThis)
{
	xRenderable2DInit(&pThis->m_xRenderable2D);
	
	pThis->m_fLineWidth = 1.0;
}

FORCE_INLINE void xRenderable2DLineSetBlendMode(xRenderable2DLine *pThis, int iBlendMode) { xRenderable2DSetBlendMode(&pThis->m_xRenderable2D, iBlendMode); }
FORCE_INLINE void xRenderable2DLineSetStartPoint(xRenderable2DLine *pThis, float fX, float fY) { xRenderable2DSetPosition(&pThis->m_xRenderable2D, fX, fY); }
FORCE_INLINE void xRenderable2DLineSetEndPoint(xRenderable2DLine *pThis, float fX, float fY) { xRenderable2DSetSize(&pThis->m_xRenderable2D, fX - pThis->m_xRenderable2D.m_fX, fY - pThis->m_xRenderable2D.m_fY); }
FORCE_INLINE void xRenderable2DLineSetColor(xRenderable2DLine *pThis, const xColor *pSource) { xRenderable2DSetColor(&pThis->m_xRenderable2D, pSource); }
FORCE_INLINE void xRenderable2DLineSetAlpha(xRenderable2DLine *pThis, float fAlpha) { xRenderable2DSetAlpha(&pThis->m_xRenderable2D, fAlpha); }
FORCE_INLINE void xRenderable2DLineSetWidth(xRenderable2DLine *pThis, float fLineWidth) { pThis->m_fLineWidth = fLineWidth; }

FORCE_INLINE void xRenderable2DLineUpdateColor(xRenderable2DLine *pThis, const xColor *pSource) { xRenderable2DUpdateColor(&pThis->m_xRenderable2D, pSource); }
FORCE_INLINE void xRenderable2DLineUpdateDepth(xRenderable2DLine *pThis, xSceneGraph *pSceneGraph, float fDepth) { xRenderable2DUpdateDepth(&pThis->m_xRenderable2D, pSceneGraph, fDepth); }
FORCE_INLINE void xRenderable2DLineUpdateVisibility(xRenderable2DLine *pThis, bool bVisible) { xRenderable2DUpdateVisibility(&pThis->m_xRenderable2D, bVisible); }

void xRenderable2DLineUpdate(xRenderable2DLine *pThis);

#endif