/////////////////////////////////////////////////////////////////
// Name: xTexture.h
/////////////////////////////////////////////////////////////////
// Description:
// - A texture loaded into OpenGL
/////////////////////////////////////////////////////////////////
// - 7.10.2004, Update, Dayle Flowers(Xienen)
//   Moved GetWidth and GetHeight from xDX9Texture.h
//
// - 7.6.2004, Update, Arto Ruotsalainen(Arex)
//   Comment stuff added to begin of the file.
//   Add new updates/fixes above this, so the old updates
//   will be at the bottom.
/////////////////////////////////////////////////////////////////
#ifndef XTEXTURE_H_
#define XTEXTURE_H_

struct xTexture
{
	GLuint	m_uiID;
	int		m_iWidth;	
	int		m_iHeight;
	int		m_iDataWidth;
	int		m_iDataHeight;
	bool	m_bHasAlpha;

	// Texture Pool Helpers
	char		 m_strObjectPath[256];
	int			 m_iReferenceCount;
	bool		 m_bLoaded;
	xTexture	*m_pNext;
	xTexture	*m_pPrev;
};

FORCE_INLINE void xTextureInit(xTexture *pThis)
{
	pThis->m_uiID			= 0;
	pThis->m_iWidth			= 0;
	pThis->m_iHeight		= 0;
	pThis->m_iDataWidth		= 0;
	pThis->m_iDataHeight	= 0;
	pThis->m_bHasAlpha		= 0;

	// Texture Pool Helpers
	pThis->m_strObjectPath[0]	= '\0';
	pThis->m_iReferenceCount	= 0;
	pThis->m_bLoaded			= 0;
	pThis->m_pNext				= 0;
	pThis->m_pPrev				= 0;
}

int xTextureCreateTexture(xTexture *pThis, xFileIO *pTextureFile, int iWidth, int iHeight);
int xTextureSkipTexture(xFileIO *pTextureFile, int iWidth, int iHeight);

#endif